Package: ballgown
Maintainer: Jack Fu <jmfu@jhsph.edu>
Authors@R: c(person("Jack", "Fu", role=c("aut"), email="jmfu@jhsph.edu"),
    person(c("Alyssa", "C."), "Frazee", role=c("aut", "cre"),
    email="alyssa.frazee@gmail.com"), person("Leonardo", "Collado-Torres",
    role=c("aut"), email="lcollado@jhu.edu"), person(c("Andrew", "E."),
    "Jaffe", role=c("aut")), person(c("Jeffrey", "T."), "Leek", role=c("aut",
    "ths"), email="jtleek@gmail.com"))
Version: 2.38.0
License: Artistic-2.0
Title: Flexible, isoform-level differential expression analysis
Description: Tools for statistical analysis of assembled transcriptomes,
    including flexible differential expression analysis, visualization of
    transcript structures, and matching of assembled transcripts to annotation.
Depends: R (>= 3.5.0), methods
Imports: GenomicRanges (>= 1.17.25), IRanges (>= 1.99.22), S4Vectors
        (>= 0.9.39), RColorBrewer, splines, sva, limma, rtracklayer (>=
        1.29.25), Biobase (>= 2.25.0), GenomeInfoDb
Suggests: testthat, knitr, markdown
VignetteBuilder: knitr
BugReports: https://github.com/alyssafrazee/ballgown/issues
biocViews: ImmunoOncology, RNASeq, StatisticalMethod, Preprocessing,
        DifferentialExpression
RoxygenNote: 7.1.1
git_url: https://git.bioconductor.org/packages/ballgown
git_branch: RELEASE_3_20
git_last_commit: ec0ed55
git_last_commit_date: 2024-10-29
Repository: Bioconductor 3.20
Date/Publication: 2024-10-29
NeedsCompilation: no
Packaged: 2024-10-29 23:32:08 UTC; biocbuild
Author: Jack Fu [aut],
  Alyssa C. Frazee [aut, cre],
  Leonardo Collado-Torres [aut],
  Andrew E. Jaffe [aut],
  Jeffrey T. Leek [aut, ths]

#' get the last element
#'
#' @param x anything you can call \code{tail} on (vector, data frame, etc.)
#'
#' @return the last element of \code{x}
#'
#' @details this function is made of several thousand lines of complex code,
#'    so be sure to read it carefully.
#'
#' @author Alyssa Frazee
#'
#' @export
#' @examples
#' last(c('h', 'e', 'l', 'l', 'o'))

last = function(x) return(tail(x, n=1))

match.data.frame = function(x1, x2, ...){
     match(do.call("paste", c(x1, sep = "\r")),
           do.call("paste", c(x2, sep = "\r")), ...)
}

#' @title load RSEM data into a ballgown object
#'
#' @description Loads results of rsem-calculate-expression into a ballgown
#'   object for easy visualization, processing, and statistical testing
#' @param dir output directory containing RSEM output for all samples (i.e. for
#'   each run of rsem-calculate-expression)
#' @param samples vector of sample names (i.e., of the \code{sample_name}
#'   arguments used in each RSEM run)
#' @param gtf path to GTF file of genes/transcripts used in your RSEM reference.
#'   (where the reference location was denoted by the \code{reference_name} 
#'   argument used in rsem-calculate-expression). RSEM references can be created
#'   with or without a GTF file, but currently the ballgown reader requires the 
#'   GTF file.
#' @param UCSC set to TRUE if \code{gtf} comes from UCSC: quotes will be
#'   stripped from transcript identifiers if so.
#' @param tfield What keyword identifies transcripts in the "attributes" field
#'   of \code{gtf}? Default \code{'transcript_id'}. 
#' @param attrsep How are attributes separated in the "attributes" field of
#'   \code{gtf}? Default \code{'; '} (semicolon-space). 
#' @param bamout set to \code{'genome'} if \code{--output-genome-bam} was used
#'   when running rsem-calculate-expression; set to \code{'none'} if 
#'   \code{--no-bam-output} was used when running rsem-calculate-expression; 
#'   otherwise use the default (\code{'transcript'}). 
#' @param pData data frame of phenotype data, with rows corresponding to
#'   \code{samples}. The first column of \code{pData} must be equal to 
#'   \code{samples}, and rows must be in the same order as \code{samples}.
#' @param verbose If TRUE (as by default), status messages are printed during
#'   data loading.
#' @param meas character vector containing either "all" or one of "FPKM" or 
#'   "TPM". The resulting ballgown object will only contain the specified
#'   expression measurement for the transcripts. "all" 
#'   creates the full object.
#' @param zipped set to TRUE if all RSEM results files have been gzipped (end)
#'   in ".gz").
#' @export
#' @seealso \code{\link{ballgown}} for reading Cufflinks/Tablemaker output
#' @return a ballgown object with the specified expression measurements and
#'   structure specified by GTF.
#' @examples 
#' dataDir = system.file('extdata', package='ballgown')
#' gtf = file.path(dataDir, 'hg19_genes_small.gtf.gz')
#' rsemobj = ballgownrsem(dir=dataDir, samples=c('tiny', 'tiny2'), gtf=gtf,
#'     bamout='none', zipped=TRUE)
#' rsemobj
#'
#' @details Currently exon- and intron-level measurements are not available for
#'   RSEM-generated ballgown objects, but development is ongoing.
ballgownrsem = function(dir="", samples, gtf, UCSC=TRUE, tfield='transcript_id',
    attrsep='; ', bamout='transcript', pData=NULL, verbose=TRUE, meas='all',
    zipped=FALSE){

    bamout = match.arg(bamout, c('transcript', 'genome', 'none'))
    meas = match.arg(meas, c('all', 'TPM', 'FPKM'))
    if('all' %in% meas & length(meas) > 1){
        stop(.makepretty('when meas is "all", all types of measurements are
            included by default.'))
    }

    if(verbose){
        message(date())
    }

    # transcript/gene correspondence (t2g):
    f = paste0(dir, '/', samples[1], '.isoforms.results')
    if(zipped){
        f = paste0(f, '.gz')
    }
    t2g = read.table(f, header=TRUE, 
        colClasses=c('character', 'character', rep("NULL", 6)))
    names(t2g) = c('t_id', 'g_id')


    # exon GRanges setup / e2t:
    if(verbose){
        message(paste0(date(), ': reading annotation'))
    }
    tgtf = gffRead(gtf)
    tgtf$t_name = getAttributeField(tgtf$attributes, tfield, attrsep)
    if(UCSC){
        # strip off extra quotes
        tgtf$t_name = substr(tgtf$t_name, 2, nchar(tgtf$t_name)-1)
    }
    tgtf = tgtf[tgtf$feature == "exon",]
    if(verbose){
        message(paste0(date(), ': handling exons'))
    }
    estrand = as.character(tgtf$strand)
    estrand[estrand=="."] = "*"
    e_id = match.data.frame(tgtf[,c(1,4,5,7)], unique(tgtf[,c(1,4,5,7)])) 
    #^exons id'd by chr, start, end, strand
    t_id = tgtf$t_name
    e2t = data.frame(e_id, t_id)
    tgtf$e_id = e_id
    exons_unique = subset(tgtf, !duplicated(tgtf[,c(1,4,5,7)]))

    # exon data frame:
    exon = data.frame(e_id=exons_unique$e_id, chr=exons_unique$seqname,
        strand=exons_unique$strand, start=exons_unique$start, 
        end=exons_unique$end)
    exon = exon[order(exon$e_id),] #safety check

    # finish exon GRanges:
    tnamesex = split(as.character(e2t$t_id), e2t$e_id)
    #CAREFUL: this ^ is SUPER SLOW if e2t$t_id is left as a factor
    tnamesex_ord = as.character(tnamesex)[match(exon$e_id, names(tnamesex))]
    exongr = GRanges(seqnames=Rle(as.character(exon$chr)), 
        ranges=IRanges(start=exon$start, end=exon$end), 
        strand=Rle(exon$strand), 
        id=exon$e_id, transcripts = tnamesex_ord)

    # transcript GRangesList
    if(verbose){
        message(paste0(date(), ': handling introns'))
    }

    mm = match(e2t$e_id, mcols(exongr)$id)
    if(any(is.na(mm))){
        warning(paste('the following exon(s) did not appear in the data:',
        paste(e2t$e_id[which(is.na(mm))], collapse=", ")))
    }
    tgrl = split(exongr[mm[!is.na(mm)]], as.character(e2t$t_id)[!is.na(mm)])

    # intron GRanges setup:
    unltrans = unlist(tgrl)
    transcriptIDs = rep(names(tgrl), times=elementNROWS(tgrl))
    notLast = rev(duplicated(rev(transcriptIDs)))
    introngr = GRanges(seqnames=seqnames(unltrans)[notLast], 
        ranges=IRanges(start=end(unltrans)[notLast]+1, 
            end=start(unltrans)[which(notLast)+1]-1), 
        strand=strand(unltrans)[notLast])
    # same matchymatch trick to identify introns:
    idf = as.data.frame(introngr)
    i_id = match.data.frame(idf, unique(idf))
    mcols(introngr)$id = i_id

    # i2t
    i2t = data.frame(i_id, t_id=transcriptIDs[notLast])

    # finish intron GRanges:
    tnamesin = split(as.character(i2t$t_id), i2t$i_id) 
    mcols(introngr)$transcripts = as.character(tnamesin)[match(i_id, 
        names(tnamesin))]
    introngr = unique(introngr)

    # intron data frame:
    dftmp = IRanges::as.data.frame(introngr)
    stopifnot(all(names(dftmp) == 
        c('seqnames', 'start', 'end', 'width', 'strand', 'id', 'transcripts')))
    intron = data.frame(i_id=dftmp$id, chr=dftmp$seqnames, strand=dftmp$strand, 
        start=dftmp$start, end=dftmp$end)
    intron = intron[order(intron$i_id),] #safety check

    # transcript data frame
    if(verbose){
        message(paste0(date(), ': handling transcripts'))
    }
    isofiles = paste0(dir, '/', samples, '.isoforms.results')
    if(zipped){
        isofiles = paste0(isofiles, '.gz')
    }
    isodata = lapply(isofiles, function(x){
        read.table(x, header=TRUE)
    })
    gene = isodata[[1]]$gene_id[match(names(tgrl), isodata[[1]]$transcript_id)] 
    trans = data.frame(t_id=names(tgrl), 
        chr=unlist(runValue(seqnames(tgrl))),
        strand=unlist(runValue(strand(tgrl))),
        start=sapply(start(tgrl), min), end=sapply(end(tgrl), max),
        t_name=names(tgrl), num_exons=elementNROWS(tgrl),
        length=sapply(width(tgrl), sum), gene_id=gene, gene_name=gene)

    for(i in seq_along(isodata)){
        data_order = match(names(tgrl), isodata[[i]]$transcript_id)
        if(meas == 'all' | meas == 'TPM'){
            trans[,paste('TPM', samples[i],  sep='.')] = 
                isodata[[i]]$TPM[data_order]
        }
        if(meas == 'all' | meas == 'FPKM'){
            trans[,paste('FPKM', samples[i], sep='.')] = 
                isodata[[i]]$FPKM[data_order]
        }
    }

    # handle pData
    stopifnot(is.null(pData) | class(pData) == 'data.frame')
    if(verbose){
        message(paste0(date(), ': handling pData'))
    }

    if(!is.null(pData)){
        if(!all(pData[,1] == samples)){
            msg = 'Rows of pData did not seem to be in the same order as the
                columns of the expression data. Attempting to rearrange
                pData...'
            warning(.makepretty(msg))
            tmp = try(pData <- pData[,match(samples, pData[,1])], 
                silent=TRUE)
            if(class(tmp) == "try-error"){
                msg = 'first column of pData does not match the names of the
                    folders containing the ballgown data.'
                stop(.makepretty(msg))
            }else{
                message('successfully rearranged!')
            }
        }
    }

    # handle bamfiles
    if(bamout == 'none'){
        bamfiles=NULL
    }else{
        bamfiles = paste0(dir, '/', samples, '.', bamout, '.bam')
    }

    # handle gexpr (get it directly with RSEM)
    genefiles = paste0(dir, '/', samples, '.genes.results')
    if(zipped){
        genefiles = paste0(genefiles, '.gz')
    }
    genedata = lapply(genefiles, function(x){
        read.table(x, header=TRUE)
    })
    g = data.frame(gene_id=sort(genedata[[1]]$gene_id))
    for(i in seq_along(genedata)){
        data_order = match(g$gene_id, genedata[[i]]$gene_id)
        if(meas == 'all' | meas == 'TPM'){
            g[,paste('TPM', samples[i],  sep='.')] = 
                genedata[[i]]$TPM[data_order]
        }
        if(meas == 'all' | meas == 'FPKM'){
            g[,paste('FPKM', samples[i], sep='.')] = 
                genedata[[i]]$FPKM[data_order]
        }
    }

    gm = as.matrix(g[,-1])
    rownames(gm) = as.character(g$gene_id)
    colnames(gm) = names(g)[-1]
    rm(g)

    result = new("ballgown", 
        expr=list(intron=intron, exon=exon, trans=trans, gm=gm), 
        indexes=list(e2t=e2t, i2t=i2t, t2g=t2g, bamfiles=bamfiles, pData=pData),
        structure=list(intron=introngr, exon=exongr, trans=tgrl), 
        dirs=paste0(normalizePath(dir), '/', samples), 
        mergedDate=date(), meas=meas, RSEM=TRUE)

    if(verbose) message(paste0(date(), ': done!'))
    return(result)
}

#' cluster assembled transcripts and plot the results
#' 
#' This is an experimental, first-pass function that clusters assembled 
#' transcripts based on their overlap percentage, then plots and colors the 
#' transcript clusters.
#'
#' @param gene string, name of gene whose transcripts should be clustered 
#'   (e.g., "XLOC_000001")
#' @param gown object of class \code{ballgown} being used for analysis
#' @param method clustering method to use.  Currently can choose from 
#'   hierarchical clustering (\code{hclust}) or K-means (\code{kmeans}).  More 
#'   methods are in development.
#' @param k number of transcripts clusters to use.  By default, \code{k} is 
#'   \code{NULL} and thus is chosen using a rule of thumb, but providing
#'   \code{k} overrides those rules of thumb.
#' @param choosek if \code{k} is not provided, how should the number of clusters
#'   be chosen?  Must be one of "var90" (choose a \code{k} that explains 90 
#'   percent of the observed variation) or "thumb" (\code{k} is set to be 
#'   approximately \code{sqrt(n)}, where n is the total number of transcripts 
#'   for \code{gene})
#' @param returncluster if TRUE (as it is by default), return the results of the
#'   call to \code{clusterTrancsripts} so the data is available for later use.  
#'   Nothing is returned if FALSE.
#' @param labelTranscripts if TRUE (as it is by default), print transcript IDs 
#'   on the y-axis
#' @param ... other arguments to pass to plotTranscripts
#' 
#' @return if \code{returncluster} is TRUE, the transcript clusters are returned
#'   as described in \code{\link{clusterTranscripts}}. A plot of the transcript 
#'   clusters is also produced, in the style of \code{\link{plotTranscripts}}.
#' 
#' @seealso \code{\link{clusterTranscripts}}, \code{\link{plotTranscripts}}
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' @examples \donttest{
#' data(bg)
#' plotLatentTranscripts('XLOC_000454', bg, method='kmeans', k=2)
#' }
plotLatentTranscripts = function(gene, gown, method=c("hclust", "kmeans"), 
    k=NULL, choosek=c("var90", "thumb"), returncluster=TRUE, 
    labelTranscripts=TRUE, ...){

    ## check validity:
    method = match.arg(method)
    if(is.null(k)){
        choosek = match.arg(choosek)
        if(choosek == 'var90' & method != 'kmeans'){
            stop("need to use method=\"kmeans\" when choosek is \"var90\"")
        }
    }

    ## do the clustering
    if(!is.null(k)){
        cl = clusterTranscripts(gene=gene, gown=gown, method=method, k=k)
    } else if(choosek=="thumb"){
        ntranscripts = sum(texpr(gown, 'all')$gene_id == gene)
        k = ceiling(sqrt(ntranscripts/2))
        cl = clusterTranscripts(gene=gene, gown=gown, method=method, k=k)
    } else if(choosek == "var90"){
        ntranscripts = sum(texpr(gown, 'all')$gene_id == gene)
        for(i in 1:(ntranscripts-1)){
            cl = clusterTranscripts(gene=gene, gown=gown, method="kmeans", k=i)
            if(cl$pctvar>=0.9) break
        }
        if(i==ntranscripts-1 & cl$pctvar < 0.9){
            # either k=n-1 or nothing explained 90% of variation:
            plotTranscripts(gene=gene, gown=gown, colorby="none")
            warning(.makepretty("k = n-1 did not explain 90% of variation. Try
                no clustering, or specifying k."))
            return(NULL) #this function is now done.    
        }
    }
    
    ## plot:
    numcolors = length(unique(cl$clusters$cluster))
    cols = suppressWarnings(brewer.pal(numcolors, 'Dark2')) 
    #^have 2-color graph w/o warning
    sorted_clusters = cl$clusters[order(cl$clusters$cluster),]
    pTitle = paste0(gene, ": transcripts clustered with ", method, 
        ", k=", numcolors)
    plotTranscripts(gene, gown, legend=FALSE, samples=sampleNames(gown)[1], 
        main=pTitle, customCol=cols[sorted_clusters$cluster], 
        customOrder=sorted_clusters$t_id, labelTranscripts=labelTranscripts, 
        ...)

    if(returncluster) return(cl) 
}

context('test plotting functions')

bg = ballgown(dataDir=system.file('extdata', package='ballgown'),
    samplePattern='sample', verbose=FALSE)
pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))

pdf(file=NULL) # don't print plots to screen while testing

test_that('plotTranscripts does not throw errors', {
    # multi-transcript gene:
    expect_that(plotTranscripts('XLOC_000454', bg), not(throws_error()))
    expect_that(plotTranscripts('XLOC_000454', bg, samples='sample06'),
        not(throws_error()))
    expect_that(plotTranscripts('XLOC_000454', bg,
        samples=c('sample06', 'sample08')), not(throws_error()))
    expect_that(plotTranscripts('XLOC_000454', bg, colorby='exon', meas='cov'),
        not(throws_error()))
    expect_that(plotTranscripts('XLOC_000454', bg, colorby='exon'),
        throws_error())
    expect_that(plotTranscripts('XLOC_000454', bg, colorby='transcript',
        customCol=c('red', 'blue', 'green'), legend=FALSE),
    not(throws_error()))

    # single-transcript gene:
    expect_that(plotTranscripts('XLOC_000010', bg), not(throws_error()))
})

# test_that('plotMeans does not throw errors', {
#     expect_that(plotMeans('XLOC_000454', bg, groupvar='group'),
#         not(throws_error()))
#     expect_that(plotMeans('XLOC_000454', bg, groupvar='group'),
#         not(throws_error()))
#     expect_that(plotMeans('XLOC_000454', bg, groupvar='group', groupname=0),
#         not(throws_error()))
#     expect_that(plotMeans('XLOC_000454', bg, groupvar='group', overall=TRUE),
#         gives_warning())
#     expect_that(plotMeans('XLOC_000454', bg, groupvar='group', overall=FALSE),
#         not(throws_error()))
#     expect_that(plotMeans('XLOC_000454', bg, groupvar='group', colorby='exon',
#         meas='cov'), not(throws_error()))
# })

test_that('plotLatentTranscripts does not throw errors', {
    expect_that(plotLatentTranscripts('XLOC_000454', bg, method='kmeans', k=2),
        not(throws_error()))
    expect_that(plotLatentTranscripts('XLOC_000454', bg, method='kmeans', k=8),
        throws_error())
    expect_that(plotLatentTranscripts('XLOC_000454', bg, method='kmeans',
        choosek='var90'), not(throws_error()))
    expect_that(plotLatentTranscripts('XLOC_000454', bg, method='hclust', k=2),
        not(throws_error()))
}) #this function is mostly clusterTranscripts anyway

dev.off()

## ----loadmethods, echo=FALSE, message=FALSE, warning=FALSE--------------------
library(methods)

## ----installme, eval=FALSE----------------------------------------------------
#  if (!requireNamespace("BiocManager", quietly=TRUE))
#      install.packages("BiocManager")
#  BiocManager::install("ballgown")

## ----makebgobj, message=FALSE-------------------------------------------------
library(ballgown)
data_directory = system.file('extdata', package='ballgown') # automatically finds ballgown's installation directory
# examine data_directory:
data_directory

# make the ballgown object:
bg = ballgown(dataDir=data_directory, samplePattern='sample', meas='all')
bg

## ----struct-------------------------------------------------------------------
structure(bg)$exon
structure(bg)$intron
structure(bg)$trans

## ----getexpr------------------------------------------------------------------
transcript_fpkm = texpr(bg, 'FPKM')
transcript_cov = texpr(bg, 'cov')
whole_tx_table = texpr(bg, 'all')
exon_mcov = eexpr(bg, 'mcov')
junction_rcount = iexpr(bg)
whole_intron_table = iexpr(bg, 'all')
gene_expression = gexpr(bg)

## ----pData--------------------------------------------------------------------
pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))

## ----indexex------------------------------------------------------------------
exon_transcript_table = indexes(bg)$e2t
transcript_gene_table = indexes(bg)$t2g
head(transcript_gene_table)
phenotype_table = pData(bg)

## ----dirs---------------------------------------------------------------------
head(bg@dirs)

## ----mergedDate---------------------------------------------------------------
bg@mergedDate

## ----meas---------------------------------------------------------------------
bg@meas

## ----plotTranscripts, fig.height=8, fig.width=8, fig.cap=""-------------------
plotTranscripts(gene='XLOC_000454', gown=bg, samples='sample12', 
    meas='FPKM', colorby='transcript', 
    main='transcripts from gene XLOC_000454: sample 12, FPKM')

## ----plotTranscripts2, fig.height=10, fig.width=10, fig.cap=""----------------
plotTranscripts('XLOC_000454', bg, 
    samples=c('sample01', 'sample06', 'sample12', 'sample19'), 
    meas='FPKM', colorby='transcript')

## ----plotMeans, fig.height=5, fig.width=10, fig.cap=""------------------------
plotMeans('XLOC_000454', bg, groupvar='group', meas='FPKM', colorby='transcript')

## ----stattest-----------------------------------------------------------------
stat_results = stattest(bg, feature='transcript', meas='FPKM', covariate='group')
head(stat_results)

## ----stattest_time------------------------------------------------------------
pData(bg) = data.frame(pData(bg), time=rep(1:10, 2)) #dummy time covariate
timecourse_results = stattest(bg, feature='transcript', meas='FPKM', covariate='time', timecourse=TRUE)

## ----stattest_adjust----------------------------------------------------------
group_adj_timecourse_results = stattest(bg, feature='transcript', meas='FPKM', covariate='time', 
    timecourse=TRUE, adjustvars='group')

## ----customMod----------------------------------------------------------------
# create example data:
set.seed(43)
sex = sample(c('M','F'), size=nrow(pData(bg)), replace=TRUE)
age = sample(21:52, size=nrow(pData(bg)), replace=TRUE)

# create design matrices:
mod = model.matrix(~ sex + age + pData(bg)$group + pData(bg)$time)
mod0 = model.matrix(~ pData(bg)$group + pData(bg)$time)

# run differential expression tests:
adjusted_results = stattest(bg, feature='transcript', meas='FPKM', mod0=mod0, mod=mod)
head(adjusted_results)

## ----cluster------------------------------------------------------------------
clusterTranscripts(gene='XLOC_000454', gown=bg, k=2, method='kmeans')

## ----clusterviz, fig.height=8, fig.width=8, fig.cap=""------------------------
plotLatentTranscripts(gene='XLOC_000454', gown=bg, k=2, method='kmeans', returncluster=FALSE)

## ----collapse-----------------------------------------------------------------
agg = collapseTranscripts(gene='XLOC_000454', gown=bg, k=2, method='kmeans')
stattest(gowntable=agg$tab, pData=pData(bg), feature='transcript_cluster', 
    covariate='group', libadjust=FALSE)

## ----sessioninfo, results='markup'--------------------------------------------
sessionInfo()

#' @title Connect a transcript to its gene
#'
#' @description find the gene to which a transcript belongs
#' @param bg ballgown object
#' @param transcript transcript identifier
#' @param tid set to \code{TRUE} if \code{transcript} is a numeric transcript
#'   identifier (i.e., \code{t_id} in expression tables), or \code{FALSE} if
#'   \code{transcript} is a named identifie (e.g., \code{TCONS_000001} or
#'   similar.
#' @param gid if \code{FALSE}, return the gene *name* associated with
#'   \code{transcript} in \code{bg} instead of the gene *id*, which is returned
#'   by default. Take care to remember that not all ballgown objects include
#'   gene *name* information. (They do all include gene IDs).
#' @param warnme if \code{TRUE}, and if \code{gid} is \code{FALSE}, print a
#'   warning if no gene name is available for the transcript. This could either
#'   mean the transcript didn't overlap an annotated gene, or that no gene names
#'   were included when \code{bg} was created.
#' @export
#' @examples
#'   data(bg)
#'   tGene(bg, 10)
#'   tGene(bg, 'TCONS_00000010', tid=FALSE)
#'   tGene(bg, 10, gid=FALSE) #empty: no gene names included in bg.
#'

tGene = function(bg, transcript, tid=TRUE, gid=TRUE, warnme=TRUE){
    if(!(transcript %in% transcriptNames(bg)) &
        !(transcript %in% transcriptIDs(bg))){
        stop('transcript is not contained in ballgown object.')
    }

    expr_col_ind = ifelse(tid, which(colnames(texpr(bg,'all')) == 't_id'),
        which(colnames(texpr(bg,'all')) == 't_name'))
    i = which(texpr(bg, 'all')[,expr_col_ind] == transcript)

    if(gid){
        return(texpr(bg, 'all')$gene_id[i])
    }else{
        ret = texpr(bg, 'all')$gene_name[i]
        if(ret=="" & warnme){
            warning(.makepretty('No gene name available for this transcript.
                To return gene ID, set gid=TRUE.'))
        }
        return(ret)
    }
}

#' cluster a gene's transcripts and calculate cluster-level expression
#'
#' @param gene which gene's transcripts should be clustered
#' @param gown ballgown object
#' @param meas which transcript-level expression measurement to use 
#'   (\code{'cov'}, average per-base coverage, or \code{'FPKM'})
#' @param method which clustering method to use: \code{'hclust'} (hierarchical
#'   clustering) or \code{'kmeans'} (k-means clustering).
#' @param k how many clusters to use. 
#' 
#' @return list with two elements:
#' \itemize{
#'   \item \code{tab}, a cluster-by-sample table of expression measurements
#'     (\code{meas}, either cov or FPKM), where the expression measurement for 
#'     each cluster is the mean (for \code{'cov'}) or aggregate (for 
#'     \code{'FPKM'}, as in \code{\link{gexpr}}) expression measurement for all
#'     the transcripts in that cluster. This table can be used as the 
#'     \code{gowntable} argument to \code{\link{stattest}}, if differential
#'     expression results for transcript *clusters* are desired. 
#'   \item \code{cl} output from \code{\link{clusterTranscripts}} that was run 
#'     to produce \code{tab}, for reference. Cluster IDs in the \code{cluster} 
#'     component correspond to row names of \code{tab}
#' }
#' 
#' @seealso \code{\link{hclust}}, \code{\link{kmeans}}, 
#'    \code{\link{clusterTranscripts}}, \code{\link{plotLatentTranscripts}}
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' @examples 
#' data(bg)
#' collapseTranscripts(bg, gene='XLOC_000454', meas='FPKM', method='kmeans')
#' 
collapseTranscripts = function(gene, gown, meas='FPKM', 
    method=c('hclust', 'kmeans'), k=NULL){

    if(!gown@RSEM){
        meas = match.arg(meas, c('cov', 'FPKM'))
    }else{
        meas = match.arg(meas, c('FPKM', 'TPM'))
    }
    method = match.arg(method)
    if(is.null(k)){
        k = 'thumb'
    } else if(is.character(k)){
        k = match.arg('thumb', 'var90')
        if(k == 'var90' & method != 'kmeans'){
            stop(.makepretty('choosing k explaining 90% of variability is only
                available with kmeans clustering.'))
        }
    } else if(as.integer(k) != k){
        k = floor(k)
        warning('k must be an integer. Rounding down.')
    } else if(!is.numeric(k)){
        stop('k must be "var90", "thumb", or an integer (number of clusters)')
    }

    gown = subset(gown, paste0("gene_id == '", gene, '\''))
    ntranscripts = length(structure(gown)$trans)

    # cluster:
    if(k == 'thumb'){
        k = ceiling(sqrt(ntranscripts/2))
        cl = clusterTranscripts(gene=gene, gown=gown, method=method, k=k)
        message(paste('using k =', k, 'clusters'))
    } else if(k == "var90"){
        for(i in 1:(ntranscripts-1)){
            cl = clusterTranscripts(gene=gene, gown=gown, method="kmeans", k=i)
            if(cl$pctvar>=0.9) break
        }
        if(i==ntranscripts-1 & cl$pctvar < 0.9){
            # either k=n-1 or nothing explained 90% of variation:
            stop(.makepretty("k = n-1 did not explain 90% of variation. Try no
                clustering, or specifying k."))
        }
    } else {
        cl = clusterTranscripts(gene=gene, gown=gown, method=method, k=k)
    }

    clusterList = split(cl$clusters$t_id, cl$clusters$cluster)
    collapsed = lapply(clusterList, function(x){
        if(length(x) > 1){
            if(meas == 'cov'){
                colMeans(texpr(gown)[texpr(gown,'all')$t_id %in% x,])    
            } else {
                tstruct = structure(gown)$trans[names(structure(gown)$trans) 
                    %in% x]
                tlengths = sapply(width(tstruct), sum)
                clength = sum(width(reduce(unlist(tstruct))))
                totfrags = colSums(tlengths * texpr(gown)[texpr(gown,'all')$t_id
                    %in% x,])
                totfrags / clength
            }
        }else{
            texpr(gown)[texpr(gown,'all')$t_id == x,]
        }
    })

    tab = t(as.data.frame(collapsed))
    rownames(tab) = names(collapsed)
    return(list(tab=tab, cl=cl))
}

#' visualize transcript abundance by group
#'
#' @param gene name of gene whose transcripts will be plotted.  When using
#'   Cufflinks/Tablemaker output, usually of the form \code{"XLOC_######"}
#' @param gown ballgown object containing experimental and phenotype data
#' @param overall if \code{TRUE}, color features by the overall
#'   (experiment-wide) mean rather than a group-specific mean
#' @param groupvar string representing the name of the variable denoting which
#'   sample belongs to which group.  Can be \code{"none"} (if you want the
#'   study-wide mean), or must correspond to the name of a column of
#'   \code{pData(gown)}.  Usually a categorical variable.
#' @param groupname string representing which group's expression means you want
#'   to plot.  Can be \code{"none"} (if you want the study-wide mean),
#'   \code{"all"} (if you want a multipanel plot of each group's mean
#'   expression), or any of the levels of \code{groupvar}.
#' @param meas type of expression measurement to plot. One of "cov", "FPKM",
#'   "rcount", "ucount", "mrcount", or "mcov". Not all types are valid for all
#'   features. (See description of tablemaker output for more information).
#' @param colorby one of \code{"transcript"} or \code{"exon"}, indicating which
#'   feature's abundances should dictate plot coloring.
#' @param legend if \code{TRUE} (as it is by default), a color legend is drawn
#'   on top of the plot indicating the scale for feature abundances.
#' @param labelTranscripts if \code{TRUE}, transcript ids are labeled on the
#'   left side of the plot. Default \code{FALSE}.
#'
#' @return produces a plot of the transcript structure for the specified gene in
#'   the current graphics device, colored by study-wide or group-specific mean
#'   expression level.
#'
#' @seealso \code{\link{plotTranscripts}}
#
#' @author Alyssa Frazee
#'
#' @export
#' @examples \donttest{
#' data(bg)
#' plotMeans('XLOC_000454', bg, groupvar='group', meas='FPKM',
#'   colorby='transcript')
#' }

plotMeans = function(gene, gown, overall=FALSE, groupvar, groupname='all',
    meas=c('cov', 'FPKM', 'rcount', 'ucount', 'mrcount', 'mcov'),
    colorby=c('transcript', 'exon'), legend=TRUE, labelTranscripts=FALSE){

    meas = match.arg(meas)
    colorby = match.arg(colorby)

    if(!(meas %in% gown@meas | gown@meas=='all')){
        stop(paste('gown does not include', meas, 'measurements'))
    }

    if(colorby == "transcript" & !(meas %in% c("cov", "FPKM"))){
        stop("transcripts only have cov and FPKM measurements")
    }
    if(colorby == "exon" & meas=="FPKM"){
        stop("exons do not have FPKM measurements")
    }
    if(class(gown)!="ballgown") stop("gown must be a ballgown object")

    if(!overall & (groupvar=="none"|groupname=="none")){
        stop(.makepretty("to plot means for a specific group, please provide
            both the grouping variable name and the specific group name."))
    }
    if(groupname == "all" & overall){
        warning(.makepretty("Plotting the study-wide mean for each feature. To
            plot each group's mean separately, set overall=FALSE."))
    }
    if(groupname == "all" & groupvar == "none"){
        stop("to plot means for all groups, please provide groupvar (the name
            of the group variable)")
    }

    # some setup:
    ma = IRanges::as.data.frame(structure(gown)$trans)
    if(names(ma)[2] != 'group_name'){
        stop('IRanges::as.data.frame has changed. Please report as issue.')
    }

    thetranscripts = indexes(gown)$t2g$t_id[indexes(gown)$t2g$g_id==gene]
    gtrans = ma[ma$group_name %in% thetranscripts,]
    gtrans$tid = gtrans$group_name
    xax = seq(min(gtrans$start), max(gtrans$end), by=1)
    numtx = length(unique(thetranscripts))
    if(groupvar != "none"){
        pdatacol = which(names(pData(gown))==groupvar)
    }
    if(groupname == "all" & !overall){
        numplots = length(unique(pData(gown)[,pdatacol]))
        mf = c(floor(sqrt(numplots)), ceiling(sqrt(numplots)))
        plot_titles = sort(unique(as.factor(pData(gown)[,pdatacol])))
    }else{
        numplots = 1
        mf = c(1,1)
        if(overall){
            plot_titles = 'overall'
        }else{
            plot_titles = ifelse(groupname=="none", "mean across groups",
                groupname)
        }
    }
    if(overall){
        samples = list(sampleNames(gown))
    }else if(groupname == "all"){
        samples = split(sampleNames(gown), pData(gown)[,pdatacol])
    }else{
        samples = list(sampleNames(gown)[pData(gown)[,pdatacol]==groupname])
    }

    # plot base:
    westval = ifelse(labelTranscripts, 4, 2)
    par(mar=c(5, westval, 4, 2), mfrow = mf)
    ymax = ifelse(legend, numtx+2, numtx+1)

    # the for-loop only has >1 iteration if groupname == "all"
    for(p in 1:numplots){
        plot(xax, rep(0,length(xax)), ylim=c(0,ymax),
        type="n", xlab="genomic position",
        main=paste0(gene,": ",plot_titles[p]),
        yaxt = "n", ylab="")

        # calculate means
        if(colorby == "transcript"){
            # mean transcript-level expression measurement for this group
            t_id = texpr(gown, 'all')$t_id
            expr_matrix_i = which(t_id %in% gtrans$tid)
            smalldat = texpr(gown, meas)[expr_matrix_i,]
            datacols = which(sampleNames(gown) %in% samples[[p]])
            if(length(expr_matrix_i) > 1) {
                tmeans = rowMeans(smalldat[,datacols])
            } else {
                tmeans = mean(smalldat[datacols])
                names(tmeans) = texpr(gown, 'all')$t_id[expr_matrix_i]  # i has length 1
            }
        }

        if(colorby == "exon"){
            # mean exon-level expression measurement for this group
            e_id = eexpr(gown, 'all')$e_id
            smalldat = as.matrix(eexpr(gown, meas)[e_id %in% gtrans$id,])
            if(class(smalldat) != 'matrix'){
                smalldat = t(as.matrix(smalldat))
            }
            datacols = which(sampleNames(gown) %in% samples[[p]])
            emeans = rowMeans(smalldat[,datacols])
        }

        # make color scale:
        maxcol = quantile(smalldat, 0.99)
        colscale = seq(0, maxcol, length.out=200)

        # draw the transcripts
        for(tx in unique(gtrans$tid)){
            if(colorby == "transcript") {
                mycolor = closestColor(tmeans[which(names(tmeans)==tx)], colscale)
            }
            txind = which(unique(gtrans$tid)==tx)
            gtsub = gtrans[gtrans$tid==tx,]
            gtsub = gtsub[order(gtsub$start),]
            for(exind in 1:dim(gtsub)[1]){
                if(colorby == "exon"){ 
                    mycolor = closestColor(
                        emeans[which(names(emeans)==gtsub$id[exind])], colscale)
                }
                stopifnot(length(mycolor) > 0)
                polygon(
                    x=c(gtsub$start[exind], gtsub$start[exind], 
                        gtsub$end[exind], gtsub$end[exind]),
                    y=c(txind-0.4,txind+0.4,txind+0.4,txind-0.4), col=mycolor)
                if(exind!=dim(gtsub)[1]){
                    lines(c(gtsub$end[exind],gtsub$start[exind+1]), 
                        c(txind, txind), lty=2, col="gray60")
                }
            }
        }

        # draw the legend:
        if(legend){
            leglocs = seq(min(xax)+1, max(xax)-1, length=length(colscale)+1)
            for(i in 1:length(colscale)){
                polygon(x=c(leglocs[i], leglocs[i], leglocs[i+1], leglocs[i+1]),
                    y=c(ymax-0.3, ymax, ymax, ymax-0.3), border=NA, 
                    col=rev(heat.colors(length(colscale)))[i])
            }
            text(x=seq(min(xax)+1, max(xax)-1, length=20), y=rep(ymax+0.1, 20), 
                labels=round(colscale,2)[seq(1,length(colscale), length=20)], 
                cex=0.5)
            text(x=median(xax), y=ymax-0.5, labels=paste("mean expression, by",
                colorby), cex=0.5)
        }

        if(labelTranscripts){
            axis(side=2, at=c(1:numtx), labels=unique(gtrans$tid), 
                cex.axis=0.75, las=1)
        }
    }
}

#' The ballgown package for analysis of transcript assemblies
#'
#' @name ballgown-package
#' @aliases ballgownp
#' @docType package
#' @import GenomicRanges
#' @import IRanges
#' @import S4Vectors
#' @import RColorBrewer
#' @import splines
#' @importFrom sva f.pvalue
#' @importFrom rtracklayer import
#' @importFrom limma lmFit
#' @import methods
#' @description Super awesome transcript-level expression analysis
NULL

#' read in GTF/GFF file as a data frame
#'
#' @param gffFile name of GTF/GFF on disk
#' @param nrows number of rows to read in (default -1, which means read all 
#'    rows)
#' @param verbose if TRUE, print status info at beginning and end of file read.
#'    Default FALSE.
#' 
#' @return data frame representing the GTF/GFF file
#' 
#' @seealso \code{\link{getAttributeField}} to extract data from "attributes" 
#'  column; \url{http://useast.ensembl.org/info/website/upload/gff.html} for
#'   more information on the GTF/GFF file format.
#' 
#' @author Kasper Hansen
#' 
#' @export
#' @examples
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' annot = gffRead(gtfPath)
gffRead = function (gffFile, nrows = -1, verbose=FALSE) 
{
    if(verbose){
        cat("Reading ", gffFile, ": ", sep = "")    
    }
    gff = read.table(gffFile, sep = "\t", as.is = TRUE, quote = "", 
        header = FALSE, comment.char = "#", nrows = nrows, 
        colClasses = c("character", "character", "character", "integer", 
            "integer", "character", "character", "character", "character"))
    colnames(gff) = c("seqname", "source", "feature", "start", 
        "end", "score", "strand", "frame", "attributes")
    if(verbose){
        cat("found", nrow(gff), "rows with classes:", paste(sapply(gff, 
            class), collapse = ", "), "\n")
    }
    stopifnot(!any(is.na(gff$start)), !any(is.na(gff$end)))
    return(gff)
}

# source: https://stat.ethz.ch/pipermail/bioconductor/2008-October/024669.html

context('test annotation-related functions')

test_that('GenomicRanges is installed', {
    expect_that(suppressMessages(library(GenomicRanges)), not(throws_error()))
})

test_that('ballgown reader is not broken and data was installed properly', {
    suppressMessages(library(GenomicRanges))
    expect_that(ballgown(dataDir=system.file('extdata', package='ballgown'),
        samplePattern='sample', verbose=FALSE), not(throws_error()))
})

test_that('example annotation was installed properly', {
    expect_that(system.file('extdata', 'annot.gtf.gz', package='ballgown'), 
        not(equals("")))
})

## if these things fail, we should have gotten a more helpful message earlier:
bg = ballgown(dataDir=system.file('extdata', package='ballgown'), 
    samplePattern='sample', verbose=FALSE)
suppressMessages(library(GenomicRanges))
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')

test_that('gtf read function works', {
    expect_that(gffRead(gtfPath), not(throws_error()))
})

x = gffRead(gtfPath)

test_that('gtf read function gives the right answer', {    
    expect_that(ncol(x), equals(9))
    expect_that(nrow(x), equals(13732))
    expect_that(names(x), is_identical_to(c('seqname', 'source', 'feature',
        'start', 'end', 'score', 'strand', 'frame', 'attributes')))
    expect_that(x, is_a('data.frame'))
})

test_that('splitting attribute fields works', {
    expect_that(getAttributeField(x$attributes, 'transcript_id'), 
        not(throws_error()))
    expect_that(all(is.na(getAttributeField(x$seqname, 'transcript_id'))), 
        is_true())
    transcripts = getAttributeField(x$attributes, 'transcript_id')
    expect_that(transcripts, is_a('character'))
    expect_that(length(transcripts), equals(13732))
    expect_that(transcripts[192], equals('ENST00000444520'))
    expect_that(all(is.na(getAttributeField(x$attributes, 'transcript_id', 
        attrsep=','))), 
        is_true())
})


# test_that('reading gtf directly into GRanges and GRangesList works', {
#     expect_that(gffReadGR(gtfPath), not(throws_error()))
#     gr = gffReadGR(gtfPath)
#     expect_that(length(gr), equals(13732))
#     expect_that(gffReadGR(gtfPath, splitByTranscript=TRUE), not(throws_error()))
#     grl = gffReadGR(gtfPath, splitByTranscript=TRUE)
#     expect_that(length(grl), equals(910))
#     expect_that(names(grl), is_a('character'))
#     expect_that(sort(names(grl)), is_identical_to(
#         sort(unique(getAttributeField(x$attributes, 'transcript_id')))))
# })

grl = gffReadGR(gtfPath, splitByTranscript=TRUE)

test_that('pctOverlap function works', {
    expect_that(pctOverlap(structure(bg)$trans[[2]], grl[[369]]), 
        equals(0.7986441, tolerance=0.0001))
})

test_that('function for annotating assemblies works', {
    expect_that(annotate_assembly(assembled=structure(bg)$trans,
        grl), not(throws_error()))
    rel = annotate_assembly(assembled=structure(bg)$trans, grl)
    expect_that(nrow(rel), equals(1038))
    expect_that(ncol(rel), equals(3))
    expect_that(rel, is_a('data.frame'))
    expect_that(length(unique(rel$assembledInd)), equals(99))
    expect_that(length(unique(rel$annotatedInd)), equals(910))
    expect_that(rel$annotatedInd[6], equals(177))
    expect_that(rel$assembledInd[6], equals(3))
    expect_that(rel$percent[6], equals(0.8032030, tolerance=0.001))
})

# test_that('function for labeling assembled transcripts with genes works', {
#     expect_that(getGenes(gtfPath, structure(bg)$trans, UCSC=FALSE), 
#         not(throws_error()))
#     geneoverlaps = getGenes(gtfPath, structure(bg)$trans, UCSC=FALSE)
#     expect_that(geneoverlaps, is_a('CharacterList'))
#     expect_that(geneoverlaps[[2]], equals('ENSG00000229027'))
#     expect_that(length(geneoverlaps[[4]]), equals(2))
#     expect_that(length(geneoverlaps), equals(100))
# })

test_that('contains function works', {
    expect_that(contains(structure(bg)$trans, grl), is_a('logical'))
    expect_that(sum(contains(structure(bg)$trans, grl)), equals(61))
    expect_that(length(contains(structure(bg)$trans, grl)), equals(100))
})

pdf(file=NULL) #don't print plots to screen while testing
test_that('plot of assembled/annotated transcripts works', {
    expect_that(checkAssembledTx(annotated=grl, assembled=structure(bg)$trans, 
        ind=4), 
        not(throws_error()))
    expect_that(checkAssembledTx(annotated=grl, 
        assembled=structure(bg)$trans[1:50], ind=2), 
        gives_warning())
    expect_that(checkAssembledTx(annotated=grl, assembled=structure(bg)$trans, 
        ind=4, 
        main='hello!'), not(throws_error()))
})
dev.off()

#' match assembled transcripts to annotated transcripts
#'
#' @param assembled \code{GRangesList} object representing assembled transcripts
#' @param annotated \code{GRangesList} object representing annotated transcripts
#' 
#' @details If \code{gown} is a \code{ballgown} object, \code{assembled} can be 
#'   \code{structure(gown)$trans} (or any subset). You can generate a 
#'   \code{GRangesList} object 
#' containing annotated transcripts from a gtf file using the 
#'   \code{\link{gffReadGR}} function and 
#' setting \code{splitByTranscripts=TRUE}.
#' 
#' @return data frame, where each row contains \code{assembledInd} and 
#'   \code{annotatedInd} (indexes of overlapping transcripts in \code{assembled}
#'   and \code{annotated}), and the percent overlap between the two transcripts.
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' @examples
#' data(bg)
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' annot = gffReadGR(gtfPath, splitByTranscript=TRUE)
#' info = annotate_assembly(assembled=structure(bg)$trans, annotated=annot)

annotate_assembly = function(assembled, annotated){
    stopifnot(is(annotated, "GRangesList"),
              is(assembled, "GRangesList"))

    # things will get out of order: keep track
    names_annot = names(annotated)
    names_assmb = names(assembled)

    # get rid of metadata:
    annotatedUL = unlist(annotated)
    mcols(annotatedUL) = NULL
    annotated = split(annotatedUL, names(annotatedUL))
    annotated = annotated[match(names_annot, names(annotated))]

    # for assembly: get rid of metadata
    assembledUL = unlist(assembled)
    mcols(assembledUL) = NULL
    assembled = split(assembledUL, names(assembledUL))
    assembled = assembled[match(names_assmb, names(assembled))]

    # find the overlaps:
    ol = findOverlaps(assembled, annotated)
    ol = ol[order(queryHits(ol), subjectHits(ol))]

    # get lists of corresponding assembled/annotated transcripts:
    assembled_sort = assembled[queryHits(ol)]
    annotated_sort = annotated[subjectHits(ol)]

    # concatenate the appropriate GRanges objects (for overlapping transcripts)
    assembled_overlapIDs = rep(1:length(ol), 
        times=elementNROWS(assembled_sort))
    annotated_overlapIDs = rep(1:length(ol), 
        times=elementNROWS(annotated_sort))
    all_transcripts = c(unlist(assembled_sort), unlist(annotated_sort))
    overlapping = split(all_transcripts, 
        c(assembled_overlapIDs, annotated_overlapIDs))
    
    # calculate percentage overlap:
    coverages = coverage(ranges(overlapping))
    runvals = runValue(coverages)
    runlengths = runLength(coverages)
    pct = sum(runlengths[runvals==2]) / sum(runlengths[runvals==1 | runvals==2])

    return(data.frame(assembledInd=queryHits(ol), 
        annotatedInd=subjectHits(ol), percent=pct))
}

# slot getters

#' extract structure components from ballgown objects
#' 
#' @name structure
#' @exportMethod structure
#' @docType methods
#' @rdname structure
#' @aliases structure,ballgown-method
#' @param x a ballgown object
#' @return list containing elements \code{intron}, \code{exon}, and 
#'  \code{trans}. \code{exon} and \code{intron} are \code{GRanges} objects,
#'  where each range is an exon or intron, and \code{trans} is a
#'  \code{GRangesList} object, where each \code{GRanges} element is a set of 
#'  exons representing a transcript.
#'
#' @examples
#' data(bg)
#' names(structure(bg))
#' class(structure(bg))
#' structure(bg)$exon
setMethod("structure", "ballgown", function(x) x@structure)

#' extract expression components from ballgown objects
#' 
#' @name expr
#' @exportMethod expr
#' @docType methods
#' @rdname expr
#' @aliases expr,ballgown-method
#' @param x a ballgown object
#' @return list containing elements \code{intron}, \code{exon}, and 
#'  \code{trans}, which are feature-by-sample data frames of expression data.
#' 
#' @examples
#' data(bg)
#' names(expr(bg))
#' class(expr(bg))
#' dim(expr(bg)$exon)
#' 
#' @seealso \code{\link{texpr}}, \code{\link{gexpr}}, \code{\link{eexpr}}, 
#'   \code{\link{iexpr}}
setMethod("expr", "ballgown", function(x) x@expr)

#' extract the indexes from ballgown objects
#' 
#' @name indexes
#' @exportMethod indexes
#' @docType methods
#' @rdname indexes
#' @aliases indexes,ballgown-method
#' @param x a ballgown object
#' @return list containing elements \code{e2t}, \code{i2t}, \code{t2g}, 
#'  \code{bamfiles}, and \code{pData}, where \code{e2t} and \code{i2t} are data
#'  frames linking exons and introns (respectively) to transcripts, \code{t2g}
#'  is a data frame linking transcripts to genes, and \code{bamfiles} and 
#'  \code{pData} are described in \code{?ballgown}.
#' 
#' @examples
#' data(bg)
#' names(indexes(bg))
#' class(indexes(bg))
#' head(indexes(bg)$t2g)
setMethod("indexes", "ballgown", function(x) x@indexes)

#' extract paths to tablemaker output 
#' 
#' @name dirs
#' @exportMethod dirs
#' @docType methods
#' @rdname dirs
#' @aliases dirs,ballgown-method
#' @param x a ballgown object
#' 
#' @examples
#' data(bg)
#' dirs(bg)
setMethod("dirs", "ballgown", function(x) x@dirs)

#' extract package version & creation date from ballgown object
#' 
#' @name mergedDate
#' @exportMethod mergedDate
#' @docType methods
#' @rdname mergedDate
#' @aliases mergedDate,ballgown-method
#' @param x a ballgown object
#' 
#' @examples
#' data(bg)
#' mergedDate(bg)
setMethod("mergedDate", "ballgown", function(x) x@mergedDate)

#' extract phenotype data from a ballgown object
#' 
#' @name pData
#' @exportMethod pData
#' @docType methods
#' @rdname pData
#' @aliases pData,ballgown-method
#' @param object a ballgown object
#' @return sample-by-phenotype data frame
#' 
#' @examples
#' data(bg)
#' pData(bg)
setMethod("pData", "ballgown", function(object){
    return(indexes(object)$pData)
})

#' get names of samples in a ballgown objects
#' 
#' @name sampleNames
#' @exportMethod sampleNames
#' @docType methods
#' @rdname sampleNames
#' @aliases sampleNames,ballgown-method
#' @param object a ballgown object
#' @return vector of sample IDs for \code{x}. If \code{pData} exists, samples in
#' its rows correspond to samples in \code{sampleNames(x)} (in order).
#' 
#' @examples
#' data(bg)
#' sampleNames(bg)
setMethod("sampleNames", "ballgown", function(object){
    return(names(object@dirs))
})

#' get numeric transcript IDs from a ballgown object
#'
#' @name transcriptIDs
#' @exportMethod transcriptIDs
#' @docType methods
#' @rdname transcriptIDs
#' @aliases transcriptIDs,ballgown-method
#' @param x a ballgown object
#' @return vector of numeric transcript IDs included in the ballgown object
#' 
#' @examples
#' data(bg)
#' transcriptIDs(bg)
setMethod("transcriptIDs", "ballgown", function(x){
    return(texpr(x, 'all')$t_id)
})

#' get transcript names from a ballgown object
#'
#' @name transcriptNames
#' @exportMethod transcriptNames
#' @docType methods
#' @rdname transcriptNames
#' @aliases transcriptNames,ballgown-method
#' @param x a ballgown object
#' @return vector of transcript names included in the ballgown object. If object
#' was created using Cufflinks/Tablemaker, these transcript names will be of the
#' form "TCONS_*". Return vector is named and ordered by corresponding numeric
#' transcript ID.
#' 
#' @examples
#' data(bg)
#' transcriptNames(bg)
setMethod("transcriptNames", "ballgown", function(x){
    ret = texpr(x, 'all')$t_name
    names(ret) = texpr(x, 'all')$t_id
    ret
})

#' get gene IDs from a ballgown object
#'
#' @name geneIDs
#' @exportMethod geneIDs
#' @docType methods
#' @rdname geneIDs
#' @aliases geneIDs,ballgown-method
#' @param x a ballgown object
#' @return named vector of gene IDs included in the ballgown object. If object 
#' was created using Tablemaker, these gene IDs will be of the form "XLOC_*".
#' Vector is named and ordered by corresponding numeric transcript ID.
#'
#' @details
#' This vector differs from that produced by geneNames in that geneIDs produces
#' names of loci created during the assembly process, not necessarily
#' annotated genes. 
#' @seealso \code{\link{geneNames}}
#' @examples
#' data(bg)
#' geneIDs(bg)
setMethod("geneIDs", "ballgown", function(x){
    ret = texpr(x, 'all')$gene_id
    names(ret) = texpr(x, 'all')$t_id
    ret
})

#' get gene names from a ballgown object
#'
#' @name geneNames
#' @exportMethod geneNames
#' @docType methods
#' @rdname geneNames
#' @aliases geneNames,ballgown-method
#' @param x a ballgown object
#' @return named vector of gene names included in the ballgown object, named
#' and ordered by corresponding numeric transcript ID. 
#'
#' @details
#' This vector differs from that produced by geneIDs in that geneNames produces
#' *annotated* gene names that correspond to assembled transcripts. The
#' return will be empty/blank/NA if the transcriptome assembly is de novo 
#' (i.e., was not compared to an annotation before the ballgown object was
#' created). See \code{\link{getGenes}} for matching transcripts to gene names.
#' Some entries of this vector will be empty/blank/NA if the corresponding 
#' transcript did not overlap any annotated genes. 
#' 
#' @examples
#' data(bg)
#' # this is a de novo assembly, so it does not contain gene info as it stands
#' # but we can add it:
#' annot = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' gnames = getGenes(annot, structure(bg)$trans, UCSC=FALSE)
#' gnames_first = lapply(gnames, function(x) x[1]) #just take 1 overlapping gene
#' expr(bg)$trans$gene_name = gnames_first
#' 
#' # now we can extract these gene names:
#' geneNames(bg)
#' 
#' @seealso \code{\link{geneIDs}}
setMethod("geneNames", "ballgown", function(x){
    ret = texpr(x, 'all')$gene_name
    names(ret) = texpr(x, 'all')$t_id
    ret
})

#' get sequence (chromosome) names from ballgown object
#'
#' @name seqnames
#' @exportMethod seqnames
#' @docType methods
#' @rdname seqnames
#' @aliases seqnames,ballgown-method
#' @param x a ballgown object
#' @return vector of sequence (i.e., chromosome) names included in the 
#' ballgown object
#' 
#' @examples
#' data(bg)
#' seqnames(bg)
setMethod("seqnames", "ballgown", function(x){
    return(unique(texpr(x,'all')$chr))
})

#' @title write files to disk from ballgown object
#'
#' @description create tablemaker-like files on disk from a ballgown object
#' @param gown ballgown object
#' @param dataDir top-level directory for sample-specific folders
#' @export
#' @examples \donttest{
#'   data(bg)
#'   writeFiles(bg, dataDir=getwd())
#'}
writeFiles = function(gown, dataDir){
    # write tablemaker output files to disk (from ballgown object)
    # I don't imagine this will be widely useful, but you never know.

    if(gown@meas != 'all'){
        msg = 'Can only write full ballgown objects to disk, for now.
            (You only have specific measurements in yours).'
        stop(.makepretty(msg))
    }

    sysoutdir = gsub(' ', '\\\\ ', dataDir) #vector, length 1
    for(f in sampleNames(gown)){
        sysout = paste0(sysoutdir, '/', f)
        if(.Platform$OS.type == 'windows'){
            shell(paste('mkdir ', sysout))
        }else{
            system(paste('mkdir -p', sysout))
        }
        out = paste0(dataDir, '/', f)

        # i2t.ctab and e2t.ctab:
        write.table(indexes(gown)$i2t, file=paste0(out, '/i2t.ctab'),
            quote=FALSE, col.names=TRUE, row.names=FALSE, sep='\t')
        write.table(indexes(gown)$e2t, file=paste0(out, '/e2t.ctab'),
            quote=FALSE, col.names=TRUE, row.names=FALSE, sep='\t')

        # e_data.ctab
        cn = names(eexpr(gown, 'all'))
        e_data = eexpr(gown, 'all')[,c(1:5, which(grepl(f, cn)))]
        names(e_data)[6:ncol(e_data)] = c('rcount', 'ucount', 'mrcount',
            'cov', 'cov_sd', 'mcov', 'mcov_sd')
        write.table(e_data, file=paste0(out, '/e_data.ctab'), quote=FALSE,
            col.names=TRUE, row.names=FALSE, sep='\t')

        # i_data.ctab
        cn = names(iexpr(gown, 'all'))
        i_data = iexpr(gown, 'all')[,c(1:5, which(grepl(f, cn)))]
        names(i_data)[6:ncol(i_data)] = c('rcount', 'ucount', 'mrcount')
        write.table(i_data, file=paste0(out, '/i_data.ctab'), quote=FALSE,
            col.names=TRUE, row.names=FALSE, sep='\t')

        # t_data.ctab
        cn = names(texpr(gown, 'all'))
        t_data = texpr(gown, 'all')[,c(1:10, which(grepl(f, cn)))]
        names(t_data)[11:ncol(t_data)] = c('cov', 'FPKM')
        write.table(t_data, file=paste0(out, '/t_data.ctab'), quote=FALSE,
            col.names=TRUE, row.names=FALSE, sep='\t')

    }
}

#' statistical tests for differential expression in ballgown
#'
#' Test each transcript, gene, exon, or intron in a ballgown object for 
#' differential expression, using comparisons of linear models.
#' 
#' @param gown name of an object of class \code{ballgown}
#' @param gowntable matrix or matrix-like object with \code{rownames} 
#'   representing feature IDs and columns representing samples, with expression
#'   estimates in the cells. Provide the feature name with \code{feature}. You
#'   must provide exactly one of \code{gown} or \code{gowntable}. NB: gowntable
#'   is log-transformed within \code{stattest} if \code{log} is \code{TRUE}, so
#'   provide un-logged expression values in \code{gowntable}.
#' @param pData Required if \code{gowntable} is provided: data frame giving
#'   phenotype data for the samples in the columns of \code{gowntable}. (Rows of
#'   \code{pData} correspond to columns of \code{gowntable}). If \code{gown} is
#'   used instead, it must have a non-null, valid \code{pData} slot (and the 
#'   \code{pData} argument to \code{stattest} should be left \code{NULL}).
#' @param mod object of class \code{model.matrix} representing the design matrix
#'   for the linear regression model including covariates of interest
#' @param mod0 object of class \code{model.matrix} representing the design 
#'   matrix for the linear regression model without the covariates of interest.
#' @param feature the type of genomic feature to be tested for differential 
#'   expression. If \code{gown} is used, must be one of \code{"gene"}, 
#'   \code{"transcript"}, \code{"exon"}, or \code{"intron"}. If \code{gowntable}
#'   is used, this is just used for labeling and can be whatever the rows of 
#'   \code{gowntable} represent.
#' @param meas the expression measurement to use for statistical tests.  Must be
#'   one of \code{"cov"}, \code{"FPKM"}, \code{"rcount"}, \code{"ucount"}, 
#'   \code{"mrcount"}, or \code{"mcov"}. Not all expression measurements are 
#'   available for all features. Leave as default if \code{gowntable} is 
#'   provided.
#' @param timecourse if \code{TRUE}, tests whether or not the expression 
#'   profiles of genomic features vary over time (or another continuous 
#'   covariate) in the study.  Default \code{FALSE}.  Natural splines are used
#'   to fit time profiles, so you must have more timepoints than degrees of 
#'   freedom used to fit the splines. The default df is 4.
#' @param df degrees of freedom used for modeling expression over time with 
#'   natural cubic splines.  Default 4.  Only used if \code{timecourse=TRUE}.
#' @param covariate string representing the name of the covariate of interest 
#'   for the differential expression tests.  Must correspond to the name of a 
#'   column of \code{pData(gown)}. If \code{timecourse=TRUE}, this should be the
#'   study's time variable.
#' @param adjustvars optional vector of strings representing the names of 
#'   potential confounders.  Must correspond to names of columns of 
#'   \code{pData(gown)}.
#' @param gexpr optional data frame that is the result of calling 
#'   \code{gexpr(gown))}.  (You can speed this function up by pre-creating 
#'   \code{gexpr(gown)}.)
#' @param getFC if \code{TRUE}, also return estimated fold changes (adjusted for
#'   library size and confounders) between populations. Only available for 
#'   2-group comparisons at the moment. Default \code{FALSE}.
#' @param libadjust library-size adjustment to use in linear models. By default,
#'   the adjustment is defined as the sum of the sample's log expression
#'   measurements below the 75th percentile of those measurements. To use 
#'   a different library-size adjustment, provide a numeric vector of each 
#'   sample's adjustment value. Entries of this vector correspond to samples in
#'   in rows of \code{pData}. If no library size adjustment is desired, set to
#'   FALSE.
#' @param log if \code{TRUE}, outcome variable in linear models is 
#'   log(expression+1), otherwise it's expression. Default TRUE.
#' 
#' @details At minimum, you need to provide a ballgown object or count table, 
#'   the type of feature you want to test (gene, transcript, exon, or intron), 
#'   the expression measurement you want to use (FPKM, cov, rcount, etc.), and 
#'   the covariate of interest, which must be the name of one of the columns of 
#'   the `pData` component of your ballgown object (or provided pData). This 
#'   covariate is automatically converted to a factor during model fitting in 
#'   non-timecourse experiments.
#' 
#'   By default, models are fit using \code{log2(meas + 1)} as the outcome for 
#'   each feature. To disable the log transformation, provide `log = FALSE` as 
#'   an argument to `stattest`. You can use the \code{gowntable} option if you'd
#'   like to to use a different transformation.
#' 
#'   Library size adjustment is performed by default by using the sum of the log
#'   nonzero expression measurements for each sample, up to the 75th percentile
#'   of those measurements. This adjustment can be disabled by setting 
#'   \code{libadjust=FALSE}. You can use \code{mod} and \code{mod0} to specify 
#'   alternative library size adjustments.
#' 
#'   \code{mod} and \code{mod0} are optional arguments.  If \code{mod} is 
#'   specified, you must also specify \code{mod0}.  If neither is specified, 
#'   \code{mod0} defaults to the design matrix for a model including only a 
#'   library-size adjustment, and \code{mod} defaults to the design matrix for a
#'   model including a library-size adjustment and \code{covariate}. Note that 
#'   if you supply \code{mod} and \code{mod0}, \code{covariate}, 
#'   \code{timecourse}, \code{adjustvars}, and \code{df} are ignored, so make 
#'   sure your covariate of interest and all appropriate confounder 
#'   adjustments, including library size, are specified in \code{mod} and 
#'   \code{mod0}. By default, the library-size adjustment is the sum of all
#'   counts below the 75th percentile of nonzero counts, on the log scale
#'   (log2 + 1). 
#' 
#'   Full model details are described in the supplement of 
#'   \url{http://biorxiv.org/content/early/2014/03/30/003665}.
#' 
#' @return data frame containing the columns \code{feature}, \code{id} 
#'   representing feature id, \code{pval} representing the p-value for testing 
#'   whether this feature was differentially expressed according to 
#'   \code{covariate}, and \code{qval}, the estimated false discovery rate 
#'   using this feature's signal strength as a significance cutoff. An 
#'   additional column, \code{fc}, is included if \code{getFC} is \code{TRUE}.
#' 
#' @export
#' 
#' @references \url{http://biorxiv.org/content/early/2014/03/30/003665}
#' 
#' @author Jeff Leek, Alyssa Frazee
#' @examples
#' data(bg)
#' 
#' # two-group comparison:
#' stat_results = stattest(bg, feature='transcript', meas='FPKM', 
#'   covariate='group')
#' 
#' # timecourse test:
#' pData(bg) = data.frame(pData(bg), time=rep(1:10, 2)) #dummy time covariate
#' timecourse_results = stattest(bg, feature='transcript', meas='FPKM', 
#'   covariate='time', timecourse=TRUE)
#' 
#' # timecourse test, adjusting for group:
#' group_adj_timecourse_results = stattest(bg, feature='transcript', 
#'   meas='FPKM', covariate='time', timecourse=TRUE, adjustvars='group')
#' 
#' # custom model matrices:
#' ### create example data:
#' set.seed(43)
#' sex = sample(c('M','F'), size=nrow(pData(bg)), replace=TRUE)
#' age = sample(21:52, size=nrow(pData(bg)), replace=TRUE)
#' 
#' ### create design matrices:
#' mod = model.matrix(~ sex + age + pData(bg)$group + pData(bg)$time)
#' mod0 = model.matrix(~ pData(bg)$group + pData(bg)$time)
#'
#' ### build model: 
#' adjusted_results = stattest(bg, feature='transcript', meas='FPKM', 
#'   mod0=mod0, mod=mod)

stattest = function(gown = NULL, gowntable = NULL, pData = NULL, mod = NULL, 
    mod0 = NULL, feature = c("gene", "exon", "intron", "transcript"), 
    meas = c("cov", "FPKM", "rcount", "ucount", "mrcount", "mcov"), 
    timecourse = FALSE, covariate = NULL, adjustvars = NULL, gexpr = NULL, 
    df = 4, getFC = FALSE, libadjust = NULL, log = TRUE){

    if(!xor(is.null(gown), is.null(gowntable))){
        stop('must provide exactly one of gown and gowntable')
    }
    if(xor(is.null(mod), is.null(mod0))){
        stop("please provide both null and full models, or use the defaults")
    }

    if(!is.null(gowntable)){
        expr = as.matrix(gowntable)
        stopifnot(!is.null(pData))
        stopifnot(nrow(pData) == ncol(expr))
    } else {
        feature = match.arg(feature)
        meas = match.arg(meas)
        if(feature == "transcript" & !(meas %in% c("cov", "FPKM"))){
            stop("transcripts only have cov and FPKM measurements")
        }
        if(feature == "gene" & meas != "FPKM"){
            stop("gene tests can only be done on FPKM measurements")
        }
        if((feature == "exon") & meas == "FPKM"){
            stop("exons do not have FPKM measurements")
        }
        if((feature == "intron") & 
            !(meas %in% c("rcount", "ucount", "mrcount"))){
            stop("introns only have rcount, ucount, and mrcount measurements")
        }
        pData = pData(gown)
        if(is.null(pData) & is.null(mod)){
            stop(.makepretty('to do statistical tests, either gown must contain
                pData or you must specify models.'))
        }
            ## extract the right expression measurements
        if(feature == "gene"){
            if(is.null(gexpr)){
                expr = gexpr(gown)
            }else{
                expr = gexpr
            }
        }
        if(feature == "exon") expr = eexpr(gown, meas)
        if(feature == "intron") expr = iexpr(gown, meas)
        if(feature == "transcript") expr = texpr(gown, meas)
        expr = as.matrix(expr)
    }
    
    n = ncol(expr)

    ## library size adjustment
    if(is.null(libadjust)){
        libadjust = apply(expr, 2, function(x){
            lognz = log2(x[x!=0] + 1)
            q3 = quantile(lognz, 0.75)
            sum(lognz[lognz<q3])
        })
    }else if(!identical(libadjust, FALSE)){
            stopifnot(is.numeric(libadjust) | identical(libadjust, FALSE))
            stopifnot(length(libadjust) == nrow(pData))
    }

    if(is.null(mod) & is.null(mod0)){
        ## by default, just test whether the given covariate is important
        colind = which(names(pData) == covariate)
        if(length(colind) == 0) stop("invalid covariate name")

        ## extract the covariate
        x = pData[,colind]
                
        ## make sure there are at least 2 reps per group:
        if(any(table(x) < 2) & !timecourse){
            stop(.makepretty('There must be at least two replicates per group.
                Make sure covariate is categorical; if continuous, consider the
                timecourse option, or specify your own models with mod and
                mod0.'))
        }

        ## make sure time variable is truly continuous:
        ## (if not, continue using it just as "important")
        if(timecourse){
            n_unique_times = length(table(x))
            if(n_unique_times <= df){
                warning(paste0('Not enough timepoints (or values of', 
                    ' covariate) to fit a spline model with ', df, ' degrees ',
                    'of freedom. Statistical tests will be run treating time',
                    ' as categorical. You can also re-run the analysis with ',
                    'decreased df.'))
                timecourse = FALSE
            }
        }

        ## create model matrices
        if(!is.null(adjustvars)){
            variable_list = ""
            for(i in seq_along(adjustvars)){
                if(!adjustvars[i] %in% names(pData)){
                    stop(paste(adjustvars[i], 'is not a valid covariate'))
                }
                column_ind = which(names(pData) == adjustvars[i])
                eval(parse(text=paste0(adjustvars[i], 
                    " <- pData[,",column_ind,"]")))
                variable_list = paste(variable_list, adjustvars[i], sep="+")
            }
            if(!identical(libadjust, FALSE)){
                eval(parse(text=paste0("mod0 = model.matrix(~ libadjust", 
                    variable_list, ")")))
                if(timecourse){
                    eval(parse(text=paste0(
                        "mod = model.matrix(~ ns(x, df = ", df, ") + libadjust", 
                        variable_list, ")")))
                } else {
                    eval(parse(text=paste0(
                        "mod = model.matrix(~ as.factor(x) + libadjust", 
                        variable_list, ")")))
                }
            } else {
                variable_list = substr(variable_list, 2, nchar(variable_list)) 
                #^^strip off "+" at beginning of variable_list
                eval(parse(text=paste0("mod0 = model.matrix(~", 
                    variable_list, ")")))
                if(timecourse){
                    eval(parse(text=paste0(
                        "mod = model.matrix(~ ns(x, df = ", df, ") + ", 
                        variable_list,")")))
                } else {
                    eval(parse(text=paste0(
                        "mod = model.matrix(~ as.factor(x) + ", variable_list, 
                        ")")))
                }
            }
        } else {
            if(!identical(libadjust, FALSE)){
                mod0 = model.matrix(~ libadjust)
            } else{
                mod0 = matrix(1, nrow=length(x), ncol=1)
            }
            if(timecourse){
                if(!identical(libadjust, FALSE)){
                    mod = model.matrix(~ ns(x, df = df) + libadjust)
                } else {
                    mod = model.matrix(~ ns(x, df = df))
                }
            } else {
                if(!identical(libadjust, FALSE)){
                    mod = model.matrix(~ as.factor(x) + libadjust)
                } else {
                    mod = model.matrix(~ as.factor(x))
                }
            }
        }
    } else {
        ## test whether custom models are, in fact, nested.
        stopifnot(class(mod0)[1] == 'matrix' & class(mod)[1] == 'matrix')
        if(!('assign' %in% names(attributes(mod0))) | !('assign' %in% 
                names(attributes(mod)))){
            stop('mod and mod0 must both be model.matrix objects')
        }
        stopifnot(ncol(mod) > ncol(mod0))
        for(i in 1:ncol(mod0)){
            inMod = any(apply(mod, 2, function(x) identical(mod0[,i], x)))
            if(!inMod){
                stop('mod0 is not nested in mod')
            }
        }
    }

    if(log){
        y = log2(expr+1)
    }else{
        y = expr
    }

    if(getFC){
        two = try(length(table(x)), silent=TRUE)
        if(class(two) == 'try-error'){
            warning('fold changes not available for custom models')
        } else if(two != 2){
            warning('fold changes only available for 2-group comparisons')
        }else{
            lmodels = lmFit(y, design=mod)
            if(log){
                estFC = 2^(lmodels$coefficients[,2])
            }else{
                warning(.makepretty('log is FALSE, so estimated difference (not
                    fold change) is reported.'))
                estFC = lmodels$coefficients[,2]
            }
            presults = f.pvalue(y, mod, mod0)
            results = data.frame(feature=rep(feature, nrow(expr)), 
                id=rownames(expr), fc=estFC, 
                pval=presults, qval=p.adjust(presults, "fdr"))
            if(!log){
                names(results)[3] = 'difference'
            }
            rownames(results) = NULL
            return(results)
        }
    }

    presults = f.pvalue(y, mod, mod0)
    results = data.frame(feature=rep(feature, nrow(expr)), 
        id=rownames(expr), pval=presults, qval=p.adjust(presults, "fdr")) 
    rownames(results) = NULL
    return(results)
}

context('test differential expression functions')

test_that('ballgown reader is not broken and data was installed properly', {
    expect_that(ballgown(dataDir=system.file('extdata', package='ballgown'),
        samplePattern='sample', verbose=FALSE), not(throws_error()))
})

bg = ballgown(dataDir=system.file('extdata', package='ballgown'), 
    samplePattern='sample', verbose=FALSE)
pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))

test_that('default stat models work', {
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group'), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='cov', 
        covariate='group'), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='ucount', 
        covariate='group'), throws_error())
    statres = stattest(bg, feature='transcript', meas='FPKM', covariate='group')
    expect_that(statres, is_a('data.frame'))
    expect_that(nrow(statres), equals(100))
    expect_that(ncol(statres), equals(4))
    expect_that(statres$pval[6], equals(0.2731, tolerance=0.001))

    expect_that(stattest(bg, feature='gene', meas='FPKM', covariate='group'), 
        not(throws_error()))
    expect_that(stattest(bg, feature='gene', meas='cov', covariate='group'), 
        throws_error())
    generes = stattest(bg, feature='gene', meas='FPKM', covariate='group')
    expect_that(generes, is_a('data.frame'))
    expect_that(nrow(generes), equals(93))
    expect_that(ncol(generes), equals(4))
    expect_that(generes$pval[4], equals(0.124, tolerance=0.001))

    expect_that(stattest(bg, feature='exon', meas='cov', covariate='group'), 
        not(throws_error()))
    expect_that(stattest(bg, feature='exon', meas='FPKM', covariate='group'), 
        throws_error())
    exonres = stattest(bg, feature='exon', meas='cov', covariate='group')
    expect_that(exonres, is_a('data.frame'))
    expect_that(nrow(exonres), equals(633))
    expect_that(ncol(exonres), equals(4))
    expect_that(exonres$pval[3], equals(0.183, tolerance=0.001))

    expect_that(stattest(bg, feature='intron', meas='mrcount', 
        covariate='group'), not(throws_error()))
    expect_that(stattest(bg, feature='intron', meas='cov', covariate='group'), 
        throws_error())

    # check other errors:
    expect_that(stattest(bg, feature='junction', meas='mrcount', 
        covariate='group'), throws_error())
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate=group), throws_error())
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='nonsense!'), throws_error())
    bgnull = bg
    pData(bgnull) = NULL
    expect_that(stattest(bgnull, feature='transcript', meas='FPKM', 
        covariate='group'), throws_error())
    rm(bgnull)
})

test_that('log, library size, and getFC options work', {
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', log=FALSE), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', libadjust=FALSE), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', getFC=TRUE), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', log=FALSE, getFC=TRUE), gives_warning())
})

cpd = pData(bg)
set.seed(251)
pData(bg) = data.frame(cpd, c1=runif(20,1,5), c2=rnorm(20,0,5))

test_that('user-defined model matrices work', {
    mod0 = model.matrix(~pData(bg)$group + pData(bg)$c1)
    mod = model.matrix(~pData(bg)$group + pData(bg)$c1 + pData(bg)$c2)
    expect_that(stattest(bg, mod=mod, mod0=mod0, feature='transcript', 
        meas='FPKM'), not(throws_error()))
    customres = stattest(bg, mod=mod, mod0=mod0, feature='transcript', 
        meas='FPKM')
    expect_that(customres, is_a('data.frame'))
    expect_that(nrow(customres), equals(100))
    expect_that(ncol(customres), equals(4))
    expect_that(customres$pval[6], equals(0.27569, tolerance=0.0001))
    expect_that(stattest(bg, mod=mod, mod0=mod0, feature='transcript', 
        meas='FPKM', getFC=TRUE), gives_warning())
    expect_that(stattest(bg, mod=mod0, mod0=mod, feature='transcript', 
        meas='FPKM'), throws_error())
    m0 = model.matrix(~pData(bg)$c1 + pData(bg)$c2)
    m = model.matrix(~pData(bg)$c2 + pData(bg)$group + rnorm(20)) #non-nested
    expect_that(stattest(bg, mod=m, mod0=m0, feature='transcript', meas='FPKM'),
        throws_error())
})

test_that('adjustment for covariates works', {
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', adjustvars='c1'), not(throws_error()))
    adjres = stattest(bg, feature='transcript', meas='FPKM', covariate='group', 
        adjustvars='c1')
    expect_that(adjres, is_a('data.frame'))
    expect_that(ncol(adjres), equals(4))
    expect_that(nrow(adjres), equals(100))
    expect_that(adjres$pval[1], equals(0.0218, tolerance=0.001))
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', adjustvars=c('c1', 'c2')), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', adjustvars=c('c1', 'c2', 'nonsense')), 
        throws_error())
    expect_that(stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group', adjustvars='group'), throws_error())
})


test_that('timecourse option works', {
    expect_that(stattest(bg, feature='transcript', meas='FPKM', covariate='c1', 
        timecourse=TRUE), not(throws_error()))
    tres = stattest(bg, feature='transcript', meas='FPKM', covariate='c1', 
        timecourse=TRUE)
    expect_that(tres, is_a('data.frame'))
    expect_that(nrow(tres), equals(100))
    expect_that(ncol(tres), equals(4))
    expect_that(tres$pval[3], equals(0.569, tolerance=0.001))

    expect_that(stattest(bg, feature='transcript', meas='FPKM', covariate='c1', 
        adjustvars='group', timecourse=TRUE), not(throws_error()))
    expect_that(stattest(bg, feature='transcript', meas='FPKM', covariate='c1'),
        throws_error())
    expect_that(stattest(bg, feature='transcript', meas='FPKM', covariate='c1',
        timecourse=TRUE, df=3), not(throws_error()))
})

test_that('stattest_table functionality works', {
    tab = texpr(bg)
    orig_res = stattest(bg, feature='transcript', meas='FPKM', 
        covariate='group')
    tab_res = stattest(gowntable=tab, pData=pData(bg), feature='transcript', 
        covariate='group')
    expect_that(tab_res, is_identical_to(orig_res))
})

#' label assembled transcripts with gene names
#' 
#' @param gtf path to a GTF file containing locations of annotated transcripts
#' @param assembled GRangesList object, with each set of ranges representing 
#'   exons of an assembled transcript.
#' @param UCSC set to \code{TRUE} if you're using a UCSC gtf file. (Requires
#'   some extra text processing).
#' @param attribute set to attribute name in \code{gtf} that gives desired gene
#'   identifiers. Default \code{"gene_id"}; another commone one is
#'   \code{"gene_name"} (for the gene symbol).
#' @return an \code{IRanges CharacterList} of the same length as
#'   \code{assembled}, providing the name(s) of the gene(s) that overlaps each
#'   transcript in \code{assembled}.
#' 
#' @details chromosome labels in \code{gtf} and \code{assembled} should match.
#'   (i.e., you should provide the path to a gtf corrsponding to the same
#'   annotation you used when constructing \code{assembled})
#' 
#' @author Alyssa Frazee, Andrew Jaffe
#' @export
#' 
#' @examples
#' data(bg)
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' geneoverlaps = getGenes(gtfPath, structure(bg)$trans, UCSC=FALSE)

getGenes = function(gtf, assembled, UCSC=TRUE, attribute = "gene_id"){
    # read in annotation and split by gene:
    annot = gffReadGR(gtf)
    annotEx = annot[mcols(annot)$type=="exon"]
    col_index = which(names(mcols(annotEx)) == attribute)
    annotEx$gene_id = mcols(annotEx)[,col_index]
    if(UCSC){
        # strip quotes off of gene names
        annotEx$gene_id = substr(annotEx$gene_id, 2, nchar(annotEx$gene_id)-1)
    }
    geneLocs = split(annotEx, annotEx$gene_id)

    # find which transcripts overlap which genes:
    ol = findOverlaps(assembled, geneLocs)
    split_ol = split(names(geneLocs[subjectHits(ol)]), queryHits(ol)) 
        #^^to deal with transcripts overlapping >1 gene
    split_ol = sapply(split_ol, function(x) paste(x, collapse="; "))
    gene_id = rep("", length(assembled))
    gene_id[as.numeric(names(split_ol))] = as.character(split_ol)

    gene_id = CharacterList(strsplit(gene_id,"; "))

    return(gene_id)
}

assessSim = function(bg, bgresults, annotation, chr, trulyDEids, 
    cuffdiffFile=NULL, qcut=0.05, UCSC=TRUE, ret=FALSE, nClosest=1, 
    limmaresults=NULL, plot=TRUE){
    
    stopifnot(all(qcut >= 0 & qcut <= 1))

    assemblygr = structure(bg)$trans
    if(class(annotation)!='data.frame'){
        annot = gffRead(annotation)
        annotsub = annot[annot[,3]=='exon' & annot[,1]==chr,] 
        #^ col3=feature, col1=seqname
        annotsub$tx = getAttributeField(annotsub$attributes, "transcript_id")
        if(UCSC){
            # strip quotes and strip off any "_2" business
            annotsub$tx = substr(annotsub$tx, 2, nchar(annotsub$tx)-1)
            annotsub$tx = sapply(annotsub$tx, 
                function(x){
                    paste(strsplit(x, split="_")[[1]][1:2],collapse="_")
                })
        }
    }else{
        annotsub = annotation
    }
    degtf = annotsub[annotsub$tx %in% trulyDEids,]
    degr = split(GRanges(seqnames=Rle(chr), 
        ranges=IRanges(start=degtf$start, end=degtf$end), 
        strand=degtf$strand), degtf$tx)

    deoverlaps = annotate_assembly(assemblygr, degr)
    ol_list = split(deoverlaps[, c(1, 3)], deoverlaps[,2])
    ## ties are handled according to "sort" -- 
    ## i.e., if there's a max overlap tie, the transcript 
    ## with the smaller start position will be chosen
    find_correct = function(x){
        maxInd = min(nrow(x), nClosest)
        return(x[order(x[,2], decreasing=TRUE)[1:maxInd] ,1])
    }
    truly_de = lapply(ol_list, find_correct)

    inds_to_ids = function(x){
        as.numeric(names(assemblygr)[x])
    }##in case txid and indices do not match
    truly_de_ids = lapply(truly_de, inds_to_ids)
    non_de_ids = setdiff(unique(texpr(bg, "all")$t_id), 
        as.numeric(unlist(truly_de_ids)))

    # load in cuffdiff results
    if(!is.null(cuffdiffFile)){
        cuff = read.table(cuffdiffFile, sep = "\t", header = TRUE)
        cuffok = cuff[cuff$status == 'OK',]
    }

    if(length(qcut) == 1){
        if(!is.null(cuffdiffFile)){
            cuff_decalls = as.character(cuffok$test_id[cuffok$q_value < qcut])
            cuff_decalls = texpr(bg, "all")$t_id[match(cuff_decalls, 
                texpr(bg, "all")$t_name)]
            found_by_cuffdiff = sapply(truly_de_ids, function(x){
                any(x %in% cuff_decalls)
            })
        }
        bg_decalls = bgresults$id[which(bgresults$qval < qcut)]
        bg_decalls = as.numeric(as.character(bg_decalls))
        found_by_bg = sapply(truly_de_ids, function(x){
            any(x %in% bg_decalls)
        })
        if(!is.null(limmaresults)) { 
            limma_decalls = limmaresults$id[limmaresults$qval < qcut]
            found_by_limma = sapply(truly_de_ids, function(x){
                any(x %in% limma_decalls)
            })
        }

        bgsens = sum(found_by_bg) / length(found_by_bg)
        bgspec = sum(!(non_de_ids %in% bg_decalls))/length(non_de_ids)
        bgfdr = sum(!(bg_decalls %in% unlist(truly_de_ids)))/length(bg_decalls)

        if(!is.null(cuffdiffFile)){
            cuffsens = sum(found_by_cuffdiff) / length(found_by_cuffdiff)    
            cuffspec = sum(!(non_de_ids %in% cuff_decalls))/length(non_de_ids)
            cufffdr = sum(
                !(cuff_decalls %in% unlist(truly_de_ids)))/length(cuff_decalls)
        } else {
            cuffsens = cuffspec = cufffdr = NULL
        }
        
        if(!is.null(limmaresults)){ 
            limmasens = sum(found_by_limma) / length(found_by_limma)
            limmaspec = sum(
                !(non_de_ids %in% limma_decalls)) / length(non_de_ids)
            limmafdr = sum(!(limma_decalls %in% 
                unlist(truly_de_ids)))/length(limma_decalls)
        } else {
            limmasens = limmaspec = limmafdr = NULL
        }
        
        return(list(ballgownsens=bgsens, cuffdiffsens=cuffsens, 
            limmasens=limmasens, ballgownspec=bgspec, 
            cuffdiffspec=cuffspec, limmapsec=limmaspec, 
            ballgownfdr=bgfdr, cuffdifffdr=cufffdr, limmafdr=limmafdr))
    }

    # else, make ROC plots
    bgsens = cuffsens = bgspec = cuffspec = bgfdr = cufffdr = NULL
    limmasens = limmaspec = limmafdr = NULL
    for(i in 1:length(qcut)){

        if(!is.null(cuffdiffFile)){
            cuff_decalls = as.character(cuffok$test_id[
                cuffok$q_value < qcut[i]])
            cuff_decalls = texpr(bg,'all')$t_id[match(cuff_decalls, 
                texpr(bg,'all')$t_name)]
            found_by_cuffdiff = sapply(truly_de_ids, function(x){
                any(x %in% cuff_decalls)
            })
        }

        bg_decalls = bgresults$id[which(bgresults$qval < qcut[i])]
        bg_decalls = as.numeric(as.character(bg_decalls))
        found_by_bg = sapply(truly_de_ids, function(x){
            any(x %in% bg_decalls)
        })

        if(!is.null(limmaresults)) { 
            limma_decalls = limmaresults$id[limmaresults$qval < qcut[i]]
            found_by_limma = sapply(truly_de_ids, function(x){
                any(x %in% limma_decalls)
            })
        }

        bgsens[i] = sum(found_by_bg) / length(found_by_bg)
        bgspec[i] = sum(!(non_de_ids %in% bg_decalls))/length(non_de_ids)
        bgfdr[i] = sum(
            !(bg_decalls %in% unlist(truly_de_ids)))/length(bg_decalls)

        if(!is.null(cuffdiffFile)){
            cuffsens[i] = sum(found_by_cuffdiff) / length(found_by_cuffdiff)    
            cuffspec[i] = sum(
                !(non_de_ids %in% cuff_decalls))/length(non_de_ids) 
            cufffdr[i] = sum(
                !(cuff_decalls %in% unlist(truly_de_ids)))/length(cuff_decalls)
        }
        
        if(!is.null(limmaresults)){
            limmasens[i] = sum(found_by_limma) / length(found_by_limma)
            limmaspec[i] = sum(
                !(non_de_ids %in% limma_decalls)) / length(non_de_ids)
            limmafdr[i] = sum(!(limma_decalls %in% 
                unlist(truly_de_ids)))/length(limma_decalls)
        }
        
    }

    if(plot){
        plot(1-bgspec, bgsens, col="dodgerblue", type="l", 
            xlab="false positive rate", ylab="true positive rate", lwd=2, 
            ylim=c(0,1))
        if(!is.null(cuffdiffFile)){
            lines(1-cuffspec, cuffsens, col="orange", lwd=2)
            legend('bottomright', lty=c(1,1), lwd=c(2,2), 
                col=c("dodgerblue", "orange"), c("ballgown", "cuffdiff"))
        }
    }

    if(ret){
        isDE = bgresults$id %in% unlist(truly_de_ids)
        return(list(ballgownsens=bgsens, cuffdiffsens=cuffsens, 
            limmasens=limmasens, ballgownspec=bgspec, cuffdiffspec=cuffspec, 
            limmaspec=limmaspec, bgfdr=bgfdr, cufffdr=cufffdr, 
            limmafdr=limmafdr, isDE=isDE))
    }
}

### constructor function for ballgown objects

### helper functions:
.readIntron <- function(file, meas){
    cc = c('integer', 'character', 'factor', 'integer', 'integer', 'integer',
        'integer', 'numeric')
    if(!identical(meas, 'all')){
        dummy = c(rep(meas[1], 5), 'rcount', 'ucount', 'mrcount')
        cc[which(!(dummy %in% meas))] = 'NULL'
    }
    intron = read.table(file, header=TRUE, sep="\t", colClasses=cc, quote="")
    intron = intron[order(intron$i_id), ]
    rownames(intron) = 1:nrow(intron)
    return(intron)
}

.readExon <- function(file, meas) {
    cc = c('integer', 'character', 'factor', 'integer', 'integer',
        'integer', 'integer', rep('numeric', 5))
    if(!identical(meas, 'all')){
        dummy = c(rep(meas[1], 5), 'rcount', 'ucount', 'mrcount', 'cov',
            'cov_sd', 'mcov', 'mcov_sd')
        cc[which(!(dummy %in% meas))] = 'NULL'
    }
    exon = read.table(file, header=TRUE, sep="\t", colClasses=cc, quote="")
    exon = exon[order(exon$e_id), ]
    rownames(exon) = 1:nrow(exon)
    return(exon)
}

.readTranscript <- function(file, meas) {
    cc = c('integer', 'character', 'factor', 'integer', 'integer',
        'character', 'integer', 'integer', 'character', 'character',
        'numeric', 'numeric')
    if(!identical(meas, 'all')){
        if(!('cov' %in% meas)) cc[11] = 'NULL'
        if(!('FPKM' %in% meas)) cc[12] = 'NULL'
    }
    transcript = read.table(file, header=TRUE, sep="\t",
        colClasses=cc, quote="")
    transcript = transcript[order(transcript$t_id), ]
    rownames(transcript) = 1:nrow(transcript)
    return(transcript)
}

# make it so I can write warning/messages and whatnot that respect the 80char
# limit in my script, but still look pretty when displayed.
.makepretty = function(x){
    msg = gsub('\n', ' ', x)
    msg = gsub('    ', '', msg)
    msg
}

#' constructor function for ballgown objects
#'
#' @name ballgown-constructor
#'
#' @param samples vector of file paths to folders containing sample-specific
#'   ballgown data (generated by \code{tablemaker}).  If \code{samples} is
#'   provided, \code{dataDir} and \code{samplePattern} are not used.
#' @param dataDir file path to top-level directory containing sample-specific
#'   folders with ballgown data in them.  Only used if \code{samples} is NULL.
#' @param samplePattern regular expression identifying the subdirectories of\
#'   \code{dataDir} containing data to be loaded into the ballgown object (and
#'   only those subdirectories).  Only used if \code{samples} is NULL.
#' @param bamfiles optional vector of file paths to read alignment files for
#'    each sample.  If provided, make sure to sort properly (e.g., in the same
#'    order as \code{samples}).  Default NULL.
#' @param pData optional \code{data.frame} with rows corresponding to samples and
#'    columns corresponding to phenotypic variables.
#' @param verbose if \code{TRUE}, print status messages and timing information
#'    as the object is constructed.
#' @param meas character vector containing either "all" or one or more of:
#'   "rcount", "ucount", "mrcount", "cov", "cov_sd", "mcov", "mcov_sd", or
#'   "FPKM". The resulting ballgown object will only contain the specified
#'   expression measurements, for the appropriate features. See vignette for
#'   which expression measurements are available for which features. "all"
#'   creates the full object.
#'
#' @details Because experimental data is recorded so variably, it is the user's
#'   responsibility to format \code{pData} correctly.  In particular, it's
#'   really important that the rows of \code{pData} (corresponding to samples)
#'   are ordered the same way as \code{samples} or the
#'   \code{dataDir}/\code{samplePattern} combo. You can run
#'   \code{list.files(path = dataDir, pattern = samplePattern)} to see the sample
#'   order if \code{samples} was not used.
#'
#' If you are creating a ballgown object for a large experiment, this function
#' may run slowly and use a large amount of RAM. We recommend running this
#' constructor as a batch job and saving the resulting ballgown object as an rda
#' file.  The rda file usually has reasonable size on disk, and the object in it
#' shouldn't take up too much RAM when loaded, so the time and memory use in
#' creating the object is a one-time cost.
#'
#' @return an object of class \code{ballgown}
#'
#' @author Leonardo Collado-Torres, Alyssa Frazee
#'
#' @rdname ballgown-constructor
#'
#' @seealso \code{\link{ballgownrsem}}, for loading RSEM output into a ballgown
#'   object
#' @export
#' @examples
#' bg = ballgown(dataDir=system.file('extdata', package='ballgown'),
#'     samplePattern='sample')
#' pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))
ballgown = function(samples=NULL, dataDir=NULL, samplePattern=NULL,
    bamfiles = NULL, pData = NULL, verbose=TRUE, meas="all"){
    if(verbose) message(date())

    if(all(c(is.null(samples),is.null(dataDir),is.null(samplePattern)))){
        stop(.makepretty('must provide either "samples" or both "dataDir" and
            "samplePattern"'))
    }

    if(length(setdiff(meas, c("rcount", "ucount", "mrcount", "cov", 
        "cov_sd", "mcov", "mcov_sd", "FPKM", "all"))) != 0){
        msg = 'meas can be either "all" or one or more of "rcount", 
            "ucount", "cov", "cov_sd", "mcov", "mcov_sd", or "FPKM". See
            vignette for details.'
        stop(.makepretty(msg))
    }
    if('all' %in% meas & length(meas) > 1){
        stop(.makepretty('when meas is "all", all types of measurements are
            included by default.'))
    }

    ## Determine where data is located
    if(is.null(samples)){
        if(is.null(samplePattern)|is.null(dataDir)){
            stop(.makepretty('must provide both "dataDir" and "samplePattern"
                if "samples" is NULL.'))
        }
        samples = list.files(path=dataDir, 
            pattern=samplePattern, full.names=TRUE)
        names(samples) = list.files(path=dataDir, pattern=samplePattern)
    }else{
        names(samples) = sapply(samples, function(x){
            tail(strsplit(x, split="/")[[1]],n=1)
        }, USE.NAMES=FALSE)
    }

    ## check to see if you actually have ballgown data:
    n = length(samples)
    subfiles = list.files(samples)
    ctabs = subfiles[subfiles %in% 
        c('e_data.ctab', 'i_data.ctab', 't_data.ctab', 'e2t.ctab', 'i2t.ctab')]
    if(length(ctabs) != 5*n){
        msg = 'Something is wrong: are you missing .ctab files? Do extra
        files/folders (other than tablemaker output folders) match your
        samples/dataDir/samplePattern argument(s)?'
        stop(.makepretty(msg))
    }

    ## Read tables linking exons/introns to transcripts
    if(verbose) message(paste0(date(), ": Reading linking tables"))
    e2t = read.table(list.files(samples[1], "e2t.ctab", full.names=TRUE), 
        header=TRUE, sep="\t", colClasses=c("integer", "integer"))
    i2t = read.table(list.files(samples[1], "i2t.ctab", full.names=TRUE), 
        header=TRUE, sep="\t", colClasses=c("integer", "integer"))

    ## Order by transcript id
    e2t = e2t[order(e2t$t_id), ]
    i2t = i2t[order(i2t$t_id), ]
    rownames(e2t) = 1:nrow(e2t)
    rownames(i2t) = 1:nrow(i2t)

    ## Read counts for all introns 
    if(verbose) message(paste0(date(), ": Reading intron data files"))

    # if intron data is requested:
    if( any(c('all', 'rcount', 'ucount', 'mrcount') %in% meas)){
        intronFiles = sapply(samples, list.files, pattern="i_data.ctab", 
            full.names=TRUE)
        intronAll = NULL
        for(f in intronFiles){
            ind = which(intronFiles == f)
            intronAll[[ind]] = .readIntron(f, meas)
        }

        ## Merge the intron results
        if(verbose) message(paste0(date(), ": Merging intron data"))
        #[ensure ctab files all contain same introns]
        sumdiff = sapply(intronAll, function(x){
            sum(x$i_id != intronAll[[1]]$i_id) 
        })
        if(!(all(sumdiff==0))){
            msg = 'intron ids were either not the same or not in the same order
                across samples. double check i_data.ctab for each sample.' 
            stop(.makepretty(msg))
        }

        idataOnly = lapply(intronAll, function(x) x[,-c(1:5)] )

        intron = data.frame(intronAll[[1]][,1:5], as.data.frame(idataOnly))
        if(identical(meas, 'all')){
            colnames(intron) = c('i_id', 'chr', 'strand', 'start', 'end', 
                paste(c('rcount', 'ucount', 'mrcount'), 
                    rep(names(samples), each=3), sep="."))
        }else{
            meas_avail = intersect(c('rcount', 'ucount', 'mrcount'), meas) 
            #^order important! meas has to go after rcount/ucount/mrcount 
            #^because of file order. intersect() keeps in order of first thing.
            colnames(intron) = c('i_id', 'chr', 'strand', 'start', 'end',
                paste(meas_avail, rep(names(samples), each=length(meas_avail)), 
                    sep="."))
        }
    } else { # no intron data requested:
        f1 = list.files(samples[1], pattern='i_data.ctab', full.names=TRUE)
        intron = .readIntron(f1, meas)
        stopifnot(ncol(intron) == 5)
    }

    ## Make intron data into GRanges object
    #A. fix strand information for compatibility w/ GRanges
    intron$strand = as.character(intron$strand)
    intron$strand[intron$strand=="."] <- "*"
    #B. get names of transcripts each intron belongs to
    tnamesin = split(i2t$t_id, i2t$i_id)
    tnamesin.ord = as.character(tnamesin)[match(intron$i_id, names(tnamesin))]
    #C. make the GRanges object
    introngr = GRanges(seqnames=Rle(intron$chr), 
        ranges=IRanges(start=intron$start, end=intron$end),
        strand = Rle(intron$strand), 
        id=intron$i_id, 
        transcripts = tnamesin.ord)

    ## Read exon data
    if(verbose) message(paste0(date(), ": Reading exon data files"))

    # if any exon data is requested:
    emeas = c('all', 'rcount', 'ucount', 'mrcount', 'cov', 'cov_sd', 'mcov', 
        'mcov_sd')
    if( any(emeas %in% meas)){
        exonFiles = sapply(samples, list.files, pattern="e_data.ctab", 
            full.names=TRUE)
        exonAll = NULL
        for(f in exonFiles){
            ind = which(exonFiles == f)
            exonAll[[ind]] = .readExon(f, meas)
        }

        ## Merge the exon results
        if(verbose) message(paste0(date(), ": Merging exon data"))
        #[ensure ctab files all contain same exons]
        sumdiffex = sapply(exonAll, function(x){
            sum(x$e_id != exonAll[[1]]$e_id)
        })
        if(!(all(sumdiffex==0))){
            stop(.makepretty('exon ids were either not the same or not in the
                same order across samples. double check e_data.ctab for each
                sample.'))
        }

        edataOnly = lapply(exonAll, function(x) x[,-c(1:5)])
        exon = data.frame(exonAll[[1]][,1:5], as.data.frame(edataOnly))
        if(identical(meas, 'all')){
            colnames(exon) = c('e_id', 'chr', 'strand', 'start', 'end', 
                paste(emeas[-1], rep(names(samples), each=7), sep="."))
        }else{
            meas_avail = intersect(emeas[-1], meas) 
            #^order important! 
            colnames(exon) = c('e_id', 'chr', 'strand', 'start', 'end',
                paste(meas_avail, rep(names(samples), each=length(meas_avail)), 
                    sep="."))
        }
    } else { # no exon data requested:
        f1 = list.files(samples[1], pattern='e_data.ctab', full.names=TRUE)
        exon = .readExon(f1, meas)
        stopifnot(ncol(exon) == 5)
    }

    ## Make exon data into GRanges object
    #A. fix strand information for compatibility w/ GRanges
    exon$strand = as.character(exon$strand)
    exon$strand[exon$strand=="."] <- "*"
    #B. get names of transcripts each exon belongs to
    tnamesex = split(e2t$t_id, e2t$e_id)
    #C. make the GRanges object
    tnamesex.ord = as.character(tnamesex)[match(exon$e_id, names(tnamesex))]
    exongr = GRanges(seqnames=Rle(exon$chr), 
        ranges=IRanges(start=exon$start, end=exon$end), 
        strand=Rle(exon$strand), 
        id=exon$e_id, 
        transcripts=tnamesex.ord)

    ## Read transcript data
    if(verbose) message(paste0(date(), ": Reading transcript data files"))

    # if any transcript data requested:
    if( any(c('all', 'cov', 'FPKM') %in% meas)){
        tFiles = sapply(samples, list.files, pattern="t_data.ctab", 
            full.names=TRUE)
        tAll = NULL
        for(f in tFiles){
            ind = which(tFiles == f)
            tAll[[ind]] = .readTranscript(f, meas)
        }

        ## Merge the transcript results
        if(verbose) message(paste0(date(), ": Merging transcript data"))
        #[ensure ctab files all contain same transcripts]
        sumdifft = sapply(tAll, function(x) sum(x$t_id != tAll[[1]]$t_id))
        if(!(all(sumdifft==0))){
            msg = 'Transcript ids were either not the same or not in the same
                order across samples. Double check t_data.ctab for each sample.'
            stop(.makepretty(msg))
        }

        tdataOnly = lapply(tAll, function(x) x[,-c(1:10)])
        transcript = data.frame(tAll[[1]][,1:10], as.data.frame(tdataOnly))
        if(identical(meas, 'all')){
            colnames(transcript) = c('t_id', 'chr', 'strand', 'start', 'end', 
                't_name', 'num_exons', 'length', 'gene_id', 'gene_name', 
                paste(c('cov', 'FPKM'), rep(names(samples), each=2), sep="."))
        }else{
            meas_avail = intersect(c('cov', 'FPKM'), meas) 
            #^order important!
            colnames(transcript) = c('t_id', 'chr', 'strand', 'start', 'end', 
                't_name','num_exons', 'length', 'gene_id', 'gene_name',
                paste(meas_avail, rep(names(samples), each=length(meas_avail)),
                    sep="."))
        }
    } else { # no transcript data requested:
        f1 = list.files(samples[1], pattern='t_data.ctab', full.names=TRUE)
        transcript = .readTranscript(f1, meas)
        stopifnot(ncol(transcript) == 10)
    }

    ## Make transcripts into a GRanges list object
    mm = match(e2t$e_id, mcols(exongr)$id)
    if(any(is.na(mm))){
        warning(paste('the following exon(s) did not appear in e_data.ctab:',
        paste(e2t$e_id[which(is.na(mm))], collapse=", ")))
    }
    tgrl = split(exongr[mm[!is.na(mm)]], e2t$t_id[!is.na(mm)])

    ## Connect transcripts to genes:
    t2g = data.frame(t_id = transcript$t_id, g_id = transcript$gene_id)

    ## Read phenotype table, if given:
    stopifnot(is.null(pData) | class(pData) == 'data.frame')
    if(!is.null(pData)){
        if(!all(pData[,1] == names(samples))){
            msg = 'Rows of pData did not seem to be in the same order as the
                columns of the expression data. Attempting to rearrange
                pData...'
            warning(.makepretty(msg))
            tmp = try(pData <- pData[,match(names(samples), pData[,1])], 
                silent=TRUE)
            if(class(tmp) == "try-error"){
                msg = 'first column of pData does not match the names of the
                    folders containing the ballgown data.'
                stop(.makepretty(msg))
            }else{
                message('successfully rearranged!')
            }
        }
    }

    if(verbose) message('Wrapping up the results')
    result = new('ballgown', 
        expr=list(intron=intron, exon=exon, trans=transcript), 
        indexes=list(e2t=e2t, i2t=i2t, t2g=t2g, bamfiles=bamfiles, pData=pData),
        structure=list(intron=introngr, exon=exongr, trans=tgrl), 
        dirs=samples, mergedDate=date(), meas=meas, RSEM=FALSE)

    if(verbose) message(date())
    return(result)
}

context('test ballgown constructor + slots')

## need to load object first
## this will test constructor, pData, pData<-, and sampleNames for errors...
bg = ballgown(dataDir=system.file('extdata', package='ballgown'),
    samplePattern='sample', verbose=FALSE)
pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))
suppressMessages(library(GenomicRanges))

test_that('all slots are present and have correct class', {
    expect_that(bg@expr, is_a('list'))
    expect_that(bg@structure, is_a('list'))
    expect_that(bg@indexes, is_a('list'))

    expect_that(bg@expr$exon, is_a('data.frame'))
    # expect_that(eexpr(bg), is_a('matrix'))
    expect_that(bg@expr$trans, is_a('data.frame'))
    # expect_that(texpr(bg), is_a('matrix'))
    expect_that(bg@expr$intron, is_a('data.frame'))
    # expect_that(iexpr(bg), is_a('matrix'))

    expect_that(bg@structure$exon, is_a('GRanges'))
    expect_that(bg@structure$intron, is_a('GRanges'))
    expect_that(bg@structure$trans, is_a('GRangesList'))

    expect_that(bg@indexes$e2t, is_a('data.frame'))
    expect_that(bg@indexes$i2t, is_a('data.frame'))
    expect_that(bg@indexes$t2g, is_a('data.frame'))
    expect_that(bg@indexes$pData, is_a('data.frame'))
    expect_that(bg@indexes$bamfiles, is_identical_to(NULL))

    expect_that(sampleNames(bg), is_a('character'))
})

test_that('expression data is read accurately', {
    expect_that(dim(texpr(bg)), is_equivalent_to(c(100, 20)))
    expect_that(ncol(texpr(bg, 'all')), equals(50))
    expect_that(dim(eexpr(bg)), is_equivalent_to(c(633, 20)))
    expect_that(ncol(eexpr(bg, 'all')), equals(145))
    expect_that(dim(iexpr(bg)), is_equivalent_to(c(536, 20)))
    expect_that(ncol(iexpr(bg, 'all')), equals(65))
    expect_that(texpr(bg)[29, 11], equals(171.12))
    expect_that(eexpr(bg)[9, 19], equals(21))
    expect_that(iexpr(bg, 'ucount')[89, 2], equals(8))
})

test_that('indexes are read accurately', {
    expect_that(dim(indexes(bg)$t2g), is_equivalent_to(c(100, 2)))
    expect_that(indexes(bg)$t2g$t_id[19], equals(258))
    expect_that(dim(indexes(bg)$e2t), is_equivalent_to(c(684, 2)))
    expect_that(indexes(bg)$e2t$t_id[131], equals(377))
    expect_that(dim(indexes(bg)$i2t), is_equivalent_to(c(584, 2)))
    expect_that(indexes(bg)$i2t$i_id[512], equals(2627))
})

test_that('structure information is read accurately', {
    expect_that(length(structure(bg)$intron), equals(536))
    expect_that(start(ranges(structure(bg)$intron))[56], equals(22285664))
    expect_that(length(structure(bg)$exon), equals(633))
    expect_that(end(ranges(structure(bg)$exon))[194], equals(29747255))
    expect_that(length(structure(bg)$trans), equals(100))
    expect_that(width(ranges(structure(bg)$trans[[7]]))[3], equals(159))
})

#' read in gtf file as GRanges object
#' 
#' (very) light wrapper for rtracklayer::import
#'  
#' @param gtf name of GTF/GFF file on disk
#' @param splitByTranscript if \code{TRUE}, return a \code{GRangesList} of
#'    transcripts; otherwise return a \code{GRanges} object containing all
#'    genomic features in \code{gtf}. Default \code{FALSE}.
#' @param identifier name of transcript identifier column of \code{attributes}
#'    field in \code{gtf}. Default \code{"transcript_id"}. Only used if
#'    \code{splitByTranscript} is \code{TRUE}.
#' @param sep field separator in the \code{attributes} field of \code{gtf}. 
#'    Default \code{"; "} (semicolon + space). Only used if 
#'    \code{splitByTranscript} is \code{TRUE}.
#' 
#' @return if \code{splitByTranscript} is \code{FALSE}, an object of class 
#'    \code{GRanges} representing the genomic features in \code{gtf}. If 
#'    \code{splitByTranscript} is TRUE, an object of class \code{GRangesList}, 
#'    where each element is a \code{GRanges} object corresponding to an 
#'    annotated transcript (designated in \code{names}).
#' 
#' @seealso \code{\link{gffRead}} for reading in a GTF file as a data frame
#'    rather than a \code{GRanges}/\code{GRangesList} object.
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' 
#' @examples
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' 
#' # read in exons as GRanges:
#' annotgr = gffReadGR(gtfPath)
#' 
#' # read in groups of exons as transcripts, in GRangesList:
#' transcripts_grl = gffReadGR(gtfPath, splitByTranscript=TRUE)
#' 
gffReadGR = function(gtf, splitByTranscript=FALSE, identifier='transcript_id', 
    sep='; '){
    con = file(gtf)
    ret = suppressWarnings(import(con, format='GFF'))
    if(splitByTranscript){
        split_col_i = which(names(mcols(ret)) == identifier)
        exons = ret[ret$type == 'exon',]
        ret = split(exons, mcols(exons)[,split_col_i]) 
    }
    return(ret)
}

#' @title subset ballgown objects using an expression filter
#' 
#' @description Create a new ballgown object containing only transcripts passing
#'   a mean expression filter
#' @param gown a ballgown object
#' @param cutoff transcripts must have mean expression across samples above this
#'   value to be included in the return
#' @param meas how should transcript expression be measured? Default FPKM, but 
#'   can also be \code{'cov'}.
#' @export
#' @seealso \code{\link{subset}}
#' @return A new ballgown object derived from \code{gown}, but only containing 
#'   transcripts (and associated exons/introns) with mean \code{meas} greater
#'   than \code{cutoff} across all samples.
#' @examples
#'   data(bg)
#'   # make a ballgown object containing only transcripts with mean FPKM > 100:
#'   over100 = exprfilter(bg, cutoff=100)  
#'
exprfilter = function(gown, cutoff, meas='FPKM'){
    e_id = t_id = i_id = NULL #prep for use in subset function / R CMD CHECK
    meas = match.arg(meas, c('FPKM', 'cov'))

    stopifnot(gown@meas == 'all' | meas %in% gown@meas)

    means = rowMeans(texpr(gown, meas))
    hiexpr_index = which(means > cutoff)
    trans = texpr(gown, 'all')[hiexpr_index,]
    thetx = trans$t_id

    inttmp = split(indexes(gown)$i2t$i_id, indexes(gown)$i2t$t_id)
    theint = as.numeric(unique(unlist(inttmp[names(inttmp) %in% thetx])))
    intron = subset(expr(gown)$intron, i_id %in% theint)

    extmp = split(indexes(gown)$e2t$e_id, indexes(gown)$e2t$t_id)
    theex = as.numeric(unique(unlist(extmp[names(extmp) %in% thetx])))
    exon = subset(expr(gown)$exon, e_id %in% theex)

    e2t = subset(indexes(gown)$e2t, t_id %in% thetx)
    i2t = subset(indexes(gown)$i2t, t_id %in% thetx)
    t2g = subset(indexes(gown)$t2g, t_id %in% thetx)

    introngr = structure(gown)$intron[elementMetadata(structure(gown)$intron)$id
        %in% theint]
    exongr = structure(gown)$exon[elementMetadata(structure(gown)$exon)$id 
        %in% theex]
    transgrl = structure(gown)$trans[names(structure(gown)$trans) %in% thetx]
    return(new('ballgown', 
        expr=list(intron=intron, exon=exon, trans=trans), 
        indexes=list(e2t=e2t, i2t=i2t, t2g=t2g, 
            bamfiles=indexes(gown)$bamfiles, pData=indexes(gown)$pData), 
        structure=list(intron=introngr, exon=exongr, trans=transgrl), 
        dirs=dirs(gown), mergedDate=mergedDate(gown), RSEM=gown@RSEM, 
        meas=gown@meas))
}

## function that returns 2nd half of expression column names
## (regardless of whether they have '.' in them)
half2 = function(x) paste(x[-1], collapse='.')


#' subset ballgown objects to specific samples or genomic locations
#' 
#' @name subset
#' @exportMethod subset
#' @docType methods
#' @rdname subset
#' @aliases subset,ballgown-method
#' @param x a ballgown object
#' @param cond Condition on which to subset. See details.
#' @param genomesubset if TRUE, subset \code{x} to a specific part of the 
#'   genome. Otherwise, subset x to only include specific samples. TRUE by 
#'   default.
#' @return a subsetted ballgown object, containing only the regions or samples
#'   satisfying \code{cond}.
#' 
#' @details To use \code{subset}, you must provide the \code{cond} argument as a
#'   string representing a logical expression specifying your desired subset.
#'   The subset expression can either involve column names of
#'   \code{texpr(x, "all")} (if \code{genomesubset} is \code{TRUE}) or of 
#'   \code{pData(x)} (if \code{genomesubset} is \code{FALSE}). For example, if
#'   you wanted a ballgown object for only chromosome 22, you might call 
#'   \code{subset(x, "chr == 'chr22'")}. (Be sure to handle quotes within
#'   character strings appropriately). 
#' 
#' @author Alyssa Frazee
#' 
#' @examples
#' data(bg)
#' bg_twogenes = subset(bg, "gene_id=='XLOC_000454' | gene_id=='XLOC_000024'")
#' bg_twogenes 
#' # ballgown instance with 4 assembled transcripts and 20 samples
#' 
#' bg_group0 = subset(bg, "group == 0", genomesubset=FALSE)
#' bg_group0 
#' # ballgown instance with 100 assembled transcripts and 10 samples
setMethod("subset", "ballgown", function(x, cond, genomesubset=TRUE){
    stopifnot(class(cond) == 'character')

    # if you are subsetting by something in the genome (say, a chromosome):
    if(genomesubset){
        trans = subset(expr(x)$trans, eval(parse(text=cond)))  
        thetx = trans$t_id
    
        inttmp = split(indexes(x)$i2t$i_id, indexes(x)$i2t$t_id)
        theint = as.numeric(unique(unlist(inttmp[names(inttmp) %in% thetx])))
        intron = subset(expr(x)$intron, i_id %in% theint)
    
        extmp = split(indexes(x)$e2t$e_id, indexes(x)$e2t$t_id)
        theex = as.numeric(unique(unlist(extmp[names(extmp) %in% thetx])))
        exon = subset(expr(x)$exon, e_id %in% theex)
    
        e2t = subset(indexes(x)$e2t, t_id %in% thetx)
        i2t = subset(indexes(x)$i2t, t_id %in% thetx)
        t2g = subset(indexes(x)$t2g, t_id %in% thetx)
    
        introngr = structure(x)$intron[elementMetadata(structure(x)$intron)$id 
            %in% theint]
        exongr = structure(x)$exon[elementMetadata(structure(x)$exon)$id 
            %in% theex]
        grltxids = as.numeric(names(structure(x)$trans))
        transgrl = structure(x)$trans[grltxids %in% thetx]
    
        return(new("ballgown", expr=list(intron=intron, exon=exon, trans=trans),
            indexes=list(e2t=e2t, i2t=i2t, t2g=t2g, 
                bamfiles=indexes(x)$bamfiles, pData=indexes(x)$pData), 
            structure=list(intron=introngr, exon=exongr, trans=transgrl), 
            dirs=dirs(x), mergedDate=mergedDate(x), meas=x@meas, RSEM=x@RSEM))
    }else{
        # you're doing a phenotype subset
        # structure, some indexes, dirs, and mergedDate stay the same
        # change: data, indexes(pData), and indexes(bamfiles)
        
        ## pData
        newpd = subset(pData(x), eval(parse(text=cond)))
        newpd = droplevels(newpd)
        
        ## bamfiles
        newsampnames = newpd[,1]
        rowIndsToKeep = which(pData(x)[,1] %in% newsampnames)
        if(!is.null(indexes(x)$bamfiles)){
            newbamfiles = indexes(x)$bamfiles[rowIndsToKeep]
        }else{
            newbamfiles = NULL
        }

        ## transcript data
        txcolsamples = sapply(strsplit(names(texpr(x, 'all')), '\\.'), half2)
        txKeepCols = c(1:10, which(txcolsamples %in% newsampnames))
        newtdat = texpr(x, 'all')[,txKeepCols]

        ## exon data
        excolsamples = sapply(strsplit(names(eexpr(x, 'all')), '\\.'), half2)
        exKeepCols = c(1:5, which(excolsamples %in% newsampnames))
        newedat = eexpr(x, 'all')[,exKeepCols]

        ## intron data
        icolsamples = sapply(strsplit(names(iexpr(x, 'all')), '\\.'), half2)
        iKeepCols = c(1:5, which(icolsamples %in% newsampnames))
        newidat = iexpr(x, 'all')[,iKeepCols]

        return(new("ballgown", 
            expr=list(intron=newidat, exon=newedat, trans=newtdat), 
            indexes=list(e2t=indexes(x)$e2t, i2t=indexes(x)$i2t,
                t2g=indexes(x)$t2g, bamfiles=newbamfiles, pData=newpd), 
            structure=list(intron=structure(x)$intron, exon=structure(x)$exon, 
                trans=structure(x)$trans),
            dirs=dirs(x)[rowIndsToKeep], mergedDate=mergedDate(x), 
            meas=x@meas, RSEM=x@RSEM))
    }
} )

#' extract exon-level expression measurements from ballgown objects
#' 
#' @name eexpr
#' @exportMethod eexpr
#' @docType methods
#' @rdname eexpr
#' @aliases eexpr,ballgown-method
#' @param x a ballgown object
#' @param meas type of measurement to extract. Can be "rcount", "ucount", 
#'   "mrcount", "cov", "mcov", or "all". Default "rcount".
#' @return exon-by-sample matrix containing exon-level expression values
#'   (measured by \code{meas}). If \code{meas} is \code{"all"}, or 
#'   \code{x@@RSEM} is TRUE, a data frame is returned, containing all
#'   measurements and location information.
#' 
#' @examples 
#' data(bg)
#' exon_rcount_matrix = eexpr(bg)
#' exon_ucount_matrix = eexpr(bg, 'ucount')
#' exon_data_frame = eexpr(bg, 'all')
setMethod('eexpr', 'ballgown', function(x, meas='rcount'){
    if(x@RSEM){
        return(expr(x)$exon)
    }
    emeas = c('all', 'rcount', 'ucount', 'mrcount', 'cov', 'mcov', 'cov_sd', 
        'mcov_sd')
    meas = match.arg(meas, emeas)
    if(meas!='all'){
        if(!identical(x@meas, 'all')){
            if(!(meas %in% x@meas)){
                meas_avail = paste(c(intersect(x@meas, emeas), 'all'), 
                    collapse=', ')
                msg = paste(meas, 'measurements were not included when this
                    ballgown object was created. Instead, you can use eexpr
                    with these measurements:', meas_avail)
                stop(.makepretty(msg))
            }
        }
        mat = expr(x)$exon[,-c(1:5)]
        mat = subset(mat, select=paste(meas, sampleNames(x), sep='.'))
        rownames(mat) = expr(x)$exon$e_id
        mat = as.matrix(mat)
    }else{
        if(!any(emeas[-1] %in% x@meas) & !identical(x@meas, 'all')){
            msg = 'No exon-level expression measurements are included in this
                    ballgown object. Returning data frame of all exons\' genomic
                    coordinates.'
            warning(.makepretty(msg))
        }
        mat = expr(x)$exon
    }
    return(mat)
})

#' extract transcript-level expression measurements from ballgown objects
#' 
#' @name texpr
#' @exportMethod texpr
#' @docType methods
#' @rdname texpr
#' @aliases texpr,ballgown-method
#' @param x a ballgown object
#' @param meas type of measurement to extract. Can be "cov", "FPKM", or "all". 
#'   Default "FPKM".
#' @return transcript-by-sample matrix containing expression values (measured by
#'   \code{meas}). If \code{meas} is \code{"all"}, a data frame is returned, 
#'   containing all measurements and location information.
#' 
#' @examples
#' data(bg)
#' transcript_fpkm_matrix = texpr(bg)
#' transcript_data_frame = texpr(bg, 'all')
setMethod('texpr', 'ballgown', function(x, meas='FPKM'){
    if(x@RSEM){
        meas = match.arg(meas, c('TPM', 'FPKM', 'all'))
    }else{
        meas = match.arg(meas, c('cov', 'FPKM', 'all'))
    }
    if(meas!='all'){
        if(!identical(x@meas, 'all')){
            if(!(meas %in% x@meas)){
                meas_avail = paste(c(intersect(x@meas, c('cov', 'FPKM', 'TPM')),
                    'all'), collapse=', ')
                msg = paste(meas, 'measurements were not included when this
                    ballgown object was created. Instead, you can use texpr with
                    these measurements:', meas_avail)
                stop(.makepretty(msg))
            }
        }
        mat = expr(x)$trans[,-c(1:10)]
        mat = subset(mat, select=paste(meas, sampleNames(x), sep='.'))
        rownames(mat) = expr(x)$trans$t_id
        mat = as.matrix(mat)
    }else{
        if(!any(c('cov', 'FPKM', 'TPM') %in% x@meas) & 
                !identical(x@meas, 'all')){
            msg = 'No transcript-level expression measurements are included in
            this ballgown object. Returning data frame of transcript structure
            information.'
            warning(.makepretty(msg))
        }
        mat = expr(x)$trans
    }
    return(mat)
})

#' extract transcript-level expression measurements from ballgown objects
#' 
#' @name iexpr
#' @exportMethod iexpr
#' @docType methods
#' @rdname iexpr
#' @aliases iexpr,ballgown-method
#' @param x a ballgown object
#' @param meas type of measurement to extract. Can be "rcount", "ucount", 
#'   "mrcount", or "all". Default "rcount".
#' @return intron-by-sample matrix containing the number of reads (measured as
#'   specified by \code{meas}) supporting each intron, in each sample. If
#'   \code{meas} is \code{"all"}, a data frame is returned, containing all
#'   measurements and location information.
#' 
#' @examples
#' data(bg)
#' intron_rcount_matrix = iexpr(bg)
#' intron_data_frame = iexpr(bg, 'all')
setMethod('iexpr', 'ballgown', function(x, meas='rcount'){
    if(x@RSEM){
        return(expr(x)$intron)
    }
    meas = match.arg(meas, c('rcount', 'ucount', 'mrcount', 'all'))
    if(meas!='all'){
        if(!identical(x@meas, 'all')){
            if(!(meas %in% x@meas)){
                meas_avail = paste(c(intersect(x@meas, 
                    c('rcount', 'ucount', 'mrcount')), 'all'), collapse=', ')
                msg = paste(meas, 'measurements were not included when this
                    ballgown object was created. Instead, you can use iexpr with
                    these measurements:', meas_avail)
                stop(.makepretty(msg))
            }
        }
        mat = expr(x)$intron[,-c(1:5)]
        mat = subset(mat, select=paste(meas, sampleNames(x), sep='.'))
        rownames(mat) = expr(x)$intron$i_id
        mat = as.matrix(mat)
    }else{
        if(!any(c('ucount', 'rcount', 'mrcount') %in% x@meas) & 
            !identical(x@meas, 'all')){
            msg = 'No intron-level expression measurements are included in this
            ballgown object. Returning data frame of all introns\' genomic
            coordinates.'
            warning(.makepretty(msg))
        }
        mat = expr(x)$intron
    }
    return(mat)
})

#' extract gene-level expression measurements from ballgown objects
#' 
#' For objects created with Cufflinks/Tablemaker, gene-level measurements are 
#'   calculated by appropriately combining FPKMs from the transcripts comprising
#'   the gene. For objects created with RSEM, gene-level measurements are
#'   extracted directly from the RSEM output.
#'
#' @name gexpr
#' @exportMethod gexpr
#' @docType methods
#' @rdname gexpr
#' @aliases gexpr,ballgown-method
#' @param x a ballgown object
#' @return gene-by-sample matrix containing per-sample gene measurements.
#' 
#' @examples
#' data(bg)
#' gene_matrix = gexpr(bg)
setMethod('gexpr', 'ballgown', function(x){
    if(x@RSEM){
        return(expr(x)$gm)
    }else{
        if(!('FPKM' %in% x@meas) & !identical(x@meas, 'all')){
            msg = 'gene expression measurements can only be calculated for
            ballgown objects including transcript-level FPKM values.' 
            stop(.makepretty(msg))
        }
        gnames = as.character(indexes(x)$t2g$g_id)
        inds_by_gene = split(seq(along=gnames), gnames)
        tmeas = texpr(x, "FPKM")
        gid_by_exon = lapply(1:nrow(tmeas), function(i){
            rep(texpr(x, 'all')$gene_id[i], texpr(x, 'all')$num_exons[i])})
        ulstruct = unlist(structure(x)$trans)
        glist = split(ulstruct, unlist(gid_by_exon))
        glengths = sapply(width(reduce(glist)), sum)
        tlengths = sapply(width(structure(x)$trans), sum)
        tfrags = tlengths * tmeas
        mat = lapply(1:length(inds_by_gene), function(i){
            colSums(tfrags[inds_by_gene[[i]],,drop=FALSE]) / glengths[i]})
        mat = do.call(rbind, mat)
        rownames(mat) = names(inds_by_gene)
        return(mat)
    }
})

#' extract a specific field of the "attributes" column of a data frame created 
#' from a GTF/GFF file
#'
#' @param x vector representing the "attributes" column of GTF/GFF file
#' @param field name of the field you want to extract from the "attributes" 
#'   column
#' @param attrsep separator for the fields in the attributes column.  Defaults
#'   to '; ', the separator for GTF files outputted by Cufflinks.
#' 
#' @return vector of nucleotide positions included in the transcript
#' 
#' @seealso \code{\link{gffRead}} for creating a data frame from a GTF/GFF file,
#'   and \url{http://useast.ensembl.org/info/website/upload/gff.html} for
#'   specifics of the GFF/GTF file format.
#' 
#' @author Wolfgang Huber, in the \code{davidTiling} R package (LGPL license)
#' 
#' @export
#' @examples
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' gffdata = gffRead(gtfPath)
#' gffdata$transcriptID = getAttributeField(gffdata$attributes, 
#'   field = "transcript_id")
getAttributeField <- function (x, field, attrsep = "; ") 
{
    s = strsplit(x, split = attrsep, fixed = TRUE)
    sapply(s, function(atts) {
        a = strsplit(atts, split = " ", fixed = TRUE)
        m = match(field, sapply(a, "[", 1))
        if (!is.na(m)) {
            rv = a[[m]][2]
        }
        else {
            rv = as.character(NA)
        }
        return(rv)
    })
}

### https://stat.ethz.ch/pipermail/bioconductor/2008-October/024669.html

#' @name bg
#' @title Toy ballgown object
#' @description Small ballgown object created with simulated toy data, for
#'   demonstration purposes
#' @docType data
#' @format a \code{ballgown} object: 100 transcripts, 633 exons, 536 introns
#' @author Alyssa Frazee
#' @examples
#' data(bg)
#' bg
#' # ballgown instance with 100 transcripts and 20 samples
NULL

#' determine if one set of GRanges fully contains any of another set of GRanges
#' 
#' @param transcripts \code{GRangesList} object (assume for now that it
#'    represents transcripts)
#' @param cds \code{GRangesList} object (assume for now that it represents sets
#'    of coding sequences)
#' 
#' @details If \code{gown} is a \code{ballgown} object, \code{transcripts} can
#'    be \code{structure(gown)$trans} (or any subset). 
#' 
#' @return vector with length equal to \code{length(transcripts)}, where each
#'    entry is \code{TRUE} if the corresponding transcript contains a coding
#'    sequence (i.e., is a superset of at least one entry of \code{cds}). 
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' 
#' @examples
#' ## pretend this annotation is coding sequence:
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' annot = gffReadGR(gtfPath, splitByTranscript=TRUE)
#' data(bg)
#' results = contains(structure(bg)$trans, annot)
#' # results is a boolean vector
#' sum(results) #61
contains = function(transcripts, cds){

    stopifnot(is(transcripts, "GRangesList"), is(cds, "GRangesList"))


    # things will get out of order: keep track
    names_transcripts = names(transcripts)
    names_cds = names(cds)

    # get rid of metadata:
    transcriptsUL = unlist(transcripts)
    mcols(transcriptsUL) = NULL
    transcripts = split(transcriptsUL, names(transcriptsUL))
    transcripts = transcripts[match(names_transcripts, names(transcripts))]

    # for assembly: get rid of metadata
    cdsUL = unlist(cds)
    mcols(cdsUL) = NULL
    cds = split(cdsUL, names(cdsUL))
    cds = cds[match(names_cds, names(cds))]

    # find the overlaps:
    ol = findOverlaps(transcripts, cds)

    # get lists of corresponding assembled/annotated transcripts:
    transcripts_sort = transcripts[queryHits(ol)]
    cds_sort = cds[subjectHits(ol)]

    # concatenate the appropriate GRanges objects (for overlapping transcripts)
    transcripts_overlapIDs = rep(1:length(ol), 
        times=elementNROWS(transcripts_sort))
    cds_overlapIDs = rep(1:length(ol), times=elementNROWS(cds_sort))
    all_transcripts = c(unlist(transcripts_sort), unlist(cds_sort))
    overlapping = split(all_transcripts, 
        c(transcripts_overlapIDs, cds_overlapIDs))
    
    # decide on containment:
    stopifnot(all(as.numeric(names(overlapping)) == 1:length(ol)))
    # names(overlapping) = 1:length(ol), 
    # corresponds to overlap IDs (confirmed in above check) 
    coverages = coverage(ranges(overlapping))
    runvals = runValue(coverages)
    runlengths = runLength(coverages)
    cds_lengths = sapply(width(cds_sort), sum)
    containsCDS = sum(runlengths[runvals==2]) == cds_lengths

    # return data in right order:
    allOL = split(containsCDS, queryHits(ol))
    ret = rep(FALSE, length(transcripts))
    ret[as.numeric(names(allOL))] = sapply(allOL, any)
    return(ret)
}

#' calculate percent overlap between two GRanges objects
#'
#' @param tx1 GRanges object
#' @param tx2 GRanges object
#' 
#' @return percent overlap between \code{tx1} and \code{tx2}, as defined by the 
#'   ratio of the intersection of \code{tx1} and \code{tx2} to the union of 
#'   \code{tx1} and \code{tx2}. 
#' 
#' @details In the ballgown context, \code{tx1} and \code{tx2} are two
#'   transcripts, each represented by GRanges objects whose ranges represent the
#'   exons comprising the transcripts.  The percent overlap is the number of 
#'   nucleotides falling within both transcripts divided by the number of 
#'   nucleotides falling within either transcript.  Useful as a measure of 
#'   transcript closeness (as it is essentially Jaccard distance).

#' @author Alyssa Frazee

#' @export
#' 
#' @examples
#' data(bg)
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' annot_grl = gffReadGR(gtfPath, splitByTranscript=TRUE)
#' pctOverlap(structure(bg)$trans[[2]], annot_grl[[369]]) #79.9%
pctOverlap = function(tx1, tx2){
    stopifnot(class(tx1) == 'GRanges' & class(tx2) == 'GRanges')
    ch1 = as.character(runValue(seqnames(tx1)))
    ch2 = as.character(runValue(seqnames(tx2)))
    if(ch1 != ch2){
        return(0)
    }
    tmp1 = reduce(tx1)
    tmp2 = reduce(tx2)
    if(!identical(ranges(tmp1), ranges(tx1))){
        warning('tx1 contained overlapping ranges and was reduced.')
        tx1 = tmp1
    }
    if(!identical(ranges(tmp2), ranges(tmp2))){
        warning('tx2 contained overlapping ranges and was reduced.')
        tx2 = tmp2
    }
    mcols(tx1) = NULL
    mcols(tx2) = NULL # take away metadata
    ntcov = coverage(c(tx1, tx2))
    ind = which(names(ntcov)==ch1)
    covrle = ntcov[[ind]]
    covrle_val = runValue(covrle)
    covrle_len = runLength(covrle)
    return(sum(covrle_len[covrle_val==2]) / sum(covrle_len[covrle_val==1 | 
        covrle_val == 2]))
}

#' Ballgown
#'
#' S4 class for storing and manipulating expression data from assembled
#' transcriptomes
#'
#' @aliases Ballgown
#'
#' @slot expr tables containing expression data for genomic features (introns,
#' exons, transcripts)
#' @slot structure genomic locations of features and their relationships to one
#'   another
#' @slot indexes tables connecting components of the assembly and providing
#'   other experimental
#' information (e.g., phenotype data and locations of read alignment files)
#' @slot dirs directories holding data created by \code{tablemaker}
#' @slot mergedDate date the ballgown object was created
#' @slot meas which expression measurement(s) the object contains in its data
#'   slot. Vector of one or more of "rcount", "ucount", "mrcount", "cov",
#'   "cov_sd", "mcov", "mcov_sd", or "FPKM", if Tablemaker output is used, or
#'   one of "TPM" or "FPKM" if RSEM output is used. Can also be "all" for all
#'   measurements. See vignette for details.
#' @slot RSEM TRUE if object was made from RSEM output, FALSE if object was made
#'   from Tablemaker/Cufflinks output.
#'
#' @name ballgown-class
#'
#' @rdname ballgown-class
#'
#' @exportClass ballgown
#'
#' @author Alyssa Frazee, Leonardo Collado-Torres, Jeff Leek
#' @examples
#'   data(bg)
#'   class(bg) #"ballgown"
#'   dim(bg@@expr$exon)
#'   bg@@structure$exon
#'   head(bg@@indexes$t2g)
#'   head(bg@@dirs)
#'   bg@@mergedDate
#'   bg@@meas
#'   bg@@RSEM
setClass("ballgown",
    representation(
        expr = "list",             # coverage data
        indexes = "list",          # reference information
        structure = "list",        # assembly information
        dirs = "character",        # directories where ballgown data is stored
        mergedDate = "character",  # date the object was created
        meas = "character",        # what measurements are in the object
        RSEM = "logical"           # TRUE if made from RSEM output
    )
)

### define generics for ballgown class 

#' @name structure
#' @export
#' @docType methods
#' @rdname structure
setGeneric("structure", function(x) standardGeneric("structure"))

#' @name expr
#' @export
#' @docType methods
#' @rdname expr
setGeneric("expr", function(x) standardGeneric("expr"))

#' @name indexes
#' @export
#' @docType methods
#' @rdname indexes
setGeneric("indexes", function(x) standardGeneric("indexes"))

#' @name dirs
#' @export
#' @docType methods
#' @rdname dirs
setGeneric("dirs", function(x) standardGeneric("dirs"))

#' @name sampleNames
#' @export
#' @docType methods
#' @rdname sampleNames
#' @importFrom Biobase sampleNames
setGeneric("sampleNames")

#' @name mergedDate
#' @export
#' @docType methods
#' @rdname mergedDate
setGeneric("mergedDate", function(x) standardGeneric("mergedDate"))

#' @name indexes<-
#' @export
#' @docType methods
#' @rdname indexes-replace
setGeneric("indexes<-", function(x, value) standardGeneric("indexes<-"))

#' @name expr<-
#' @export
#' @docType methods
#' @rdname expr-replace
setGeneric("expr<-", function(x, value) standardGeneric("expr<-"))

#' @name subset
#' @export
#' @docType methods
#' @rdname subset
#' @param ... further arguments to generic subset
setGeneric("subset", function(x, ...) standardGeneric("subset"))

#' @name pData
#' @export
#' @docType methods
#' @rdname pData
#' @importFrom Biobase pData
setGeneric("pData")

#' @name pData<-
#' @export
#' @docType methods
#' @rdname pData-replace
#' @importFrom Biobase pData<-
setGeneric("pData<-")

#' @name texpr
#' @export
#' @docType methods
#' @rdname texpr
setGeneric("texpr", function(x, meas='FPKM') standardGeneric("texpr"))

#' @name eexpr
#' @export
#' @docType methods
#' @rdname eexpr
setGeneric("eexpr", function(x, meas='rcount') standardGeneric("eexpr"))

#' @name iexpr
#' @export
#' @docType methods
#' @rdname iexpr
setGeneric("iexpr", function(x, meas='rcount') standardGeneric("iexpr"))

#' @name gexpr
#' @export
#' @docType methods
#' @rdname gexpr
setGeneric("gexpr", function(x) standardGeneric("gexpr"))

#' @name seqnames
#' @export
#' @docType methods
#' @rdname seqnames
#' @importFrom GenomeInfoDb seqnames
setGeneric("seqnames")

#' @name transcriptIDs
#' @export
#' @docType methods
#' @rdname transcriptIDs
setGeneric('transcriptIDs', function(x) standardGeneric('transcriptIDs'))

#' @name transcriptNames
#' @export
#' @docType methods
#' @rdname transcriptNames
setGeneric('transcriptNames', function(x) standardGeneric('transcriptNames'))

#' @name geneIDs
#' @export
#' @docType methods
#' @rdname geneIDs
setGeneric('geneIDs', function(x) standardGeneric('geneIDs'))

#' @name geneNames
#' @export
#' @docType methods
#' @rdname geneNames
setGeneric('geneNames', function(x) standardGeneric('geneNames'))

#' Replace method for indexes slot in ballgown objects
#' 
#' @name indexes<-
#' @exportMethod indexes<-
#' @docType methods
#' @aliases indexes<-,ballgown-method
#' @rdname indexes-replace
#' @param x a ballgown object
#' @param value the updated value for \code{indexes(x)} or a subcomponent
#' 
#' @examples
#' data(bg)
#' indexes(bg)$bamfiles = paste0('/path/to/bamfolder/', 
#'   sampleNames(bg), '_accepted_hits.bam')
setReplaceMethod("indexes", "ballgown", function(x, value){
    x@indexes <- value; x})

#' Replacement method for expr slot in ballgown objects
#' 
#' @name expr<-
#' @exportMethod expr<-
#' @docType methods
#' @aliases expr<-,ballgown-method
#' @rdname expr-replace
#' @param x a ballgown object
#' @param value the updated value for \code{expr(x)} or a subcomponent
#' 
#' @examples
#' data(bg)
#' n = ncol(bg@@expr$trans)
#' #multiply all transcript expression measurements by 10:
#' bg@@expr$trans[,11:n] = 10*bg@@expr$trans[11:n] 
setReplaceMethod("expr", "ballgown", function(x, value) {x@expr <- value; x})


#' Replacement method for pData slot in ballgown objects
#' 
#' @name pData<-
#' @exportMethod pData<-
#' @docType methods
#' @aliases pData<-,ballgown,ANY-method
#' @rdname pData-replace
#' @param object a ballgown object
#' @param value the updated value for \code{pData(x)}.
#' 
#' @examples
#' # add "timepoint" covariate to ballgown object:
#' data(bg) # already contains pData
#' pData(bg) = data.frame(pData(bg), timepoint=rep(1:10, 2))
#' head(pData(bg))
setMethod("pData<-", "ballgown", function(object, value) {
    object@indexes$pData <- value
    object}
)

# the show method:
setMethod("show", "ballgown",
    function(object)
        cat(class(object), "instance with", length(structure(object)$trans),
            "transcripts and", length(object@dirs), "samples\n")
)

#' visualize structure of assembled transcripts
#'
#' @param gene name of gene whose transcripts will be plotted.  When using 
#'   Cufflinks output, usually of the form \code{"XLOC_######"}
#' @param gown ballgown object containing experimental and phenotype data
#' @param samples vector of sample(s) to plot. Can be \code{'none'} if only one 
#'   plot (showing transcript structure in gray) is desired. Use 
#'   \code{sampleNames(gown)} to see sample names for \code{gown}. Defaults to 
#'   \code{sampleNames(gown)[1]}.
#' @param colorby one of \code{"transcript"}, \code{"exon"}, or \code{"none"}, 
#'   indicating which feature's abundances should dictate plot coloring.  If 
#'   \code{"none"}, all transcripts are drawn in gray.
#' @param meas which expression measurement to color features by, if any. Must 
#'   match an available measurement for whatever feature you're plotting.
#' @param legend if \code{TRUE} (as it is by default), a color legend is drawn
#'   on top of the plot indicating scales for feature abundances.
#' @param labelTranscripts if \code{TRUE}, transcript ids are labeled on the 
#'   left side of the plot. Default \code{FALSE}.
#' @param main optional string giving the desired plot title.
#' @param blackBorders if \code{TRUE}, exon borders are drawn in black. 
#'   Otherwise, they are drawn in the same color as their transcript or exon. 
#'   Switching blackBorders to FALSE can be useful for visualizing abundances 
#'   for skinny exons and/or smaller plots, which can be the case when 
#'   \code{length(samples)} is large.
#' @param log if \code{TRUE}, color transcripts on the log scale. Default 
#'   \code{FALSE}. To account for expression values of 0, we add 1 to all 
#'   expression values before taking the log.
#' @param logbase log base to use if \code{log = TRUE}. Default 2.
#' @param customCol an optional vector of custom colors to color transcripts by.
#'   There must be the same number of colors as transcripts in the gene being 
#'   plotted.
#' @param customOrder an optional vector of transcript ids (matching ids in 
#'   \code{texpr(gown, 'all')$t_id}), indicating which order transcripts will 
#'   appear in the plot. All transcripts in \code{gene} must appear in the 
#'   vector exactly once.
#' 
#' @return produces a plot of the transcript structure for the specified gene in
#'   the current graphics device.
#' @seealso \code{\link{plotMeans}}, \code{\link{plotLatentTranscripts}}
#' @author Alyssa Frazee
#' @export
#' @examples \donttest{
#' data(bg)
#' 
#' # plot one gene for one sample:
#' plotTranscripts(gene='XLOC_000454', gown=bg, samples='sample12', meas='FPKM',
#'     colorby='transcript', 
#'     main='transcripts from gene XLOC_000454: sample 12, FPKM')
#' 
#' # plot one gene for many samples:
#' plotTranscripts('XLOC_000454', bg, 
#'     samples=c('sample01', 'sample06', 'sample12', 'sample19'), 
#'     meas='FPKM', colorby='transcript')
#' 
#' }
plotTranscripts = function(gene, gown, samples=NULL, colorby='transcript',
    meas='FPKM', legend=TRUE, labelTranscripts=FALSE, main=NULL, 
    blackBorders=TRUE, log=FALSE, logbase=2, customCol=NULL, customOrder=NULL){

    if(class(gown)!="ballgown") stop("gown must be a ballgown object")

    if(gown@RSEM & colorby=='exon'){
        stop(.makepretty('RSEM objects do not yet have exon-level measurements,
            so must color by transcript.'))
    }

    if(!gown@RSEM & meas=='TPM'){
        stop('only RSEM objects have TPM measurements.')
    }

    if(is.null(samples)){
        samples = sampleNames(gown)[1]
        if(colorby!='none') message(paste('defaulting to sample', samples))
    }
    
    if(!all(samples %in% sampleNames(gown))){
        stop(.makepretty('all entries of "samples" must be part of "gown". Use
            sampleNames(gown) to check.'))
    }

    stopifnot(colorby %in% c('transcript', 'exon', 'none'))

    if(colorby == 'transcript'){
        stopifnot(meas %in% c('cov', 'FPKM', 'TPM'))
    }
    if(colorby == 'exon'){
        emeas = c('rcount', 'ucount', 'mrcount', 'cov', 'cov_sd', 
            'mcov', 'mcov_sd')
        stopifnot(meas %in% emeas)
    }

    if(!(gown@meas == 'all' | meas %in% gown@meas)){
        stop(paste('gown does not contain', meas, 'measurements.'))
    }

    if(colorby=="none") legend = FALSE
    
    if(!is.null(customCol) & (colorby!="transcript")){
        stop("Custom coloring is only available at transcript level currently")
    }

    if(!is.null(customCol) & legend){
        stop('legend must be FALSE if you provide custom colors')
    }

    n = length(samples)
    westval = ifelse(labelTranscripts, 4, 2)
    if(n > 1){
        numrows = floor(sqrt(n))
        numcols = ceiling(n/numrows)
        par(mfrow=c(numrows,numcols), mar=c(5,westval,4,2), oma=c(0, 0, 2, 0))
    }else{
        par(mar=c(5, westval, 4, 2))
    }

    ma = IRanges::as.data.frame(structure(gown)$trans)
    if(names(ma)[2] != 'group_name'){
        stop('IRanges::as.data.frame has changed. Please report as issue.')
    }
    thetranscripts = indexes(gown)$t2g$t_id[indexes(gown)$t2g$g_id==gene]
    if(!is.null(customOrder)){
        if(!all(sort(customOrder) == sort(thetranscripts))){
            stop(.makepretty('customOrder must include each transcript in gene
                exactly once.'))
        }
    }
    
    if(substr(ma$group_name[1],1,2) == "tx"){
        warning('your ballgown object was built with a deprecated version of
            ballgown - would probably be good to re-build!')
        thetranscripts = paste0('tx', thetranscripts)
    }
    
    if(!is.null(customCol) & (length(customCol)!=length(thetranscripts))){
        stop("You must have the same number of custom colors as transcripts")
    }

    gtrans = ma[ma$group_name %in% thetranscripts,]
    xax = seq(min(gtrans$start), max(gtrans$end), by=1)
    numtx = length(unique(thetranscripts))
    ymax = ifelse(legend, numtx+1.5, numtx+1)
    
    if(length(unique(gtrans$seqnames)) > 1){ 
        stop("gene spans multiple chromosomes (?)")
    }
    if(length(unique(gtrans$strand)) > 1){ 
        stop("gene contains exons from both strands (?)")
    }

    # set appropriate color scale:
    if(colorby != 'none'){
        g_id = texpr(gown, 'all')$gene_id
        if(colorby == "transcript"){
            smalldat = texpr(gown, meas)[which(g_id == gene),]
            t_id = texpr(gown, 'all')$t_id[which(g_id == gene)]
        }
        if(colorby == "exon"){
            e_id_full = eexpr(gown, 'all')$e_id
            smalldat = eexpr(gown, meas)[which(e_id_full %in% gtrans$id),]
            e_id = e_id_full[which(e_id_full %in% gtrans$id)]
        }
        if(numtx == 1){
            snames = names(smalldat)
            smalldat = matrix(smalldat, nrow=1)
            colnames(smalldat) = snames
        }
        if(log){
            smalldat = log(smalldat+1, base=logbase)
        }
        maxcol = quantile(as.matrix(smalldat), 0.99)
        colscale = seq(0, maxcol, length.out=200)
        introntypes = c('ucount', 'rcount', 'mrcount')
        color.introns = meas %in% introntypes & 
            gown@meas %in% c('all', introntypes)
    }else{
        color.introns = FALSE
    }

    # make plot(s) (one for each sample):
    for(s in 1:n){
        ## make base plot:
        plot(xax, rep(0,length(xax)), ylim=c(0,ymax), 
            type="n", xlab="genomic position", yaxt = "n", ylab="")
        if(n > 1){
            title(samples[s])
        }
        
        colName = paste(meas, samples[s], sep='.')
        if(colorby != 'none'){
            colIndex = which(colnames(smalldat) == colName)
        }

        # draw transcripts
        if(is.null(customOrder)){
            transcript_loop = unique(gtrans$group_name)
        }else{
            transcript_loop = customOrder
        }
        for(tx in transcript_loop){
            txind = which(transcript_loop==tx)
            if(colorby == 'transcript'){
                if(!is.null(customCol)){
                    mycolor = customCol[txind]
                }else{
                    mycolor = closestColor(smalldat[,colIndex][which(t_id==tx)],
                        colscale)    
                }
                stopifnot(length(mycolor) > 0)
            }else if(colorby == 'none'){
                mycolor = 'gray70'
            }
            
            gtsub = gtrans[gtrans$group_name==tx,]
            gtsub = gtsub[order(gtsub$start),]
            for(exind in 1:dim(gtsub)[1]){
                if(colorby == "exon"){ 
                    mycolor = closestColor(
                        smalldat[,colIndex][which(e_id==gtsub$id[exind])], 
                        colscale)
                    stopifnot(length(mycolor) > 0)
                }
                borderCol = ifelse(blackBorders, 'black', mycolor)
                polygon(x=c(gtsub$start[exind], gtsub$start[exind], 
                        gtsub$end[exind], gtsub$end[exind]), 
                        y=c(txind-0.4,txind+0.4,txind+0.4,txind-0.4), 
                        col=mycolor, border=borderCol)
                if(exind!=dim(gtsub)[1]){
                    if(!color.introns){ 
                        lines(c(gtsub$end[exind],gtsub$start[exind+1]), 
                            c(txind, txind), lty=2, col="gray60")
                    }
                    if(color.introns){
                        intronindex = which(
                            expr(gown)$intron$start == gtsub$end[exind]+1 & 
                            expr(gown)$intron$end == gtsub$start[exind+1]-1 & 
                            expr(gown)$intron$chr==unique(gtsub$seqnames) & 
                            expr(gown)$intron$strand == unique(gtsub$strand))
                        icolumnind = which(names(expr(gown)$intron) == colName)
                        icol = closestColor(
                            expr(gown)$intron[intronindex,icolumnind], colscale)
                        lines(c(gtsub$end[exind]+10,gtsub$start[exind+1]-10), 
                            c(txind, txind), lwd=3, col=icol)
                        lines(c(gtsub$end[exind],gtsub$start[exind+1]),
                            c(txind+0.1, txind+0.1), lwd=0.5, col="gray60")
                        lines(c(gtsub$end[exind],gtsub$start[exind+1]),
                            c(txind-0.1, txind-0.1), lwd=0.5, col="gray60")
                    }#end if color.introns
                }# end if exind != last exon
            }# end loop over exons
        }# end loop over transcripts
    
        # draw the legend:
        if(legend){
            leglocs = seq(min(xax)+1, max(xax)-1, length=length(colscale)+1)
            for(i in 1:length(colscale)){
                polygon(x=c(leglocs[i], leglocs[i], leglocs[i+1], leglocs[i+1]),
                    y=c(ymax-0.3, ymax, ymax, ymax-0.3), border=NA, 
                    col=rev(heat.colors(length(colscale)))[i])
            }
            text(x = seq(min(xax)+1, max(xax)-1, length=10), 
                y=rep(ymax+0.1, 10), 
                labels=round(colscale,2)[seq(1,length(colscale), length=10)], 
                cex=0.5) 
            if(log){
                text(x=median(xax), y=ymax-0.5, 
                    labels=paste("log expression, by",  colorby), cex=0.5)
            }else{
                text(x=median(xax), y=ymax-0.5, 
                    labels=paste("expression, by",  colorby), cex=0.5)
            }
        }

        # label the transcripts on the y-axis (if asked for)
        if(labelTranscripts){
            axis(side=2, at=c(1:numtx), labels=transcript_loop, cex.axis=0.75, 
                las=1)
        }

    } #end loop over samples

    # put title on plot
    if(!is.null(main)){
        title(main, outer=(n>1))
    }else{
        if(n==1){
            title(paste0(gene,': ',samples))
        }else{
            title(gene, outer=TRUE)
        }
    }

}

#' group a gene's assembled transcripts into clusters
#'
#' @param gene name of gene whose transcripts will be clustered.  When using 
#'   Cufflinks output, usually of the form \code{"XLOC_######"}
#' @param gown ballgown object containing experimental data
#' @param k number of clusters to use
#' @param method clustering method to use.  Must be one of \code{"hclust"}, for
#'   hierarchical clustering, or \code{"kmeans"}, for k-means clustering. 
#' 
#' @return list with elements \code{clusters} and \code{pctvar}. 
#'    \code{clusters} contains columns "cluster" and "t_id", and denotes which
#'    transcripts belong to which clusters.  
#' \code{pctvar} is only non-NULL when using k-means clustering and is the
#'    percentage of variation explained by these clusters, defined as the ratio
#'    of the between-cluster sum of squares to the total sum of squares.
#' 
#' @seealso \code{\link{hclust}}, \code{\link{kmeans}}, 
#'   \code{\link{plotLatentTranscripts}} for visualizing the transcript clusters
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' 
#' @examples 
#' data(bg)
#' clusterTranscripts('XLOC_000454', bg, k=2, method='kmeans')
#' # transcripts 1294 and 1301 cluster together, 91% variation explained.

clusterTranscripts = function(gene, gown, k=NULL, method=c('hclust', 'kmeans')){
    method = match.arg(method)

    txnames = indexes(gown)$t2g$t_id[indexes(gown)$t2g$g_id == gene]
    if(!is.null(k) & length(txnames) <= k){
        stop('k must be strictly less than the number of transcripts in gene')
    }else if(is.null(k)){
        k = ceiling(sqrt(length(txnames)/2))
    }

    inds = which(names(structure(gown)$trans) %in% txnames)
    tx = structure(gown)$trans[inds]
    chr = texpr(gown, 'all')$chr[inds[1]]

    xg = expand.grid(c(1:length(tx)), c(1:length(tx)))
    matInds = as.vector(t(xg)) 
    #^ vector of transcript pairs to calculate overlaps for
    olGroup = rep(1:(length(matInds)/2), each=2)
    olGroupSplit = rep(olGroup, times=elementNROWS(tx[matInds]))
    overlapping = split(unlist(tx[matInds]), olGroupSplit)
    coverages = coverage(ranges(overlapping))
    runvals = runValue(coverages)
    runlengths = runLength(coverages)
    pct = sum(runlengths[runvals==2]) / sum(runlengths[runvals==1 | runvals==2])
    distMat = 1-matrix(pct, nrow=length(tx))


    if(method=="hclust"){
        groups = cutree(hclust(as.dist(distMat)), k=k)
        pctvar = NULL
    } 
    
    if(method=="kmeans"){
        km = kmeans(distMat, centers=k)
        groups = as.numeric(km$cluster)
        pctvar = km$betweenss/km$totss
    }

    return(list(clusters=data.frame(cluster=groups, t_id=txnames), 
        pctvar=pctvar))
}

#' plot annotated and assembled transcripts together
#'
#' @param assembled a GRangesList object where the GRanges objects in the list 
#'   represent sets of exons comprising assembled transcripts
#' @param annotated a GRangesList object where the GRanges objects in the list
#'   represent sets of 
#' exons comprising annotated transcripts
#' @param ind integer; index of \code{annotated} specifying which annotated 
#'   transcript to plot.  All transcripts (assembled and annotated) overlapping
#'   \code{annotated[[ind]]} will be plotted. Default 1.
#' @param main optional character string giving the title for the resulting
#'   plot.  Default: "Assembled and Annotated Transcripts"
#' @param customCol optional vector of custom colors for the annotated
#'   transcripts. If not the same length as the number of annotated transcripts
#'   in the plot, recycling or truncation might occur.
#' 
#' @return Plots annotated transcripts on the bottom panel (shaded in gray) and
#'   assembled transcripts on the top panel (shaded with diagonal lines).
#' 
#' @author Alyssa Frazee
#' 
#' @export
#' @examples \donttest{
#' gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
#' annot = gffReadGR(gtfPath, splitByTranscript=TRUE)
#' data(bg)
#' checkAssembledTx(annotated=annot, assembled=structure(bg)$trans, ind=4)
#' }
checkAssembledTx = function(assembled, annotated, ind=1, 
    main='Assembled and Annotated Transcripts', customCol=NULL){

    ol = findOverlaps(annotated, assembled)
    ol.self = findOverlaps(annotated, annotated) 
    #^ plot any overlapping transcripts also.
    indsas = subjectHits(ol)[which(queryHits(ol)==ind)]

    if(length(indsas)==0){
        warning(.makepretty('This annotated transcript was not covered by any
            assembled transcripts. No plot will be produced'), call.=FALSE)
        return(0)
    }

    # plot setup:
    par(mar=c(5,3,4,2))
    annot.list = lapply(subjectHits(ol.self)[which(queryHits(ol.self)==ind)], 
        function(i) annotated[[i]])
    names(annot.list) = names(annotated)[subjectHits(ol.self)[which(
        queryHits(ol.self)==ind)]]
    annot.df = as.data.frame(GRangesList(annot.list))
    asmbl.list = lapply(indsas, function(i) assembled[[i]])
    names(asmbl.list) = names(assembled)[indsas]
    asmbl.df = as.data.frame(GRangesList(asmbl.list))
    xax = seq(min(min(asmbl.df$start), min(annot.df$start)), 
        max(max(asmbl.df$end), max(annot.df$end)), by=1)
    if(names(asmbl.df)[2] != 'group_name'){
        stop('IRanges::as.data.frame has changed, please report')
    }
    numtx = length(unique(annot.df$group_name))+
        length(unique(asmbl.df$group_name))

    # plot base:
    plot(xax, rep(0, length(xax)), ylim=c(0.5, numtx+1), type="n", 
        xlab="genomic position", yaxt="n", ylab="")

    # plot the annotated transcripts:
    txind = 0
    for(tx in unique(annot.df$group_name)){
        txind = txind+1 #counter
        gtsub = annot.df[annot.df$group_name==tx,]
        gtsub = gtsub[order(gtsub$start),]
        for(exind in 1:dim(gtsub)[1]){
            polygon(x=c(gtsub$start[exind], gtsub$start[exind], 
                gtsub$end[exind], gtsub$end[exind]), 
                y=c(txind-0.4, txind+0.4, txind+0.4, txind-0.4), col="gray30")
            if(exind!=dim(gtsub)[1]){
                lines(c(gtsub$end[exind],gtsub$start[exind+1]), c(txind, txind),
                    lty=2, col="gray50")
            }
        }
        st.compare = gtsub$start[-1]
        en.compare = gtsub$end[-length(gtsub$end)]
        diffs = st.compare-en.compare
        if(any(diffs<0)){
            warning(paste("overlapping exons in annotated transcript",tx), 
                call.=FALSE)
        }
    }
    colorind = 0
    txind = txind+0.5
    abline(h=txind+0.25)

    # plot the assembled transcripts
    for(tx in unique(asmbl.df$group_name)){
        txind = txind+1
        gtsub = asmbl.df[asmbl.df$group_name==tx,]
        gtsub = gtsub[order(gtsub$start),]
        if(is.null(customCol)){
            mycolor = 'black'
            density = 15
        }else{
            mycolor = customCol[(colorind %% length(customCol))+1]
            density = NULL
        }
        mycolor = ifelse(is.null(customCol), 'black', 
            customCol[(colorind %% length(customCol))+1])
        for(exind in 1:dim(gtsub)[1]){
            polygon(x=c(gtsub$start[exind], gtsub$start[exind], 
                    gtsub$end[exind], gtsub$end[exind]), 
                y=c(txind-0.4, txind+0.4, txind+0.4, txind-0.4), 
                col=mycolor, density=density)
            if(exind!=dim(gtsub)[1]){
                lines(c(gtsub$end[exind],gtsub$start[exind+1]), c(txind, txind),
                    lty=2, col="gray50")
            }
        }
        st.compare = gtsub$start[-1]
        en.compare = gtsub$end[-length(gtsub$end)]
        diffs = st.compare-en.compare
        if(any(diffs<0)){
            warning(paste("overlapping exons in assembled transcript",tx), 
                call.=FALSE)
        }
        colorind = colorind+1
    }
    title(main)
    axis(side=2, at=c(median(1:length(unique(annot.df$group_name))), 
        median(1:length(unique(asmbl.df$group_name)))+
            length(unique(annot.df$group_name))+0.5), 
        labels=c("annotated", "assembled"), tick=FALSE)
}

<!--
%\VignetteEngine{knitr::knitr}
%\VignetteIndexEntry{Flexible isoform-level differential expression analysis with Ballgown}
-->

```{r loadmethods, echo=FALSE, message=FALSE, warning=FALSE}
library(methods)
```

# Introduction
Ballgown is a software package designed to facilitate flexible differential expression analysis of RNA-seq data. 

Before using the Ballgown R package, a few preprocessing steps are necessary:
* RNA-seq reads should be aligned to a reference genome. Any junction-aware aligner is appropriate.
* A transcriptome should be assembled, or a reference transcriptome should be downloaded. Any assembler or download that produces a GTF file denoting the transcriptome's structure is appropriate.
* Expression for the features in the transcriptome should be estimated. We provide software called _Tablemaker_ that does this estimation. Tablemaker calls _Cufflinks_ version 2.1.1 (<a href="http://dx.doi.org/10.1038/nbt.1621">Trapnell et al. (2010)</a>) to estimate transcript-level FPKMs, and provides several alternative expression measurements (e.g. average per-base coverage, number of mapped reads, etc.) for other features. Expression is estimated for each transcript, exon, and intron (junction) in the assembly. 

The Ballgown package provides functions to organize, visualize, and analyze the expression measurements for your transcriptome assembly. 

# Installation
Start R and run:

```{r installme, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("ballgown")
```

# Running Tablemaker
Users need to run _Tablemaker_ to organize assembly output into a format that Ballgown can load. Tablemaker can be downloaded from figshare:

* [OSX binary](http://figshare.com/articles/Tablemaker_OS_X_Binary/1053136)
* [Linux binary](http://figshare.com/articles/Tablemaker_Linux_Binary/1053137)

Tablemaker can also be built from source from [this repository](https://github.com/alyssafrazee/tablemaker) by following [Cufflinks' instructions](http://cufflinks.cbcb.umd.edu/tutorial.html). 

Tablemaker needs to be run on each RNA-seq sample in your experiment.  It requires one transcripome assembly, in [GTF format](http://www.ensembl.org/info/website/upload/gff.html), and read alignments for each sample, in BAM format. From the command line, _Tablemaker_ is run as follows:

`tablemaker -p 4 -q -W -G merged.gtf -o sample01_output read_alignments.bam`

where:
* `-p` denotes how many threads to use (the program can take a few hours to run, but can be parallelized)
* The `-q` can be removed for more verbose output messages  
* `-W` and `-G merged.gtf` are required.  The `-W` tells the program to run in tablemaker mode (rather than Cufflinks mode), and the `-G` argument points to the assembly GTF file, which gives the assembled transcripts' structures. For Cufflinks users, often this is the `merged.gtf` output from Cuffmerge.
* The argument to `-o` is the desired output directory for the sample (each sample should have its own output directory)
* The read alignment file is the last argument.  If reads were aligned with TopHat, this is usually some variant of `accepted_hits.bam`

The output is 5 files, written to the specified output directory:

* `e_data.ctab`: exon-level expression measurements.  One row per exon.  Columns are `e_id` (numeric exon id), `chr`, `strand`, `start`, `end` (genomic location of the exon), and the following expression measurements for each sample:
    * `rcount`:  reads overlapping the exon 
    * `ucount`: uniquely mapped reads overlapping the exon 
    * `mrcount`: multi-map-corrected number of reads overlapping the exon
    * `cov` average per-base read coverage 
    * `cov_sd`: standard deviation of per-base read coverage
    * `mcov`: multi-map-corrected average per-base read coverage
    * `mcov_sd`: standard deviation of multi-map-corrected per-base coverage
* `i_data.ctab`: intron- (i.e., junction-) level expression measurements.  One row per intron.  Columns are `i_id` (numeric intron id), `chr`, `strand`, `start`, `end` (genomic location of the intron), and the following expression measurements for each sample: 
    * `rcount`: number of reads supporting the intron
    * `ucount`: number of uniquely mapped reads supporting the intron
    * `mrcount`: multi-map-corrected number of reads supporting the intron
* `t_data.ctab`: transcript-level expression measurements.  One row per transcript.  Columns are:
    * `t_id`: numeric transcript id
    * `chr`, `strand`, `start`, `end`: genomic location of the transcript
    * `t_name`: Cufflinks-generated transcript id
    * `num_exons`: number of exons comprising the transcript
    * `length`: transcript length, including both exons and introns
    * `gene_id`: gene the transcript belongs to
    * `gene_name`: HUGO gene name for the transcript, if known
    * `cov`: per-base coverage for the transcript (available for each sample)
    * `FPKM`: Cufflinks-estimated FPKM for the transcript (available for each sample)
* `e2t.ctab`: table with two columns, `e_id` and `t_id`, denoting which exons belong to which transcripts.  These ids match the ids in the `e_data` and `t_data` tables.
* `i2t.ctab`: table with two columns, `i_id` and `t_id`, denoting which introns belong to which transcripts.  These ids match the ids in the `i_data` and `t_data` tables.


# Loading data into R
At this point, _Tablemaker_ should have been run on all samples in the experiment. For this example, assume each sample's _Tablemaker_ output directory is a subfolder of the same root directory. The Ballgown package's `extdata` folder provides an example of such a directory, where the folder structure looks like:

```
extdata/
    sample01/
        e2t.ctab
        e_data.ctab
        i2t.ctab
        i_data.ctab
        t_data.ctab
    sample02/
        e2t.ctab
        e_data.ctab
        i2t.ctab
        i_data.ctab
        t_data.ctab
    ...
    sample20/
        e2t.ctab
        e_data.ctab
        i2t.ctab
        i_data.ctab
        t_data.ctab
```

Data is loaded using the `ballgown` function. 

If your data is stored in directories matching the above structure (one root folder, subfolders named by sample, and `.ctab` files in the subfolders), you can use the `dataDir` and `samplePattern` arguments to load the data. `samplePattern` takes a regular expressions specifying the subfolders that should be included in the ballgown object:

```{r makebgobj, message=FALSE}
library(ballgown)
data_directory = system.file('extdata', package='ballgown') # automatically finds ballgown's installation directory
# examine data_directory:
data_directory

# make the ballgown object:
bg = ballgown(dataDir=data_directory, samplePattern='sample', meas='all')
bg
```

If your data is stored in a directory structure other than the one specified above, you can use the `samples` argument in the `ballgown` function: `samples` should be a vector (1-d array) with one entry per sample, where the entry gives the path to the folder containing that sample's `.ctab` files. 

The result from either of these approaches is an object of class `ballgown` (named `bg` in these examples).

In the rest of this document, we use `bg` to refer to the first example, where samples are named `sample01` through `sample20`.

A note for large experiments (with many samples or with large genomes): loading the data might require a lot of time and memory. In these cases, it's often useful to do the data loading in non-interactive mode. More specifically, you could create a script called `load.R` that contains these lines:

```R
library(ballgown)
data_directory = system.file('extdata', package='ballgown') 
bg = ballgown(dataDir=data_directory, samplePattern='sample', meas='all')
save(bg, file='bg.rda')
```

You could then run this script non-interactively using `R CMD BATCH`: from the command line, run:

```
R CMD BATCH load.R
```

This may take some time, but when it finishes, the file `bg.rda` will be saved in the current directory, and you can read it back into R using the `load()` function. Rda files are usually only a few Gb on disk, even for large experiments. It is also possible to load only a subset of all the expression measurements by changing the `meas` argument to the `ballgown` function. For example, to only load transcript-level FPKMs, set `meas = 'FPKM'` and to load average coverage values and read counts, set `meas=c('cov', 'rcount').`

See `?ballgown` for detailed information on creating Ballgown objects.

# Accessing assembly data
A `ballgown` object has six slots: `structure`, `expr`, `indexes`, `dirs`, `mergedDate`, and `meas`. 

#### structure
The `structure` slot depends heavily on the `GenomicRanges` Bioconductor package (<a href="http://dx.doi.org/10.1371/journal.pcbi.1003118">Lawrence et al. (2013)</a>). The slot specifies the structure, i.e., genomic locations and relationships between exons, introns, and transcripts, of the transcriptome assembly.  It is convenient to represent exons and introns as intervals and to represent transcripts as a set of intervals (exons), so assembled exons and introns are available as `GRanges` objects, and the assembled transcripts are available as a `GRangesList` object.  This means that useful range operations, such as `findOverlaps` and `reduce`, are readily available for assembled features. 

Exon, intron, and transcript structures are easily extracted from the main `ballgown` object:

```{r struct}
structure(bg)$exon
structure(bg)$intron
structure(bg)$trans
```
#### expr
The `expr` slot is a list that contains tables of expression data for the genomic features.  These tables are very similar to the `*_data.ctab` _Tablemaker_ output files. Ballgown implements the following syntax to access components of the `expr` slot:

```R
*expr(ballgown_object_name, <EXPRESSION_MEASUREMENT>)
``` 

where `*` is either e for exon, i for intron, t for transcript, or g for gene, and <EXPRESSION MEASUREMENT> is an expression-measurement column name from the appropriate `.ctab` file.  Gene-level measurements are calculated by aggregating the transcript-level measurements for that gene.  All of the following are valid ways to extract expression data from the `bg` ballgown object:

```{r getexpr}
transcript_fpkm = texpr(bg, 'FPKM')
transcript_cov = texpr(bg, 'cov')
whole_tx_table = texpr(bg, 'all')
exon_mcov = eexpr(bg, 'mcov')
junction_rcount = iexpr(bg)
whole_intron_table = iexpr(bg, 'all')
gene_expression = gexpr(bg)
```
Calculating the gene-level expression measurements can be slow for large experiments.

The `*expr` functions return matrices unless `meas = 'all'`, in which case some additional feature metadata is returned and the result is a `data.frame`.

#### indexes
The `indexes` slot of a ballgown object connects the pieces of the assembly and provides other experimental information. `indexes(bg)` is a list with several components that can be extracted with the `$` operator.

Perhaps most importantly, there is a component called `pData` that should hold a data frame of phenotype information for the samples in the experiment. This must be created manually.  It is **very important** that the rows of pData are in the correct order. Each row corresponds to a sample, and the rows of pData should be ordered teh same as the tables in the `expr` slot. You can check that order by running `sampleNames(bg)`. The `pData` component can be added during construction (you can pass a data frame to the `ballgown` function), or you can add it later:

```{r pData}
pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))
```

The other components of `indexes` are the `e2t` and `i2t` tables described in the _Tablemaker_ section, as well as a `t2g` table denoting which transcripts belong to which genes.  There is also a `bamfiles` component, designed to hold paths to the read alignment files for each sample. The `bamfiles` component isn't currently used by any ballgown functions, but it could come in handy for users of `RSamtools` or similar packages.  Here are some examples of how to extract `indexes` components from ballgown objects:

```{r indexex}
exon_transcript_table = indexes(bg)$e2t
transcript_gene_table = indexes(bg)$t2g
head(transcript_gene_table)
phenotype_table = pData(bg)
```

#### other slots

The `dirs` slot gives full filepaths to _Tablemaker_ output:

```{r dirs}
head(bg@dirs)
```

The `mergedDate` slot indicates when the `ballgown` object was created:

```{r mergedDate}
bg@mergedDate
```

And the `meas` slot gives the expression measurements present in the object:

```{r meas}
bg@meas
``` 

# Plotting transcript structures

Visualization of the assembled transcripts is done with the `plotTranscripts` function. Transcripts or exons can be colored by expression level. This plot colors transcripts by expression level:

```{r plotTranscripts, fig.height=8, fig.width=8, fig.cap=""}
plotTranscripts(gene='XLOC_000454', gown=bg, samples='sample12', 
    meas='FPKM', colorby='transcript', 
    main='transcripts from gene XLOC_000454: sample 12, FPKM')
```

It is also possible to plot several samples at once:

```{r plotTranscripts2, fig.height=10, fig.width=10, fig.cap=""}
plotTranscripts('XLOC_000454', bg, 
    samples=c('sample01', 'sample06', 'sample12', 'sample19'), 
    meas='FPKM', colorby='transcript')
```

You can also make side-by-side plots comparing mean abundances between groups (here, 0 and 1):

```{r plotMeans, fig.height=5, fig.width=10, fig.cap=""}
plotMeans('XLOC_000454', bg, groupvar='group', meas='FPKM', colorby='transcript')
```

# Differential expression analysis

Ballgown provides a wide selection of simple, fast statistical methods for testing whether transcripts are differentially expressed between experimental conditions or across a continuous covariate (such as time). 

The default statistical test in ballgown is a parametric F-test comparing nested linear models; details are available in the Ballgown manuscript (<a href="http://biorxiv.org/content/early/2014/03/30/003665">Frazee et al. (2014)</a>). These models are conceptually simialar to the models used by <a href="http://link.springer.com/chapter/10.1007%2F0-387-29362-0_23">Smyth (2005)</a> in the `limma` package. In `limma`, more sophisticated empirical Bayes shrinkage methods are used, and generally a single linear model is fit per feature instead of doing a nested model comparison, but the flavor is similar (and in fact, `limma` can easily be run on any of the data matrices in a `ballgown` object).

Ballgown's statistical models are implemented with the `stattest` function. Two models are fit to each feature, using expression as the outcome: one including the covariate of interest (e.g., case/control status or time) and one not including that covariate. An F statistic and p-value are calculated using the fits of the two models. A significant p-value means the model including the covariate of interest fits significantly better than the model without that covariate, indicating differential expression. We adjust for multiple testing by reporting q-values (<a href="http://dx.doi.org/10.1073/pnas.1530509100">Storey & Tibshirani (2003)</a>) for each transcript in addition to p-values: reporting features with, say, q < 0.05 means the false discovery rate should be controlled at about 5%. 

`stattest` automatically handles two-group (e.g. case/control) comparisons, multi-group comparisons (e.g. comparison of several tissue types), and "timecourse" comparisons (with the scare quotes meaning that these comparisons are also applicable to continuous covariates that aren't time). For two- and multi-group comparisons, a significant result indicates that the feature is differentially expressed in at least one of the groups. For timecourse comparisions, significant results mean the feature has an expression profile that varies significantly over time (i.e., values of the continuous covariate) as opposed to being flat over time. 

The example dataset `bg` contains two group labels, 0 and 1. We can test each transcript for differential expression with `stattest`:

```{r stattest}
stat_results = stattest(bg, feature='transcript', meas='FPKM', covariate='group')
head(stat_results)
```
The result is a data frame containing the feature tested, feature ids, and corresponding p- and q-values. See `?stattest` for further usage details.

#### timecourse experiments
For timecourse experiments, a smooth curve is fit to time (or the continuous covariate) using [natural splines](http://en.wikipedia.org/wiki/Spline_interpolation). The default degrees of freedom used for the spline model is 4, but this can be adjusted with the `df` option. The model for expression including these spline terms is compared to a model without any spline terms for the F-test. The results indicate which features' expression levels change significantly over time. For our example, we can define a "time" covariate and then demonstrate a typical call to `stattest` for a timecourse experiment:

```{r stattest_time}
pData(bg) = data.frame(pData(bg), time=rep(1:10, 2)) #dummy time covariate
timecourse_results = stattest(bg, feature='transcript', meas='FPKM', covariate='time', timecourse=TRUE)
```

The timecourse option assumes that "time" in your study is truly continuous, i.e., that it takes several values along a time scale. If you have very few timepoints (e.g., fewer than 5), we recommend treating time as a categorical variable, since having very few values does not give much granularity for fitting a smooth curve using splines. You can do this by setting covariate equal to 'time' (or whatever your time variable is named) and simply leaving timecourse as FALSE, its default. If you don't have more timepoints than degrees of freedom in the spline model, a warning will be printed and time will be coerced to categorical.

#### adjusting for confounders
You can adjust for any or all variables in `pData` when testing for differential expression.  Ballgown automatically adjusts for library size using the sum of all logged nonzero expression measurements below the 75th percentile of those measurements, for each sample.  If you would like to adjust for other variables, just provide those confounders as the `adjustvars` argument to `stattest`:

```{r stattest_adjust}
group_adj_timecourse_results = stattest(bg, feature='transcript', meas='FPKM', covariate='time', 
    timecourse=TRUE, adjustvars='group')
```

#### defining custom models
It is also possible to explicitly provide the design matrices for the models to be compared. You can provide any two models for `mod` and `mod0`, provided that `mod0` is nested in `mod`, i.e., that all covariates used in `mod0` also appear in `mod`. For example, suppose we had sex and age information available, in addition to group and time, and we wanted to compare a model (`mod`) including all information (sex, age, group, time) to a model including only group and time (`mod`). Code to do this with `ballgown` is:

```{r customMod}
# create example data:
set.seed(43)
sex = sample(c('M','F'), size=nrow(pData(bg)), replace=TRUE)
age = sample(21:52, size=nrow(pData(bg)), replace=TRUE)

# create design matrices:
mod = model.matrix(~ sex + age + pData(bg)$group + pData(bg)$time)
mod0 = model.matrix(~ pData(bg)$group + pData(bg)$time)

# run differential expression tests:
adjusted_results = stattest(bg, feature='transcript', meas='FPKM', mod0=mod0, mod=mod)
head(adjusted_results)
```

# Using alternative statistical methods
Ballgown's statistical methods for differential expression testing are straightforward and accurate (<a href="http://biorxiv.org/content/early/2014/03/30/003665">Frazee et al. (2014)</a>), but users may wish to use one of the many existing packages for differential expression. Ballgown's data structures make it easy to use table-based packages like limma (<a href="">Smyth (2005)</a>), limma Voom (<a href="http://dx.doi.org/10.1186/gb-2014-15-2-r29">Law et al. (2014)</a>), DESeq (<a href="http://dx.doi.org/10.1186/gb-2010-11-10-r106">Anders & Huber (2010)</a>), DEXSeq (<a href="http://dx.doi.org/10.1101/gr.133744.111">Anders et al. (2012)</a>), or EdgeR (<a href="http://dx.doi.org/10.1093/bioinformatics/btp616">Robinson et al. (2010)</a>) for differential expression analysis.  A feature-by-sample expression table can be easily created with a `*expr` function and used directly as input to these or other differential expression packages. 

# Simple transcript clustering
Sometimes several very similar transcripts are assembled for the same gene, which might cause expression estimates for those transcripts to be unreliable: statistically, it can very difficult or impossible to tell which of two very similar transcript a read came from. This means differential expression results might also be unreliable. 

As a preliminary attempt at addressing this issue, Ballgown provides some simple transcript clustering functions. The idea is that similar assembled transcripts can be grouped together in clusters, and differential expression analysis could be performed on the cluster, whose expression measurement aggregates the expression estimates of the transcripts that compose it.

These functions measure the distance between transcripts using [Jaccard distance](http://en.wikipedia.org/wiki/Jaccard_index), where each transcript's "set" is the nucleotides included in its exons. Transcripts can be clustered using either _k_-means clustering or hierarchical clustering.

```{r cluster}
clusterTranscripts(gene='XLOC_000454', gown=bg, k=2, method='kmeans')
``` 

You can also visualize the transcript clusters:

```{r clusterviz, fig.height=8, fig.width=8, fig.cap=""}
plotLatentTranscripts(gene='XLOC_000454', gown=bg, k=2, method='kmeans', returncluster=FALSE)
```

And you can calculate aggregate cluster expression measurements for some gene using `collapseTranscripts`. The `tab` result of `collapseTranscripts` can be passed to `stattest` as the `gowntable` argument, for differential expression analysis of the clusters:

```{r collapse}
agg = collapseTranscripts(gene='XLOC_000454', gown=bg, k=2, method='kmeans')
stattest(gowntable=agg$tab, pData=pData(bg), feature='transcript_cluster', 
    covariate='group', libadjust=FALSE)
```

This example clustered only three transcripts, but we imagine clustering could be useful when many more than three transcripts have been assembled for a single gene.

# References
- Simon Anders, Wolfgang Huber (2010). Differential Expression Analysis For Sequence Count Data.  *Genome Biology*  **11**  R106-NA  [10.1186/gb-2010-11-10-r106](http://dx.doi.org/10.1186/gb-2010-11-10-r106)
- Simon Anders, Alejandro Reyes, Wolfgang Huber (2012). Detecting Differential Usage of Exons From RNA-Seq Data.  *Genome Research*  **22**  2008-2017  [10.1101/gr.133744.111](http://dx.doi.org/10.1101/gr.133744.111)
- Alyssa C. Frazee, Geo Pertea, Andrew E. Jaffe, Ben Langmead, Steven L. Salzberg, Jeffrey T. Leek (2014). Flexible isoform-level differential expression analysis with Ballgown.  *bioRxiv*  [http://biorxiv.org/content/early/2014/03/30/003665](http://biorxiv.org/content/early/2014/03/30/003665)
- Charity W Law, Yunshun Chen, Wei Shi, Gordon K Smyth,   (2014) Voom: Precision Weights Unlock Linear Model Analysis Tools For RNA-Seq Read Counts.  *Genome Biology*  **15**  R29-NA  [10.1186/gb-2014-15-2-r29](http://dx.doi.org/10.1186/gb-2014-15-2-r29)
- Michael Lawrence, Wolfgang Huber, Herve Pages, Patrick Aboyoun, Marc Carlson, Robert Gentleman, Martin T. Morgan, Vincent J. Carey, Andreas Prlic (2013). Software For Computing And Annotating Genomic Ranges.  *Plos Computational Biology*  **9**  e1003118-NA  [10.1371/journal.pcbi.1003118](http://dx.doi.org/10.1371/journal.pcbi.1003118)
- Mark D. Robinson, Davis J. McCarthy and Gordon K. Smyth (2009) "edgeR: a
Bioconductor package for differential expression analysis of
digital gene expression data". *Bioinformatics* **26.1** pp. 139-140. [10.1093/bioinformatics/btp616](http://dx.doi.org/10.1093/bioinformatics/btp616.)
- Gordon Smyth, (2005) Limma: linear models for microarray data.  397-420
- John D. Storey, Robert Tibshirani (2003). Statistical Significance For Genomewide Studies.  *Proceedings of The National Academy of Sciences*  **100**  9440-9445  [10.1073/pnas.1530509100](http://dx.doi.org/10.1073/pnas.1530509100)
- Cole Trapnell, Brian A Williams, Geo Pertea, Ali Mortazavi, Gordon Kwan, Marijke J van Baren, Steven L Salzberg, Barbara J Wold, Lior Pachter, (2010) Transcript Assembly And Quantification by Rna-Seq Reveals Unannotated Transcripts And Isoform Switching During Cell Differentiation.  *Nature Biotechnology*  **28**  511-515  [10.1038/nbt.1621](http://dx.doi.org/10.1038/nbt.1621)

# Session Information
```{r sessioninfo, results='markup'}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{pData}
\alias{pData}
\alias{pData,ballgown-method}
\title{extract phenotype data from a ballgown object}
\usage{
pData(object)

\S4method{pData}{ballgown}(object)
}
\arguments{
\item{object}{a ballgown object}
}
\value{
sample-by-phenotype data frame
}
\description{
extract phenotype data from a ballgown object
}
\examples{
data(bg)
pData(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clusterTranscripts.R
\name{clusterTranscripts}
\alias{clusterTranscripts}
\title{group a gene's assembled transcripts into clusters}
\usage{
clusterTranscripts(gene, gown, k = NULL, method = c("hclust", "kmeans"))
}
\arguments{
\item{gene}{name of gene whose transcripts will be clustered.  When using 
Cufflinks output, usually of the form \code{"XLOC_######"}}

\item{gown}{ballgown object containing experimental data}

\item{k}{number of clusters to use}

\item{method}{clustering method to use.  Must be one of \code{"hclust"}, for
hierarchical clustering, or \code{"kmeans"}, for k-means clustering.}
}
\value{
list with elements \code{clusters} and \code{pctvar}. 
   \code{clusters} contains columns "cluster" and "t_id", and denotes which
   transcripts belong to which clusters.  
\code{pctvar} is only non-NULL when using k-means clustering and is the
   percentage of variation explained by these clusters, defined as the ratio
   of the between-cluster sum of squares to the total sum of squares.
}
\description{
group a gene's assembled transcripts into clusters
}
\examples{
data(bg)
clusterTranscripts('XLOC_000454', bg, k=2, method='kmeans')
# transcripts 1294 and 1301 cluster together, 91\% variation explained.
}
\seealso{
\code{\link{hclust}}, \code{\link{kmeans}}, 
  \code{\link{plotLatentTranscripts}} for visualizing the transcript clusters
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/constructor.R
\name{ballgown-constructor}
\alias{ballgown-constructor}
\alias{ballgown}
\title{constructor function for ballgown objects}
\usage{
ballgown(
  samples = NULL,
  dataDir = NULL,
  samplePattern = NULL,
  bamfiles = NULL,
  pData = NULL,
  verbose = TRUE,
  meas = "all"
)
}
\arguments{
\item{samples}{vector of file paths to folders containing sample-specific
ballgown data (generated by \code{tablemaker}).  If \code{samples} is
provided, \code{dataDir} and \code{samplePattern} are not used.}

\item{dataDir}{file path to top-level directory containing sample-specific
folders with ballgown data in them.  Only used if \code{samples} is NULL.}

\item{samplePattern}{regular expression identifying the subdirectories of\
\code{dataDir} containing data to be loaded into the ballgown object (and
only those subdirectories).  Only used if \code{samples} is NULL.}

\item{bamfiles}{optional vector of file paths to read alignment files for
each sample.  If provided, make sure to sort properly (e.g., in the same
order as \code{samples}).  Default NULL.}

\item{pData}{optional \code{data.frame} with rows corresponding to samples and
columns corresponding to phenotypic variables.}

\item{verbose}{if \code{TRUE}, print status messages and timing information
as the object is constructed.}

\item{meas}{character vector containing either "all" or one or more of:
"rcount", "ucount", "mrcount", "cov", "cov_sd", "mcov", "mcov_sd", or
"FPKM". The resulting ballgown object will only contain the specified
expression measurements, for the appropriate features. See vignette for
which expression measurements are available for which features. "all"
creates the full object.}
}
\value{
an object of class \code{ballgown}
}
\description{
constructor function for ballgown objects
}
\details{
Because experimental data is recorded so variably, it is the user's
  responsibility to format \code{pData} correctly.  In particular, it's
  really important that the rows of \code{pData} (corresponding to samples)
  are ordered the same way as \code{samples} or the
  \code{dataDir}/\code{samplePattern} combo. You can run
  \code{list.files(path = dataDir, pattern = samplePattern)} to see the sample
  order if \code{samples} was not used.

If you are creating a ballgown object for a large experiment, this function
may run slowly and use a large amount of RAM. We recommend running this
constructor as a batch job and saving the resulting ballgown object as an rda
file.  The rda file usually has reasonable size on disk, and the object in it
shouldn't take up too much RAM when loaded, so the time and memory use in
creating the object is a one-time cost.
}
\examples{
bg = ballgown(dataDir=system.file('extdata', package='ballgown'),
    samplePattern='sample')
pData(bg) = data.frame(id=sampleNames(bg), group=rep(c(1,0), each=10))
}
\seealso{
\code{\link{ballgownrsem}}, for loading RSEM output into a ballgown
  object
}
\author{
Leonardo Collado-Torres, Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stattest.R
\name{stattest}
\alias{stattest}
\title{statistical tests for differential expression in ballgown}
\usage{
stattest(
  gown = NULL,
  gowntable = NULL,
  pData = NULL,
  mod = NULL,
  mod0 = NULL,
  feature = c("gene", "exon", "intron", "transcript"),
  meas = c("cov", "FPKM", "rcount", "ucount", "mrcount", "mcov"),
  timecourse = FALSE,
  covariate = NULL,
  adjustvars = NULL,
  gexpr = NULL,
  df = 4,
  getFC = FALSE,
  libadjust = NULL,
  log = TRUE
)
}
\arguments{
\item{gown}{name of an object of class \code{ballgown}}

\item{gowntable}{matrix or matrix-like object with \code{rownames} 
representing feature IDs and columns representing samples, with expression
estimates in the cells. Provide the feature name with \code{feature}. You
must provide exactly one of \code{gown} or \code{gowntable}. NB: gowntable
is log-transformed within \code{stattest} if \code{log} is \code{TRUE}, so
provide un-logged expression values in \code{gowntable}.}

\item{pData}{Required if \code{gowntable} is provided: data frame giving
phenotype data for the samples in the columns of \code{gowntable}. (Rows of
\code{pData} correspond to columns of \code{gowntable}). If \code{gown} is
used instead, it must have a non-null, valid \code{pData} slot (and the 
\code{pData} argument to \code{stattest} should be left \code{NULL}).}

\item{mod}{object of class \code{model.matrix} representing the design matrix
for the linear regression model including covariates of interest}

\item{mod0}{object of class \code{model.matrix} representing the design 
matrix for the linear regression model without the covariates of interest.}

\item{feature}{the type of genomic feature to be tested for differential 
expression. If \code{gown} is used, must be one of \code{"gene"}, 
\code{"transcript"}, \code{"exon"}, or \code{"intron"}. If \code{gowntable}
is used, this is just used for labeling and can be whatever the rows of 
\code{gowntable} represent.}

\item{meas}{the expression measurement to use for statistical tests.  Must be
one of \code{"cov"}, \code{"FPKM"}, \code{"rcount"}, \code{"ucount"}, 
\code{"mrcount"}, or \code{"mcov"}. Not all expression measurements are 
available for all features. Leave as default if \code{gowntable} is 
provided.}

\item{timecourse}{if \code{TRUE}, tests whether or not the expression 
profiles of genomic features vary over time (or another continuous 
covariate) in the study.  Default \code{FALSE}.  Natural splines are used
to fit time profiles, so you must have more timepoints than degrees of 
freedom used to fit the splines. The default df is 4.}

\item{covariate}{string representing the name of the covariate of interest 
for the differential expression tests.  Must correspond to the name of a 
column of \code{pData(gown)}. If \code{timecourse=TRUE}, this should be the
study's time variable.}

\item{adjustvars}{optional vector of strings representing the names of 
potential confounders.  Must correspond to names of columns of 
\code{pData(gown)}.}

\item{gexpr}{optional data frame that is the result of calling 
\code{gexpr(gown))}.  (You can speed this function up by pre-creating 
\code{gexpr(gown)}.)}

\item{df}{degrees of freedom used for modeling expression over time with 
natural cubic splines.  Default 4.  Only used if \code{timecourse=TRUE}.}

\item{getFC}{if \code{TRUE}, also return estimated fold changes (adjusted for
library size and confounders) between populations. Only available for 
2-group comparisons at the moment. Default \code{FALSE}.}

\item{libadjust}{library-size adjustment to use in linear models. By default,
the adjustment is defined as the sum of the sample's log expression
measurements below the 75th percentile of those measurements. To use 
a different library-size adjustment, provide a numeric vector of each 
sample's adjustment value. Entries of this vector correspond to samples in
in rows of \code{pData}. If no library size adjustment is desired, set to
FALSE.}

\item{log}{if \code{TRUE}, outcome variable in linear models is 
log(expression+1), otherwise it's expression. Default TRUE.}
}
\value{
data frame containing the columns \code{feature}, \code{id} 
  representing feature id, \code{pval} representing the p-value for testing 
  whether this feature was differentially expressed according to 
  \code{covariate}, and \code{qval}, the estimated false discovery rate 
  using this feature's signal strength as a significance cutoff. An 
  additional column, \code{fc}, is included if \code{getFC} is \code{TRUE}.
}
\description{
Test each transcript, gene, exon, or intron in a ballgown object for 
differential expression, using comparisons of linear models.
}
\details{
At minimum, you need to provide a ballgown object or count table, 
  the type of feature you want to test (gene, transcript, exon, or intron), 
  the expression measurement you want to use (FPKM, cov, rcount, etc.), and 
  the covariate of interest, which must be the name of one of the columns of 
  the `pData` component of your ballgown object (or provided pData). This 
  covariate is automatically converted to a factor during model fitting in 
  non-timecourse experiments.

  By default, models are fit using \code{log2(meas + 1)} as the outcome for 
  each feature. To disable the log transformation, provide `log = FALSE` as 
  an argument to `stattest`. You can use the \code{gowntable} option if you'd
  like to to use a different transformation.

  Library size adjustment is performed by default by using the sum of the log
  nonzero expression measurements for each sample, up to the 75th percentile
  of those measurements. This adjustment can be disabled by setting 
  \code{libadjust=FALSE}. You can use \code{mod} and \code{mod0} to specify 
  alternative library size adjustments.

  \code{mod} and \code{mod0} are optional arguments.  If \code{mod} is 
  specified, you must also specify \code{mod0}.  If neither is specified, 
  \code{mod0} defaults to the design matrix for a model including only a 
  library-size adjustment, and \code{mod} defaults to the design matrix for a
  model including a library-size adjustment and \code{covariate}. Note that 
  if you supply \code{mod} and \code{mod0}, \code{covariate}, 
  \code{timecourse}, \code{adjustvars}, and \code{df} are ignored, so make 
  sure your covariate of interest and all appropriate confounder 
  adjustments, including library size, are specified in \code{mod} and 
  \code{mod0}. By default, the library-size adjustment is the sum of all
  counts below the 75th percentile of nonzero counts, on the log scale
  (log2 + 1). 

  Full model details are described in the supplement of 
  \url{http://biorxiv.org/content/early/2014/03/30/003665}.
}
\examples{
data(bg)

# two-group comparison:
stat_results = stattest(bg, feature='transcript', meas='FPKM', 
  covariate='group')

# timecourse test:
pData(bg) = data.frame(pData(bg), time=rep(1:10, 2)) #dummy time covariate
timecourse_results = stattest(bg, feature='transcript', meas='FPKM', 
  covariate='time', timecourse=TRUE)

# timecourse test, adjusting for group:
group_adj_timecourse_results = stattest(bg, feature='transcript', 
  meas='FPKM', covariate='time', timecourse=TRUE, adjustvars='group')

# custom model matrices:
### create example data:
set.seed(43)
sex = sample(c('M','F'), size=nrow(pData(bg)), replace=TRUE)
age = sample(21:52, size=nrow(pData(bg)), replace=TRUE)

### create design matrices:
mod = model.matrix(~ sex + age + pData(bg)$group + pData(bg)$time)
mod0 = model.matrix(~ pData(bg)$group + pData(bg)$time)

### build model: 
adjusted_results = stattest(bg, feature='transcript', meas='FPKM', 
  mod0=mod0, mod=mod)
}
\references{
\url{http://biorxiv.org/content/early/2014/03/30/003665}
}
\author{
Jeff Leek, Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{mergedDate}
\alias{mergedDate}
\alias{mergedDate,ballgown-method}
\title{extract package version & creation date from ballgown object}
\usage{
mergedDate(x)

\S4method{mergedDate}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\description{
extract package version & creation date from ballgown object
}
\examples{
data(bg)
mergedDate(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-expr-methods.R
\docType{methods}
\name{texpr}
\alias{texpr}
\alias{texpr,ballgown-method}
\title{extract transcript-level expression measurements from ballgown objects}
\usage{
texpr(x, meas = "FPKM")

\S4method{texpr}{ballgown}(x, meas = "FPKM")
}
\arguments{
\item{x}{a ballgown object}

\item{meas}{type of measurement to extract. Can be "cov", "FPKM", or "all". 
Default "FPKM".}
}
\value{
transcript-by-sample matrix containing expression values (measured by
  \code{meas}). If \code{meas} is \code{"all"}, a data frame is returned, 
  containing all measurements and location information.
}
\description{
extract transcript-level expression measurements from ballgown objects
}
\examples{
data(bg)
transcript_fpkm_matrix = texpr(bg)
transcript_data_frame = texpr(bg, 'all')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{geneNames}
\alias{geneNames}
\alias{geneNames,ballgown-method}
\title{get gene names from a ballgown object}
\usage{
geneNames(x)

\S4method{geneNames}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
named vector of gene names included in the ballgown object, named
and ordered by corresponding numeric transcript ID.
}
\description{
get gene names from a ballgown object
}
\details{
This vector differs from that produced by geneIDs in that geneNames produces
*annotated* gene names that correspond to assembled transcripts. The
return will be empty/blank/NA if the transcriptome assembly is de novo 
(i.e., was not compared to an annotation before the ballgown object was
created). See \code{\link{getGenes}} for matching transcripts to gene names.
Some entries of this vector will be empty/blank/NA if the corresponding 
transcript did not overlap any annotated genes.
}
\examples{
data(bg)
# this is a de novo assembly, so it does not contain gene info as it stands
# but we can add it:
annot = system.file('extdata', 'annot.gtf.gz', package='ballgown')
gnames = getGenes(annot, structure(bg)$trans, UCSC=FALSE)
gnames_first = lapply(gnames, function(x) x[1]) #just take 1 overlapping gene
expr(bg)$trans$gene_name = gnames_first

# now we can extract these gene names:
geneNames(bg)

}
\seealso{
\code{\link{geneIDs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getGenes.R
\name{getGenes}
\alias{getGenes}
\title{label assembled transcripts with gene names}
\usage{
getGenes(gtf, assembled, UCSC = TRUE, attribute = "gene_id")
}
\arguments{
\item{gtf}{path to a GTF file containing locations of annotated transcripts}

\item{assembled}{GRangesList object, with each set of ranges representing 
exons of an assembled transcript.}

\item{UCSC}{set to \code{TRUE} if you're using a UCSC gtf file. (Requires
some extra text processing).}

\item{attribute}{set to attribute name in \code{gtf} that gives desired gene
identifiers. Default \code{"gene_id"}; another commone one is
\code{"gene_name"} (for the gene symbol).}
}
\value{
an \code{IRanges CharacterList} of the same length as
  \code{assembled}, providing the name(s) of the gene(s) that overlaps each
  transcript in \code{assembled}.
}
\description{
label assembled transcripts with gene names
}
\details{
chromosome labels in \code{gtf} and \code{assembled} should match.
  (i.e., you should provide the path to a gtf corrsponding to the same
  annotation you used when constructing \code{assembled})
}
\examples{
data(bg)
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
geneoverlaps = getGenes(gtfPath, structure(bg)$trans, UCSC=FALSE)
}
\author{
Alyssa Frazee, Andrew Jaffe
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{expr}
\alias{expr}
\alias{expr,ballgown-method}
\title{extract expression components from ballgown objects}
\usage{
expr(x)

\S4method{expr}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
list containing elements \code{intron}, \code{exon}, and 
 \code{trans}, which are feature-by-sample data frames of expression data.
}
\description{
extract expression components from ballgown objects
}
\examples{
data(bg)
names(expr(bg))
class(expr(bg))
dim(expr(bg)$exon)

}
\seealso{
\code{\link{texpr}}, \code{\link{gexpr}}, \code{\link{eexpr}}, 
  \code{\link{iexpr}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pctOverlap.R
\name{pctOverlap}
\alias{pctOverlap}
\title{calculate percent overlap between two GRanges objects}
\usage{
pctOverlap(tx1, tx2)
}
\arguments{
\item{tx1}{GRanges object}

\item{tx2}{GRanges object}
}
\value{
percent overlap between \code{tx1} and \code{tx2}, as defined by the 
  ratio of the intersection of \code{tx1} and \code{tx2} to the union of 
  \code{tx1} and \code{tx2}.
}
\description{
calculate percent overlap between two GRanges objects
}
\details{
In the ballgown context, \code{tx1} and \code{tx2} are two
  transcripts, each represented by GRanges objects whose ranges represent the
  exons comprising the transcripts.  The percent overlap is the number of 
  nucleotides falling within both transcripts divided by the number of 
  nucleotides falling within either transcript.  Useful as a measure of 
  transcript closeness (as it is essentially Jaccard distance).
}
\examples{
data(bg)
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
annot_grl = gffReadGR(gtfPath, splitByTranscript=TRUE)
pctOverlap(structure(bg)$trans[[2]], annot_grl[[369]]) #79.9\%
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-expr-methods.R
\docType{methods}
\name{gexpr}
\alias{gexpr}
\alias{gexpr,ballgown-method}
\title{extract gene-level expression measurements from ballgown objects}
\usage{
gexpr(x)

\S4method{gexpr}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
gene-by-sample matrix containing per-sample gene measurements.
}
\description{
For objects created with Cufflinks/Tablemaker, gene-level measurements are 
  calculated by appropriately combining FPKMs from the transcripts comprising
  the gene. For objects created with RSEM, gene-level measurements are
  extracted directly from the RSEM output.
}
\examples{
data(bg)
gene_matrix = gexpr(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotLatentTranscripts.R
\name{plotLatentTranscripts}
\alias{plotLatentTranscripts}
\title{cluster assembled transcripts and plot the results}
\usage{
plotLatentTranscripts(
  gene,
  gown,
  method = c("hclust", "kmeans"),
  k = NULL,
  choosek = c("var90", "thumb"),
  returncluster = TRUE,
  labelTranscripts = TRUE,
  ...
)
}
\arguments{
\item{gene}{string, name of gene whose transcripts should be clustered 
(e.g., "XLOC_000001")}

\item{gown}{object of class \code{ballgown} being used for analysis}

\item{method}{clustering method to use.  Currently can choose from 
hierarchical clustering (\code{hclust}) or K-means (\code{kmeans}).  More 
methods are in development.}

\item{k}{number of transcripts clusters to use.  By default, \code{k} is 
\code{NULL} and thus is chosen using a rule of thumb, but providing
\code{k} overrides those rules of thumb.}

\item{choosek}{if \code{k} is not provided, how should the number of clusters
be chosen?  Must be one of "var90" (choose a \code{k} that explains 90 
percent of the observed variation) or "thumb" (\code{k} is set to be 
approximately \code{sqrt(n)}, where n is the total number of transcripts 
for \code{gene})}

\item{returncluster}{if TRUE (as it is by default), return the results of the
call to \code{clusterTrancsripts} so the data is available for later use.  
Nothing is returned if FALSE.}

\item{labelTranscripts}{if TRUE (as it is by default), print transcript IDs 
on the y-axis}

\item{...}{other arguments to pass to plotTranscripts}
}
\value{
if \code{returncluster} is TRUE, the transcript clusters are returned
  as described in \code{\link{clusterTranscripts}}. A plot of the transcript 
  clusters is also produced, in the style of \code{\link{plotTranscripts}}.
}
\description{
This is an experimental, first-pass function that clusters assembled 
transcripts based on their overlap percentage, then plots and colors the 
transcript clusters.
}
\examples{
\donttest{
data(bg)
plotLatentTranscripts('XLOC_000454', bg, method='kmeans', k=2)
}
}
\seealso{
\code{\link{clusterTranscripts}}, \code{\link{plotTranscripts}}
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ballgownrsem.R
\name{ballgownrsem}
\alias{ballgownrsem}
\title{load RSEM data into a ballgown object}
\usage{
ballgownrsem(
  dir = "",
  samples,
  gtf,
  UCSC = TRUE,
  tfield = "transcript_id",
  attrsep = "; ",
  bamout = "transcript",
  pData = NULL,
  verbose = TRUE,
  meas = "all",
  zipped = FALSE
)
}
\arguments{
\item{dir}{output directory containing RSEM output for all samples (i.e. for
each run of rsem-calculate-expression)}

\item{samples}{vector of sample names (i.e., of the \code{sample_name}
arguments used in each RSEM run)}

\item{gtf}{path to GTF file of genes/transcripts used in your RSEM reference.
(where the reference location was denoted by the \code{reference_name} 
argument used in rsem-calculate-expression). RSEM references can be created
with or without a GTF file, but currently the ballgown reader requires the 
GTF file.}

\item{UCSC}{set to TRUE if \code{gtf} comes from UCSC: quotes will be
stripped from transcript identifiers if so.}

\item{tfield}{What keyword identifies transcripts in the "attributes" field
of \code{gtf}? Default \code{'transcript_id'}.}

\item{attrsep}{How are attributes separated in the "attributes" field of
\code{gtf}? Default \code{'; '} (semicolon-space).}

\item{bamout}{set to \code{'genome'} if \code{--output-genome-bam} was used
when running rsem-calculate-expression; set to \code{'none'} if 
\code{--no-bam-output} was used when running rsem-calculate-expression; 
otherwise use the default (\code{'transcript'}).}

\item{pData}{data frame of phenotype data, with rows corresponding to
\code{samples}. The first column of \code{pData} must be equal to 
\code{samples}, and rows must be in the same order as \code{samples}.}

\item{verbose}{If TRUE (as by default), status messages are printed during
data loading.}

\item{meas}{character vector containing either "all" or one of "FPKM" or 
"TPM". The resulting ballgown object will only contain the specified
expression measurement for the transcripts. "all" 
creates the full object.}

\item{zipped}{set to TRUE if all RSEM results files have been gzipped (end)
in ".gz").}
}
\value{
a ballgown object with the specified expression measurements and
  structure specified by GTF.
}
\description{
Loads results of rsem-calculate-expression into a ballgown
  object for easy visualization, processing, and statistical testing
}
\details{
Currently exon- and intron-level measurements are not available for
  RSEM-generated ballgown objects, but development is ongoing.
}
\examples{
dataDir = system.file('extdata', package='ballgown')
gtf = file.path(dataDir, 'hg19_genes_small.gtf.gz')
rsemobj = ballgownrsem(dir=dataDir, samples=c('tiny', 'tiny2'), gtf=gtf,
    bamout='none', zipped=TRUE)
rsemobj

}
\seealso{
\code{\link{ballgown}} for reading Cufflinks/Tablemaker output
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{seqnames}
\alias{seqnames}
\alias{seqnames,ballgown-method}
\title{get sequence (chromosome) names from ballgown object}
\usage{
seqnames(x)

\S4method{seqnames}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
vector of sequence (i.e., chromosome) names included in the 
ballgown object
}
\description{
get sequence (chromosome) names from ballgown object
}
\examples{
data(bg)
seqnames(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{indexes}
\alias{indexes}
\alias{indexes,ballgown-method}
\title{extract the indexes from ballgown objects}
\usage{
indexes(x)

\S4method{indexes}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
list containing elements \code{e2t}, \code{i2t}, \code{t2g}, 
 \code{bamfiles}, and \code{pData}, where \code{e2t} and \code{i2t} are data
 frames linking exons and introns (respectively) to transcripts, \code{t2g}
 is a data frame linking transcripts to genes, and \code{bamfiles} and 
 \code{pData} are described in \code{?ballgown}.
}
\description{
extract the indexes from ballgown objects
}
\examples{
data(bg)
names(indexes(bg))
class(indexes(bg))
head(indexes(bg)$t2g)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exprfilter.R
\name{exprfilter}
\alias{exprfilter}
\title{subset ballgown objects using an expression filter}
\usage{
exprfilter(gown, cutoff, meas = "FPKM")
}
\arguments{
\item{gown}{a ballgown object}

\item{cutoff}{transcripts must have mean expression across samples above this
value to be included in the return}

\item{meas}{how should transcript expression be measured? Default FPKM, but 
can also be \code{'cov'}.}
}
\value{
A new ballgown object derived from \code{gown}, but only containing 
  transcripts (and associated exons/introns) with mean \code{meas} greater
  than \code{cutoff} across all samples.
}
\description{
Create a new ballgown object containing only transcripts passing
  a mean expression filter
}
\examples{
  data(bg)
  # make a ballgown object containing only transcripts with mean FPKM > 100:
  over100 = exprfilter(bg, cutoff=100)  

}
\seealso{
\code{\link{subset}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{dirs}
\alias{dirs}
\alias{dirs,ballgown-method}
\title{extract paths to tablemaker output}
\usage{
dirs(x)

\S4method{dirs}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\description{
extract paths to tablemaker output
}
\examples{
data(bg)
dirs(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-subset-method.R
\docType{methods}
\name{subset}
\alias{subset}
\alias{subset,ballgown-method}
\title{subset ballgown objects to specific samples or genomic locations}
\usage{
subset(x, ...)

\S4method{subset}{ballgown}(x, cond, genomesubset = TRUE)
}
\arguments{
\item{x}{a ballgown object}

\item{...}{further arguments to generic subset}

\item{cond}{Condition on which to subset. See details.}

\item{genomesubset}{if TRUE, subset \code{x} to a specific part of the 
genome. Otherwise, subset x to only include specific samples. TRUE by 
default.}
}
\value{
a subsetted ballgown object, containing only the regions or samples
  satisfying \code{cond}.
}
\description{
subset ballgown objects to specific samples or genomic locations
}
\details{
To use \code{subset}, you must provide the \code{cond} argument as a
  string representing a logical expression specifying your desired subset.
  The subset expression can either involve column names of
  \code{texpr(x, "all")} (if \code{genomesubset} is \code{TRUE}) or of 
  \code{pData(x)} (if \code{genomesubset} is \code{FALSE}). For example, if
  you wanted a ballgown object for only chromosome 22, you might call 
  \code{subset(x, "chr == 'chr22'")}. (Be sure to handle quotes within
  character strings appropriately).
}
\examples{
data(bg)
bg_twogenes = subset(bg, "gene_id=='XLOC_000454' | gene_id=='XLOC_000024'")
bg_twogenes 
# ballgown instance with 4 assembled transcripts and 20 samples

bg_group0 = subset(bg, "group == 0", genomesubset=FALSE)
bg_group0 
# ballgown instance with 100 assembled transcripts and 10 samples
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{transcriptIDs}
\alias{transcriptIDs}
\alias{transcriptIDs,ballgown-method}
\title{get numeric transcript IDs from a ballgown object}
\usage{
transcriptIDs(x)

\S4method{transcriptIDs}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
vector of numeric transcript IDs included in the ballgown object
}
\description{
get numeric transcript IDs from a ballgown object
}
\examples{
data(bg)
transcriptIDs(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/collapseTranscripts.R
\name{collapseTranscripts}
\alias{collapseTranscripts}
\title{cluster a gene's transcripts and calculate cluster-level expression}
\usage{
collapseTranscripts(
  gene,
  gown,
  meas = "FPKM",
  method = c("hclust", "kmeans"),
  k = NULL
)
}
\arguments{
\item{gene}{which gene's transcripts should be clustered}

\item{gown}{ballgown object}

\item{meas}{which transcript-level expression measurement to use 
(\code{'cov'}, average per-base coverage, or \code{'FPKM'})}

\item{method}{which clustering method to use: \code{'hclust'} (hierarchical
clustering) or \code{'kmeans'} (k-means clustering).}

\item{k}{how many clusters to use.}
}
\value{
list with two elements:
\itemize{
  \item \code{tab}, a cluster-by-sample table of expression measurements
    (\code{meas}, either cov or FPKM), where the expression measurement for 
    each cluster is the mean (for \code{'cov'}) or aggregate (for 
    \code{'FPKM'}, as in \code{\link{gexpr}}) expression measurement for all
    the transcripts in that cluster. This table can be used as the 
    \code{gowntable} argument to \code{\link{stattest}}, if differential
    expression results for transcript *clusters* are desired. 
  \item \code{cl} output from \code{\link{clusterTranscripts}} that was run 
    to produce \code{tab}, for reference. Cluster IDs in the \code{cluster} 
    component correspond to row names of \code{tab}
}
}
\description{
cluster a gene's transcripts and calculate cluster-level expression
}
\examples{
data(bg)
collapseTranscripts(bg, gene='XLOC_000454', meas='FPKM', method='kmeans')

}
\seealso{
\code{\link{hclust}}, \code{\link{kmeans}}, 
   \code{\link{clusterTranscripts}}, \code{\link{plotLatentTranscripts}}
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-replace-methods.R
\docType{methods}
\name{pData<-}
\alias{pData<-}
\alias{pData<-,ballgown,ANY-method}
\title{Replacement method for pData slot in ballgown objects}
\usage{
pData(object) <- value

\S4method{pData}{ballgown,ANY}(object) <- value
}
\arguments{
\item{object}{a ballgown object}

\item{value}{the updated value for \code{pData(x)}.}
}
\description{
Replacement method for pData slot in ballgown objects
}
\examples{
# add "timepoint" covariate to ballgown object:
data(bg) # already contains pData
pData(bg) = data.frame(pData(bg), timepoint=rep(1:10, 2))
head(pData(bg))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{structure}
\alias{structure}
\alias{structure,ballgown-method}
\title{extract structure components from ballgown objects}
\usage{
structure(x)

\S4method{structure}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
list containing elements \code{intron}, \code{exon}, and 
 \code{trans}. \code{exon} and \code{intron} are \code{GRanges} objects,
 where each range is an exon or intron, and \code{trans} is a
 \code{GRangesList} object, where each \code{GRanges} element is a set of 
 exons representing a transcript.
}
\description{
extract structure components from ballgown objects
}
\examples{
data(bg)
names(structure(bg))
class(structure(bg))
structure(bg)$exon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-expr-methods.R
\docType{methods}
\name{eexpr}
\alias{eexpr}
\alias{eexpr,ballgown-method}
\title{extract exon-level expression measurements from ballgown objects}
\usage{
eexpr(x, meas = "rcount")

\S4method{eexpr}{ballgown}(x, meas = "rcount")
}
\arguments{
\item{x}{a ballgown object}

\item{meas}{type of measurement to extract. Can be "rcount", "ucount", 
"mrcount", "cov", "mcov", or "all". Default "rcount".}
}
\value{
exon-by-sample matrix containing exon-level expression values
  (measured by \code{meas}). If \code{meas} is \code{"all"}, or 
  \code{x@RSEM} is TRUE, a data frame is returned, containing all
  measurements and location information.
}
\description{
extract exon-level expression measurements from ballgown objects
}
\examples{
data(bg)
exon_rcount_matrix = eexpr(bg)
exon_ucount_matrix = eexpr(bg, 'ucount')
exon_data_frame = eexpr(bg, 'all')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/writeFiles.R
\name{writeFiles}
\alias{writeFiles}
\title{write files to disk from ballgown object}
\usage{
writeFiles(gown, dataDir)
}
\arguments{
\item{gown}{ballgown object}

\item{dataDir}{top-level directory for sample-specific folders}
}
\description{
create tablemaker-like files on disk from a ballgown object
}
\examples{
\donttest{
  data(bg)
  writeFiles(bg, dataDir=getwd())
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-replace-methods.R
\docType{methods}
\name{indexes<-}
\alias{indexes<-}
\alias{indexes<-,ballgown-method}
\title{Replace method for indexes slot in ballgown objects}
\usage{
indexes(x) <- value

\S4method{indexes}{ballgown}(x) <- value
}
\arguments{
\item{x}{a ballgown object}

\item{value}{the updated value for \code{indexes(x)} or a subcomponent}
}
\description{
Replace method for indexes slot in ballgown objects
}
\examples{
data(bg)
indexes(bg)$bamfiles = paste0('/path/to/bamfolder/', 
  sampleNames(bg), '_accepted_hits.bam')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotTranscripts.R
\name{plotTranscripts}
\alias{plotTranscripts}
\title{visualize structure of assembled transcripts}
\usage{
plotTranscripts(
  gene,
  gown,
  samples = NULL,
  colorby = "transcript",
  meas = "FPKM",
  legend = TRUE,
  labelTranscripts = FALSE,
  main = NULL,
  blackBorders = TRUE,
  log = FALSE,
  logbase = 2,
  customCol = NULL,
  customOrder = NULL
)
}
\arguments{
\item{gene}{name of gene whose transcripts will be plotted.  When using 
Cufflinks output, usually of the form \code{"XLOC_######"}}

\item{gown}{ballgown object containing experimental and phenotype data}

\item{samples}{vector of sample(s) to plot. Can be \code{'none'} if only one 
plot (showing transcript structure in gray) is desired. Use 
\code{sampleNames(gown)} to see sample names for \code{gown}. Defaults to 
\code{sampleNames(gown)[1]}.}

\item{colorby}{one of \code{"transcript"}, \code{"exon"}, or \code{"none"}, 
indicating which feature's abundances should dictate plot coloring.  If 
\code{"none"}, all transcripts are drawn in gray.}

\item{meas}{which expression measurement to color features by, if any. Must 
match an available measurement for whatever feature you're plotting.}

\item{legend}{if \code{TRUE} (as it is by default), a color legend is drawn
on top of the plot indicating scales for feature abundances.}

\item{labelTranscripts}{if \code{TRUE}, transcript ids are labeled on the 
left side of the plot. Default \code{FALSE}.}

\item{main}{optional string giving the desired plot title.}

\item{blackBorders}{if \code{TRUE}, exon borders are drawn in black. 
Otherwise, they are drawn in the same color as their transcript or exon. 
Switching blackBorders to FALSE can be useful for visualizing abundances 
for skinny exons and/or smaller plots, which can be the case when 
\code{length(samples)} is large.}

\item{log}{if \code{TRUE}, color transcripts on the log scale. Default 
\code{FALSE}. To account for expression values of 0, we add 1 to all 
expression values before taking the log.}

\item{logbase}{log base to use if \code{log = TRUE}. Default 2.}

\item{customCol}{an optional vector of custom colors to color transcripts by.
There must be the same number of colors as transcripts in the gene being 
plotted.}

\item{customOrder}{an optional vector of transcript ids (matching ids in 
\code{texpr(gown, 'all')$t_id}), indicating which order transcripts will 
appear in the plot. All transcripts in \code{gene} must appear in the 
vector exactly once.}
}
\value{
produces a plot of the transcript structure for the specified gene in
  the current graphics device.
}
\description{
visualize structure of assembled transcripts
}
\examples{
\donttest{
data(bg)

# plot one gene for one sample:
plotTranscripts(gene='XLOC_000454', gown=bg, samples='sample12', meas='FPKM',
    colorby='transcript', 
    main='transcripts from gene XLOC_000454: sample 12, FPKM')

# plot one gene for many samples:
plotTranscripts('XLOC_000454', bg, 
    samples=c('sample01', 'sample06', 'sample12', 'sample19'), 
    meas='FPKM', colorby='transcript')

}
}
\seealso{
\code{\link{plotMeans}}, \code{\link{plotLatentTranscripts}}
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMeans.R
\name{plotMeans}
\alias{plotMeans}
\title{visualize transcript abundance by group}
\usage{
plotMeans(
  gene,
  gown,
  overall = FALSE,
  groupvar,
  groupname = "all",
  meas = c("cov", "FPKM", "rcount", "ucount", "mrcount", "mcov"),
  colorby = c("transcript", "exon"),
  legend = TRUE,
  labelTranscripts = FALSE
)
}
\arguments{
\item{gene}{name of gene whose transcripts will be plotted.  When using
Cufflinks/Tablemaker output, usually of the form \code{"XLOC_######"}}

\item{gown}{ballgown object containing experimental and phenotype data}

\item{overall}{if \code{TRUE}, color features by the overall
(experiment-wide) mean rather than a group-specific mean}

\item{groupvar}{string representing the name of the variable denoting which
sample belongs to which group.  Can be \code{"none"} (if you want the
study-wide mean), or must correspond to the name of a column of
\code{pData(gown)}.  Usually a categorical variable.}

\item{groupname}{string representing which group's expression means you want
to plot.  Can be \code{"none"} (if you want the study-wide mean),
\code{"all"} (if you want a multipanel plot of each group's mean
expression), or any of the levels of \code{groupvar}.}

\item{meas}{type of expression measurement to plot. One of "cov", "FPKM",
"rcount", "ucount", "mrcount", or "mcov". Not all types are valid for all
features. (See description of tablemaker output for more information).}

\item{colorby}{one of \code{"transcript"} or \code{"exon"}, indicating which
feature's abundances should dictate plot coloring.}

\item{legend}{if \code{TRUE} (as it is by default), a color legend is drawn
on top of the plot indicating the scale for feature abundances.}

\item{labelTranscripts}{if \code{TRUE}, transcript ids are labeled on the
left side of the plot. Default \code{FALSE}.}
}
\value{
produces a plot of the transcript structure for the specified gene in
  the current graphics device, colored by study-wide or group-specific mean
  expression level.
}
\description{
visualize transcript abundance by group
}
\examples{
\donttest{
data(bg)
plotMeans('XLOC_000454', bg, groupvar='group', meas='FPKM',
  colorby='transcript')
}
}
\seealso{
\code{\link{plotTranscripts}}
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/contains.R
\name{contains}
\alias{contains}
\title{determine if one set of GRanges fully contains any of another set of GRanges}
\usage{
contains(transcripts, cds)
}
\arguments{
\item{transcripts}{\code{GRangesList} object (assume for now that it
represents transcripts)}

\item{cds}{\code{GRangesList} object (assume for now that it represents sets
of coding sequences)}
}
\value{
vector with length equal to \code{length(transcripts)}, where each
   entry is \code{TRUE} if the corresponding transcript contains a coding
   sequence (i.e., is a superset of at least one entry of \code{cds}).
}
\description{
determine if one set of GRanges fully contains any of another set of GRanges
}
\details{
If \code{gown} is a \code{ballgown} object, \code{transcripts} can
   be \code{structure(gown)$trans} (or any subset).
}
\examples{
## pretend this annotation is coding sequence:
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
annot = gffReadGR(gtfPath, splitByTranscript=TRUE)
data(bg)
results = contains(structure(bg)$trans, annot)
# results is a boolean vector
sum(results) #61
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bg-data.R
\docType{data}
\name{bg}
\alias{bg}
\title{Toy ballgown object}
\format{
a \code{ballgown} object: 100 transcripts, 633 exons, 536 introns
}
\description{
Small ballgown object created with simulated toy data, for
  demonstration purposes
}
\examples{
data(bg)
bg
# ballgown instance with 100 transcripts and 20 samples
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/checkAssembledTx.R
\name{checkAssembledTx}
\alias{checkAssembledTx}
\title{plot annotated and assembled transcripts together}
\usage{
checkAssembledTx(
  assembled,
  annotated,
  ind = 1,
  main = "Assembled and Annotated Transcripts",
  customCol = NULL
)
}
\arguments{
\item{assembled}{a GRangesList object where the GRanges objects in the list 
represent sets of exons comprising assembled transcripts}

\item{annotated}{a GRangesList object where the GRanges objects in the list
  represent sets of 
exons comprising annotated transcripts}

\item{ind}{integer; index of \code{annotated} specifying which annotated 
transcript to plot.  All transcripts (assembled and annotated) overlapping
\code{annotated[[ind]]} will be plotted. Default 1.}

\item{main}{optional character string giving the title for the resulting
plot.  Default: "Assembled and Annotated Transcripts"}

\item{customCol}{optional vector of custom colors for the annotated
transcripts. If not the same length as the number of annotated transcripts
in the plot, recycling or truncation might occur.}
}
\value{
Plots annotated transcripts on the bottom panel (shaded in gray) and
  assembled transcripts on the top panel (shaded with diagonal lines).
}
\description{
plot annotated and assembled transcripts together
}
\examples{
\donttest{
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
annot = gffReadGR(gtfPath, splitByTranscript=TRUE)
data(bg)
checkAssembledTx(annotated=annot, assembled=structure(bg)$trans, ind=4)
}
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tGene.R
\name{tGene}
\alias{tGene}
\title{Connect a transcript to its gene}
\usage{
tGene(bg, transcript, tid = TRUE, gid = TRUE, warnme = TRUE)
}
\arguments{
\item{bg}{ballgown object}

\item{transcript}{transcript identifier}

\item{tid}{set to \code{TRUE} if \code{transcript} is a numeric transcript
identifier (i.e., \code{t_id} in expression tables), or \code{FALSE} if
\code{transcript} is a named identifie (e.g., \code{TCONS_000001} or
similar.}

\item{gid}{if \code{FALSE}, return the gene *name* associated with
\code{transcript} in \code{bg} instead of the gene *id*, which is returned
by default. Take care to remember that not all ballgown objects include
gene *name* information. (They do all include gene IDs).}

\item{warnme}{if \code{TRUE}, and if \code{gid} is \code{FALSE}, print a
warning if no gene name is available for the transcript. This could either
mean the transcript didn't overlap an annotated gene, or that no gene names
were included when \code{bg} was created.}
}
\description{
find the gene to which a transcript belongs
}
\examples{
  data(bg)
  tGene(bg, 10)
  tGene(bg, 'TCONS_00000010', tid=FALSE)
  tGene(bg, 10, gid=FALSE) #empty: no gene names included in bg.

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/annotate_assembly.R
\name{annotate_assembly}
\alias{annotate_assembly}
\title{match assembled transcripts to annotated transcripts}
\usage{
annotate_assembly(assembled, annotated)
}
\arguments{
\item{assembled}{\code{GRangesList} object representing assembled transcripts}

\item{annotated}{\code{GRangesList} object representing annotated transcripts}
}
\value{
data frame, where each row contains \code{assembledInd} and 
  \code{annotatedInd} (indexes of overlapping transcripts in \code{assembled}
  and \code{annotated}), and the percent overlap between the two transcripts.
}
\description{
match assembled transcripts to annotated transcripts
}
\details{
If \code{gown} is a \code{ballgown} object, \code{assembled} can be 
  \code{structure(gown)$trans} (or any subset). You can generate a 
  \code{GRangesList} object 
containing annotated transcripts from a gtf file using the 
  \code{\link{gffReadGR}} function and 
setting \code{splitByTranscripts=TRUE}.
}
\examples{
data(bg)
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
annot = gffReadGR(gtfPath, splitByTranscript=TRUE)
info = annotate_assembly(assembled=structure(bg)$trans, annotated=annot)
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gffRead.R
\name{gffRead}
\alias{gffRead}
\title{read in GTF/GFF file as a data frame}
\usage{
gffRead(gffFile, nrows = -1, verbose = FALSE)
}
\arguments{
\item{gffFile}{name of GTF/GFF on disk}

\item{nrows}{number of rows to read in (default -1, which means read all 
rows)}

\item{verbose}{if TRUE, print status info at beginning and end of file read.
Default FALSE.}
}
\value{
data frame representing the GTF/GFF file
}
\description{
read in GTF/GFF file as a data frame
}
\examples{
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
annot = gffRead(gtfPath)
}
\seealso{
\code{\link{getAttributeField}} to extract data from "attributes" 
 column; \url{http://useast.ensembl.org/info/website/upload/gff.html} for
  more information on the GTF/GFF file format.
}
\author{
Kasper Hansen
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClass.R
\docType{class}
\name{ballgown-class}
\alias{ballgown-class}
\alias{Ballgown}
\title{Ballgown}
\description{
S4 class for storing and manipulating expression data from assembled
transcriptomes
}
\section{Slots}{

\describe{
\item{\code{expr}}{tables containing expression data for genomic features (introns,
exons, transcripts)}

\item{\code{structure}}{genomic locations of features and their relationships to one
another}

\item{\code{indexes}}{tables connecting components of the assembly and providing
  other experimental
information (e.g., phenotype data and locations of read alignment files)}

\item{\code{dirs}}{directories holding data created by \code{tablemaker}}

\item{\code{mergedDate}}{date the ballgown object was created}

\item{\code{meas}}{which expression measurement(s) the object contains in its data
slot. Vector of one or more of "rcount", "ucount", "mrcount", "cov",
"cov_sd", "mcov", "mcov_sd", or "FPKM", if Tablemaker output is used, or
one of "TPM" or "FPKM" if RSEM output is used. Can also be "all" for all
measurements. See vignette for details.}

\item{\code{RSEM}}{TRUE if object was made from RSEM output, FALSE if object was made
from Tablemaker/Cufflinks output.}
}}

\examples{
  data(bg)
  class(bg) #"ballgown"
  dim(bg@expr$exon)
  bg@structure$exon
  head(bg@indexes$t2g)
  head(bg@dirs)
  bg@mergedDate
  bg@meas
  bg@RSEM
}
\author{
Alyssa Frazee, Leonardo Collado-Torres, Jeff Leek
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{transcriptNames}
\alias{transcriptNames}
\alias{transcriptNames,ballgown-method}
\title{get transcript names from a ballgown object}
\usage{
transcriptNames(x)

\S4method{transcriptNames}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
vector of transcript names included in the ballgown object. If object
was created using Cufflinks/Tablemaker, these transcript names will be of the
form "TCONS_*". Return vector is named and ordered by corresponding numeric
transcript ID.
}
\description{
get transcript names from a ballgown object
}
\examples{
data(bg)
transcriptNames(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-replace-methods.R
\docType{methods}
\name{expr<-}
\alias{expr<-}
\alias{expr<-,ballgown-method}
\title{Replacement method for expr slot in ballgown objects}
\usage{
expr(x) <- value

\S4method{expr}{ballgown}(x) <- value
}
\arguments{
\item{x}{a ballgown object}

\item{value}{the updated value for \code{expr(x)} or a subcomponent}
}
\description{
Replacement method for expr slot in ballgown objects
}
\examples{
data(bg)
n = ncol(bg@expr$trans)
#multiply all transcript expression measurements by 10:
bg@expr$trans[,11:n] = 10*bg@expr$trans[11:n] 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getAttributeField.R
\name{getAttributeField}
\alias{getAttributeField}
\title{extract a specific field of the "attributes" column of a data frame created 
from a GTF/GFF file}
\usage{
getAttributeField(x, field, attrsep = "; ")
}
\arguments{
\item{x}{vector representing the "attributes" column of GTF/GFF file}

\item{field}{name of the field you want to extract from the "attributes" 
column}

\item{attrsep}{separator for the fields in the attributes column.  Defaults
to '; ', the separator for GTF files outputted by Cufflinks.}
}
\value{
vector of nucleotide positions included in the transcript
}
\description{
extract a specific field of the "attributes" column of a data frame created 
from a GTF/GFF file
}
\examples{
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')
gffdata = gffRead(gtfPath)
gffdata$transcriptID = getAttributeField(gffdata$attributes, 
  field = "transcript_id")
}
\seealso{
\code{\link{gffRead}} for creating a data frame from a GTF/GFF file,
  and \url{http://useast.ensembl.org/info/website/upload/gff.html} for
  specifics of the GFF/GTF file format.
}
\author{
Wolfgang Huber, in the \code{davidTiling} R package (LGPL license)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gffReadGR.R
\name{gffReadGR}
\alias{gffReadGR}
\title{read in gtf file as GRanges object}
\usage{
gffReadGR(
  gtf,
  splitByTranscript = FALSE,
  identifier = "transcript_id",
  sep = "; "
)
}
\arguments{
\item{gtf}{name of GTF/GFF file on disk}

\item{splitByTranscript}{if \code{TRUE}, return a \code{GRangesList} of
transcripts; otherwise return a \code{GRanges} object containing all
genomic features in \code{gtf}. Default \code{FALSE}.}

\item{identifier}{name of transcript identifier column of \code{attributes}
field in \code{gtf}. Default \code{"transcript_id"}. Only used if
\code{splitByTranscript} is \code{TRUE}.}

\item{sep}{field separator in the \code{attributes} field of \code{gtf}. 
Default \code{"; "} (semicolon + space). Only used if 
\code{splitByTranscript} is \code{TRUE}.}
}
\value{
if \code{splitByTranscript} is \code{FALSE}, an object of class 
   \code{GRanges} representing the genomic features in \code{gtf}. If 
   \code{splitByTranscript} is TRUE, an object of class \code{GRangesList}, 
   where each element is a \code{GRanges} object corresponding to an 
   annotated transcript (designated in \code{names}).
}
\description{
(very) light wrapper for rtracklayer::import
}
\examples{
gtfPath = system.file('extdata', 'annot.gtf.gz', package='ballgown')

# read in exons as GRanges:
annotgr = gffReadGR(gtfPath)

# read in groups of exons as transcripts, in GRangesList:
transcripts_grl = gffReadGR(gtfPath, splitByTranscript=TRUE)

}
\seealso{
\code{\link{gffRead}} for reading in a GTF file as a data frame
   rather than a \code{GRanges}/\code{GRangesList} object.
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-expr-methods.R
\docType{methods}
\name{iexpr}
\alias{iexpr}
\alias{iexpr,ballgown-method}
\title{extract transcript-level expression measurements from ballgown objects}
\usage{
iexpr(x, meas = "rcount")

\S4method{iexpr}{ballgown}(x, meas = "rcount")
}
\arguments{
\item{x}{a ballgown object}

\item{meas}{type of measurement to extract. Can be "rcount", "ucount", 
"mrcount", or "all". Default "rcount".}
}
\value{
intron-by-sample matrix containing the number of reads (measured as
  specified by \code{meas}) supporting each intron, in each sample. If
  \code{meas} is \code{"all"}, a data frame is returned, containing all
  measurements and location information.
}
\description{
extract transcript-level expression measurements from ballgown objects
}
\examples{
data(bg)
intron_rcount_matrix = iexpr(bg)
intron_data_frame = iexpr(bg, 'all')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/last.R
\name{last}
\alias{last}
\title{get the last element}
\usage{
last(x)
}
\arguments{
\item{x}{anything you can call \code{tail} on (vector, data frame, etc.)}
}
\value{
the last element of \code{x}
}
\description{
get the last element
}
\details{
this function is made of several thousand lines of complex code,
   so be sure to read it carefully.
}
\examples{
last(c('h', 'e', 'l', 'l', 'o'))
}
\author{
Alyssa Frazee
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{sampleNames}
\alias{sampleNames}
\alias{sampleNames,ballgown-method}
\title{get names of samples in a ballgown objects}
\usage{
sampleNames(object)

\S4method{sampleNames}{ballgown}(object)
}
\arguments{
\item{object}{a ballgown object}
}
\value{
vector of sample IDs for \code{x}. If \code{pData} exists, samples in
its rows correspond to samples in \code{sampleNames(x)} (in order).
}
\description{
get names of samples in a ballgown objects
}
\examples{
data(bg)
sampleNames(bg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ballgown-package.R
\docType{package}
\name{ballgown-package}
\alias{ballgown-package}
\alias{ballgownp}
\title{The ballgown package for analysis of transcript assemblies}
\description{
Super awesome transcript-level expression analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/ballgown-get-methods.R
\docType{methods}
\name{geneIDs}
\alias{geneIDs}
\alias{geneIDs,ballgown-method}
\title{get gene IDs from a ballgown object}
\usage{
geneIDs(x)

\S4method{geneIDs}{ballgown}(x)
}
\arguments{
\item{x}{a ballgown object}
}
\value{
named vector of gene IDs included in the ballgown object. If object 
was created using Tablemaker, these gene IDs will be of the form "XLOC_*".
Vector is named and ordered by corresponding numeric transcript ID.
}
\description{
get gene IDs from a ballgown object
}
\details{
This vector differs from that produced by geneNames in that geneIDs produces
names of loci created during the assembly process, not necessarily
annotated genes.
}
\examples{
data(bg)
geneIDs(bg)
}
\seealso{
\code{\link{geneNames}}
}
